#!/usr/bin/python3
import sys
import os
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtWidgets import QMainWindow, QPushButton, QApplication, QMessageBox
from PyQt5.QtGui import QFont
import codecs
import shutil
import subprocess
import urllib.request
import json
import datetime
import zipfile
import glob
#------Logger----
import math
import threading
import re
try:
    import serial
except:
    pass
try:
    import pyproj
except:
    pass
import socket
from contextlib import closing
#----------------
import tkinter
from tkinter import filedialog as tkFileDialog
import webbrowser

root = tkinter.Tk()
root.withdraw()

global firstFixFlag

class Dialog(QMainWindow):
    def __init__(self):
        super().__init__()
        self.initUI()

    def initUI(self):
# ui_dialog3.pyより--------------------------------------------------------------------------------------------------------
        self.setObjectName("self")
        self.setEnabled(True)
        self.resize(565, 372)
        self.setMinimumSize(QtCore.QSize(565, 372))
        self.setMaximumSize(QtCore.QSize(565, 452))
        self.tabWidget = QtWidgets.QTabWidget(self)
        self.tabWidget.setEnabled(True)
        self.tabWidget.setGeometry(QtCore.QRect(0, 0, 566, 375))
        self.tabWidget.setMinimumSize(QtCore.QSize(0, 285))
        self.tabWidget.setMaximumSize(QtCore.QSize(16777215, 500))
        self.tabWidget.setFocusPolicy(QtCore.Qt.StrongFocus)
        self.tabWidget.setObjectName("tabWidget")
        self.tab = QtWidgets.QWidget()
        self.tab.setObjectName("tab")
        self.groupBox1 = QtWidgets.QGroupBox(self.tab)
        self.groupBox1.setEnabled(True)
        self.groupBox1.setGeometry(QtCore.QRect(10, 3, 261, 310))
        self.groupBox1.setObjectName("groupBox1")
        self.label_6 = QtWidgets.QLabel(self.groupBox1)
        self.label_6.setGeometry(QtCore.QRect(10, 80, 61, 21))
        self.label_6.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_6.setObjectName("label_6")
        self.combo_baudrate = QtWidgets.QComboBox(self.groupBox1)
        self.combo_baudrate.setGeometry(QtCore.QRect(80, 50, 171, 22))
        self.combo_baudrate.setObjectName("combo_baudrate")
        self.combo_port = QtWidgets.QComboBox(self.groupBox1)
        self.combo_port.setGeometry(QtCore.QRect(80, 20, 171, 22))
        self.combo_port.setObjectName("combo_port")
        self.label_5 = QtWidgets.QLabel(self.groupBox1)
        self.label_5.setGeometry(QtCore.QRect(10, 50, 61, 21))
        self.label_5.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_5.setObjectName("label_5")
        self.combo_ByteSize = QtWidgets.QComboBox(self.groupBox1)
        self.combo_ByteSize.setGeometry(QtCore.QRect(80, 80, 171, 20))
        self.combo_ByteSize.setObjectName("combo_ByteSize")
        self.label = QtWidgets.QLabel(self.groupBox1)
        self.label.setGeometry(QtCore.QRect(10, 20, 61, 20))
        self.label.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label.setObjectName("label")
        self.combo_Parity = QtWidgets.QComboBox(self.groupBox1)
        self.combo_Parity.setGeometry(QtCore.QRect(80, 110, 171, 22))
        self.combo_Parity.setObjectName("combo_Parity")
        self.label_7 = QtWidgets.QLabel(self.groupBox1)
        self.label_7.setGeometry(QtCore.QRect(10, 112, 61, 16))
        self.label_7.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_7.setObjectName("label_7")
        self.combo_StopBits = QtWidgets.QComboBox(self.groupBox1)
        self.combo_StopBits.setGeometry(QtCore.QRect(80, 140, 171, 22))
        self.combo_StopBits.setObjectName("combo_StopBits")
        self.label_8 = QtWidgets.QLabel(self.groupBox1)
        self.label_8.setGeometry(QtCore.QRect(10, 140, 61, 21))
        self.label_8.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_8.setObjectName("label_8")
        self.label_15 = QtWidgets.QLabel(self.groupBox1)
        self.label_15.setGeometry(QtCore.QRect(10, 170, 61, 21))
        self.label_15.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_15.setObjectName("label_15")
        self.combo_FlowControl = QtWidgets.QComboBox(self.groupBox1)
        self.combo_FlowControl.setGeometry(QtCore.QRect(80, 170, 171, 22))
        self.combo_FlowControl.setObjectName("combo_FlowControl")
        self.base_lon = QtWidgets.QLineEdit(self.groupBox1)
        self.base_lon.setGeometry(QtCore.QRect(80, 251, 171, 20))
        self.base_lon.setText("")
        self.base_lon.setAlignment(QtCore.Qt.AlignCenter)
        self.base_lon.setObjectName("base_lon")
        self.base_lat = QtWidgets.QLineEdit(self.groupBox1)
        self.base_lat.setGeometry(QtCore.QRect(80, 222, 171, 20))
        self.base_lat.setText("")
        self.base_lat.setAlignment(QtCore.Qt.AlignCenter)
        self.base_lat.setObjectName("base_lat")
        self.label_78 = QtWidgets.QLabel(self.groupBox1)
        self.label_78.setGeometry(QtCore.QRect(10, 251, 61, 21))
        self.label_78.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_78.setObjectName("label_78")
        self.base_alt = QtWidgets.QLineEdit(self.groupBox1)
        self.base_alt.setGeometry(QtCore.QRect(80, 280, 171, 20))
        self.base_alt.setText("")
        self.base_alt.setAlignment(QtCore.Qt.AlignCenter)
        self.base_alt.setObjectName("base_alt")
        self.label_77 = QtWidgets.QLabel(self.groupBox1)
        self.label_77.setGeometry(QtCore.QRect(10, 222, 61, 21))
        self.label_77.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_77.setObjectName("label_77")
        self.label_79 = QtWidgets.QLabel(self.groupBox1)
        self.label_79.setGeometry(QtCore.QRect(10, 280, 61, 21))
        self.label_79.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_79.setObjectName("label_79")
        self.label_80 = QtWidgets.QLabel(self.groupBox1)
        self.label_80.setGeometry(QtCore.QRect(10, 200, 61, 21))
        self.label_80.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_80.setObjectName("label_80")
        self.save = QtWidgets.QPushButton(self.tab)
        self.save.setEnabled(True)
        self.save.setGeometry(QtCore.QRect(450, 315, 101, 23))
        self.save.setObjectName("save")
        self.combo_sh = QtWidgets.QComboBox(self.tab)
        self.combo_sh.setEnabled(True)
        self.combo_sh.setGeometry(QtCore.QRect(110, 315, 221, 22))
        self.combo_sh.setObjectName("combo_sh")
        self.switch_on = QtWidgets.QPushButton(self.tab)
        self.switch_on.setEnabled(True)
        self.switch_on.setGeometry(QtCore.QRect(340, 315, 101, 22))
        self.switch_on.setMaximumSize(QtCore.QSize(16777215, 16777215))
        self.switch_on.setWhatsThis("")
        self.switch_on.setCheckable(False)
        self.switch_on.setChecked(False)
        self.switch_on.setAutoExclusive(False)
        self.switch_on.setAutoDefault(True)
        self.switch_on.setDefault(False)
        self.switch_on.setObjectName("switch_on")
        self.label_17 = QtWidgets.QLabel(self.tab)
        self.label_17.setEnabled(True)
        self.label_17.setGeometry(QtCore.QRect(10, 317, 101, 20))
        self.label_17.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_17.setObjectName("label_17")
        self.groupBox2 = QtWidgets.QGroupBox(self.tab)
        self.groupBox2.setGeometry(QtCore.QRect(280, 3, 271, 310))
        self.groupBox2.setObjectName("groupBox2")
        self.label_9 = QtWidgets.QLabel(self.groupBox2)
        self.label_9.setGeometry(QtCore.QRect(0, 55, 111, 21))
        self.label_9.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_9.setObjectName("label_9")
        self.label_10 = QtWidgets.QLabel(self.groupBox2)
        self.label_10.setGeometry(QtCore.QRect(0, 35, 111, 21))
        self.label_10.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_10.setObjectName("label_10")
        self.label_11 = QtWidgets.QLabel(self.groupBox2)
        self.label_11.setGeometry(QtCore.QRect(0, 15, 111, 20))
        self.label_11.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_11.setObjectName("label_11")
        self.lineEdit_Host = QtWidgets.QLineEdit(self.groupBox2)
        self.lineEdit_Host.setGeometry(QtCore.QRect(120, 15, 141, 20))
        self.lineEdit_Host.setText("")
        self.lineEdit_Host.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_Host.setObjectName("lineEdit_Host")
        self.lineEdit_Port = QtWidgets.QLineEdit(self.groupBox2)
        self.lineEdit_Port.setGeometry(QtCore.QRect(120, 35, 141, 20))
        self.lineEdit_Port.setText("")
        self.lineEdit_Port.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_Port.setObjectName("lineEdit_Port")
        self.lineEdit_Mountpoint = QtWidgets.QLineEdit(self.groupBox2)
        self.lineEdit_Mountpoint.setGeometry(QtCore.QRect(120, 55, 141, 20))
        self.lineEdit_Mountpoint.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_Mountpoint.setObjectName("lineEdit_Mountpoint")
        self.label_12 = QtWidgets.QLabel(self.groupBox2)
        self.label_12.setGeometry(QtCore.QRect(0, 75, 111, 21))
        self.label_12.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_12.setObjectName("label_12")
        self.lineEdit_ID = QtWidgets.QLineEdit(self.groupBox2)
        self.lineEdit_ID.setGeometry(QtCore.QRect(120, 75, 141, 20))
        self.lineEdit_ID.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_ID.setObjectName("lineEdit_ID")
        self.label_13 = QtWidgets.QLabel(self.groupBox2)
        self.label_13.setGeometry(QtCore.QRect(0, 95, 111, 21))
        self.label_13.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_13.setObjectName("label_13")
        self.lineEdit_Pass = QtWidgets.QLineEdit(self.groupBox2)
        self.lineEdit_Pass.setGeometry(QtCore.QRect(120, 95, 141, 20))
        self.lineEdit_Pass.setText("")
        self.lineEdit_Pass.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_Pass.setObjectName("lineEdit_Pass")
        self.label_76 = QtWidgets.QLabel(self.groupBox2)
        self.label_76.setGeometry(QtCore.QRect(10, 116, 41, 21))
        self.label_76.setObjectName("label_76")
        self.combo_cmd = QtWidgets.QComboBox(self.groupBox2)
        self.combo_cmd.setGeometry(QtCore.QRect(60, 116, 201, 21))
        self.combo_cmd.setEditable(False)
        self.combo_cmd.setObjectName("combo_cmd")
        self.checkBox_String = QtWidgets.QCheckBox(self.groupBox2)
        self.checkBox_String.setGeometry(QtCore.QRect(10, 141, 151, 16))
        self.checkBox_String.setObjectName("checkBox_String")
        self.textEdit_String = QtWidgets.QTextEdit(self.groupBox2)
        self.textEdit_String.setGeometry(QtCore.QRect(10, 161, 251, 61))
        self.textEdit_String.setObjectName("textEdit_String")
        self.sample = QtWidgets.QPushButton(self.groupBox2)
        self.sample.setGeometry(QtCore.QRect(160, 138, 101, 22))
        self.sample.setMaximumSize(QtCore.QSize(16777215, 16777215))
        self.sample.setFocusPolicy(QtCore.Qt.NoFocus)
        self.sample.setWhatsThis("")
        self.sample.setCheckable(False)
        self.sample.setChecked(False)
        self.sample.setAutoExclusive(False)
        self.sample.setAutoDefault(True)
        self.sample.setDefault(False)
        self.sample.setObjectName("sample")
        self.textEdit_msg = QtWidgets.QTextEdit(self.groupBox2)
        self.textEdit_msg.setGeometry(QtCore.QRect(10, 244, 251, 61))
        self.textEdit_msg.setObjectName("textEdit_msg")
        self.checkBox_conv = QtWidgets.QCheckBox(self.groupBox2)
        self.checkBox_conv.setGeometry(QtCore.QRect(10, 225, 111, 16))
        self.checkBox_conv.setObjectName("checkBox_conv")
        self.sample2 = QtWidgets.QPushButton(self.groupBox2)
        self.sample2.setGeometry(QtCore.QRect(160, 222, 101, 22))
        self.sample2.setMaximumSize(QtCore.QSize(16777215, 16777215))
        self.sample2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.sample2.setWhatsThis("")
        self.sample2.setCheckable(False)
        self.sample2.setChecked(False)
        self.sample2.setAutoExclusive(False)
        self.sample2.setAutoDefault(True)
        self.sample2.setDefault(False)
        self.sample2.setObjectName("sample2")
        self.radio_Output1 = QtWidgets.QRadioButton(self.groupBox2)
        self.radio_Output1.setGeometry(QtCore.QRect(60, -1, 101, 16))
        self.radio_Output1.setChecked(True)
        self.radio_Output1.setObjectName("radio_Output1")
        self.radio_Output2 = QtWidgets.QRadioButton(self.groupBox2)
        self.radio_Output2.setGeometry(QtCore.QRect(165, -1, 91, 16))
        self.radio_Output2.setObjectName("radio_Output2")
        self.tabWidget.addTab(self.tab, "")
        self.tab_2 = QtWidgets.QWidget()
        self.tab_2.setObjectName("tab_2")
        self.pushButton1 = QtWidgets.QPushButton(self.tab_2)
        self.pushButton1.setEnabled(True)
        self.pushButton1.setGeometry(QtCore.QRect(364, 315, 91, 23))
        self.pushButton1.setObjectName("pushButton1")
        self.pushButton2 = QtWidgets.QPushButton(self.tab_2)
        self.pushButton2.setEnabled(True)
        self.pushButton2.setGeometry(QtCore.QRect(268, 315, 91, 23))
        self.pushButton2.setCheckable(False)
        self.pushButton2.setObjectName("pushButton2")
        self.pushButton3 = QtWidgets.QPushButton(self.tab_2)
        self.pushButton3.setEnabled(True)
        self.pushButton3.setGeometry(QtCore.QRect(460, 315, 91, 23))
        self.pushButton3.setObjectName("pushButton3")
        self.label_67 = QtWidgets.QLabel(self.tab_2)
        self.label_67.setGeometry(QtCore.QRect(4, 317, 101, 20))
        self.label_67.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_67.setObjectName("label_67")
        self.combo_path = QtWidgets.QComboBox(self.tab_2)
        self.combo_path.setEnabled(True)
        self.combo_path.setGeometry(QtCore.QRect(101, 315, 161, 22))
        self.combo_path.setObjectName("combo_path")
        self.groupBox3 = QtWidgets.QGroupBox(self.tab_2)
        self.groupBox3.setGeometry(QtCore.QRect(0, 0, 561, 311))
        self.groupBox3.setMinimumSize(QtCore.QSize(0, 231))
        self.groupBox3.setMaximumSize(QtCore.QSize(16777215, 500))
        self.groupBox3.setTitle("")
        self.groupBox3.setFlat(True)
        self.groupBox3.setObjectName("groupBox3")
        self.label_27 = QtWidgets.QLabel(self.groupBox3)
        self.label_27.setGeometry(QtCore.QRect(365, 235, 91, 21))
        self.label_27.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_27.setObjectName("label_27")
        self.lineEdit12 = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEdit12.setGeometry(QtCore.QRect(460, 185, 91, 21))
        self.lineEdit12.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit12.setObjectName("lineEdit12")
        self.lineEdit3 = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEdit3.setGeometry(QtCore.QRect(270, 10, 281, 21))
        self.lineEdit3.setObjectName("lineEdit3")
        self.label_18 = QtWidgets.QLabel(self.groupBox3)
        self.label_18.setGeometry(QtCore.QRect(0, 60, 81, 21))
        self.label_18.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_18.setObjectName("label_18")
        self.lineEditL1 = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEditL1.setGeometry(QtCore.QRect(100, 210, 131, 21))
        self.lineEditL1.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.lineEditL1.setObjectName("lineEditL1")
        self.label_16 = QtWidgets.QLabel(self.groupBox3)
        self.label_16.setGeometry(QtCore.QRect(184, 35, 81, 21))
        self.label_16.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_16.setObjectName("label_16")
        self.label_25 = QtWidgets.QLabel(self.groupBox3)
        self.label_25.setGeometry(QtCore.QRect(375, 185, 81, 21))
        self.label_25.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_25.setObjectName("label_25")
        self.label_21 = QtWidgets.QLabel(self.groupBox3)
        self.label_21.setGeometry(QtCore.QRect(0, 135, 81, 21))
        self.label_21.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_21.setObjectName("label_21")
        self.label_3 = QtWidgets.QLabel(self.groupBox3)
        self.label_3.setGeometry(QtCore.QRect(0, 35, 81, 21))
        self.label_3.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_3.setObjectName("label_3")
        self.label_20 = QtWidgets.QLabel(self.groupBox3)
        self.label_20.setGeometry(QtCore.QRect(366, 60, 91, 21))
        self.label_20.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_20.setObjectName("label_20")
        self.label_26 = QtWidgets.QLabel(self.groupBox3)
        self.label_26.setGeometry(QtCore.QRect(6, 210, 91, 21))
        self.label_26.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_26.setObjectName("label_26")
        self.label_4 = QtWidgets.QLabel(self.groupBox3)
        self.label_4.setGeometry(QtCore.QRect(184, 10, 81, 21))
        self.label_4.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_4.setObjectName("label_4")
        self.label_22 = QtWidgets.QLabel(self.groupBox3)
        self.label_22.setGeometry(QtCore.QRect(0, 160, 81, 21))
        self.label_22.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_22.setObjectName("label_22")
        self.lineEdit4 = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEdit4.setGeometry(QtCore.QRect(270, 35, 281, 21))
        self.lineEdit4.setText("")
        self.lineEdit4.setObjectName("lineEdit4")
        self.label_23 = QtWidgets.QLabel(self.groupBox3)
        self.label_23.setGeometry(QtCore.QRect(0, 185, 81, 21))
        self.label_23.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_23.setObjectName("label_23")
        self.label_19 = QtWidgets.QLabel(self.groupBox3)
        self.label_19.setGeometry(QtCore.QRect(184, 60, 81, 21))
        self.label_19.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_19.setObjectName("label_19")
        self.label_24 = QtWidgets.QLabel(self.groupBox3)
        self.label_24.setGeometry(QtCore.QRect(185, 185, 91, 21))
        self.label_24.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_24.setObjectName("label_24")
        self.label_2 = QtWidgets.QLabel(self.groupBox3)
        self.label_2.setGeometry(QtCore.QRect(0, 10, 81, 21))
        self.label_2.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_2.setObjectName("label_2")
        self.label_34 = QtWidgets.QLabel(self.groupBox3)
        self.label_34.setGeometry(QtCore.QRect(0, 85, 81, 21))
        self.label_34.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_34.setObjectName("label_34")
        self.label_35 = QtWidgets.QLabel(self.groupBox3)
        self.label_35.setGeometry(QtCore.QRect(184, 85, 81, 21))
        self.label_35.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_35.setObjectName("label_35")
        self.label_36 = QtWidgets.QLabel(self.groupBox3)
        self.label_36.setGeometry(QtCore.QRect(0, 110, 81, 21))
        self.label_36.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_36.setObjectName("label_36")
        self.label_37 = QtWidgets.QLabel(self.groupBox3)
        self.label_37.setGeometry(QtCore.QRect(184, 110, 81, 21))
        self.label_37.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_37.setObjectName("label_37")
        self.combo1 = QtWidgets.QComboBox(self.groupBox3)
        self.combo1.setGeometry(QtCore.QRect(85, 10, 91, 21))
        self.combo1.setEditable(False)
        self.combo1.setObjectName("combo1")
        self.combo2 = QtWidgets.QComboBox(self.groupBox3)
        self.combo2.setGeometry(QtCore.QRect(85, 35, 91, 21))
        self.combo2.setEditable(False)
        self.combo2.setObjectName("combo2")
        self.combo5 = QtWidgets.QComboBox(self.groupBox3)
        self.combo5.setGeometry(QtCore.QRect(85, 60, 91, 21))
        self.combo5.setEditable(False)
        self.combo5.setObjectName("combo5")
        self.combo6 = QtWidgets.QComboBox(self.groupBox3)
        self.combo6.setGeometry(QtCore.QRect(270, 60, 91, 21))
        self.combo6.setEditable(False)
        self.combo6.setObjectName("combo6")
        self.combo7 = QtWidgets.QComboBox(self.groupBox3)
        self.combo7.setGeometry(QtCore.QRect(460, 60, 91, 21))
        self.combo7.setEditable(False)
        self.combo7.setObjectName("combo7")
        self.combo21 = QtWidgets.QComboBox(self.groupBox3)
        self.combo21.setGeometry(QtCore.QRect(85, 85, 91, 21))
        self.combo21.setEditable(False)
        self.combo21.setObjectName("combo21")
        self.combo22 = QtWidgets.QComboBox(self.groupBox3)
        self.combo22.setGeometry(QtCore.QRect(270, 85, 91, 21))
        self.combo22.setEditable(False)
        self.combo22.setObjectName("combo22")
        self.combo23 = QtWidgets.QComboBox(self.groupBox3)
        self.combo23.setGeometry(QtCore.QRect(85, 110, 91, 21))
        self.combo23.setEditable(False)
        self.combo23.setObjectName("combo23")
        self.combo24 = QtWidgets.QComboBox(self.groupBox3)
        self.combo24.setGeometry(QtCore.QRect(270, 110, 91, 21))
        self.combo24.setEditable(False)
        self.combo24.setObjectName("combo24")
        self.combo10 = QtWidgets.QComboBox(self.groupBox3)
        self.combo10.setGeometry(QtCore.QRect(85, 185, 91, 21))
        self.combo10.setEditable(False)
        self.combo10.setObjectName("combo10")
        self.combo11 = QtWidgets.QComboBox(self.groupBox3)
        self.combo11.setGeometry(QtCore.QRect(280, 185, 91, 21))
        self.combo11.setEditable(False)
        self.combo11.setObjectName("combo11")
        self.label_81 = QtWidgets.QLabel(self.groupBox3)
        self.label_81.setGeometry(QtCore.QRect(240, 210, 21, 21))
        self.label_81.setAlignment(QtCore.Qt.AlignCenter)
        self.label_81.setObjectName("label_81")
        self.lineEditL2 = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEditL2.setGeometry(QtCore.QRect(260, 210, 131, 21))
        self.lineEditL2.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.lineEditL2.setObjectName("lineEditL2")
        self.lineEditL5 = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEditL5.setGeometry(QtCore.QRect(420, 210, 131, 21))
        self.lineEditL5.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.lineEditL5.setObjectName("lineEditL5")
        self.label_82 = QtWidgets.QLabel(self.groupBox3)
        self.label_82.setGeometry(QtCore.QRect(400, 210, 21, 21))
        self.label_82.setAlignment(QtCore.Qt.AlignCenter)
        self.label_82.setObjectName("label_82")
        self.lineEdit14 = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEdit14.setGeometry(QtCore.QRect(460, 235, 91, 21))
        self.lineEdit14.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit14.setObjectName("lineEdit14")
        self.label_83 = QtWidgets.QLabel(self.groupBox3)
        self.label_83.setGeometry(QtCore.QRect(7, 235, 111, 21))
        self.label_83.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_83.setObjectName("label_83")
        self.combo_Rover = QtWidgets.QComboBox(self.groupBox3)
        self.combo_Rover.setGeometry(QtCore.QRect(125, 235, 91, 21))
        self.combo_Rover.setEditable(False)
        self.combo_Rover.setObjectName("combo_Rover")
        self.combo_Base = QtWidgets.QComboBox(self.groupBox3)
        self.combo_Base.setGeometry(QtCore.QRect(275, 235, 91, 21))
        self.combo_Base.setEditable(False)
        self.combo_Base.setObjectName("combo_Base")
        self.label_92 = QtWidgets.QLabel(self.groupBox3)
        self.label_92.setGeometry(QtCore.QRect(237, 235, 31, 21))
        self.label_92.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_92.setObjectName("label_92")
        self.lineEdit_out1path = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEdit_out1path.setGeometry(QtCore.QRect(85, 135, 181, 21))
        self.lineEdit_out1path.setToolTip("")
        self.lineEdit_out1path.setObjectName("lineEdit_out1path")
        self.lineEdit_out2path = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEdit_out2path.setGeometry(QtCore.QRect(85, 160, 181, 21))
        self.lineEdit_out2path.setToolTip("")
        self.lineEdit_out2path.setObjectName("lineEdit_out2path")
        self.checkBox_mOption = QtWidgets.QCheckBox(self.groupBox3)
        self.checkBox_mOption.setGeometry(QtCore.QRect(370, 87, 81, 16))
        self.checkBox_mOption.setFocusPolicy(QtCore.Qt.NoFocus)
        self.checkBox_mOption.setObjectName("checkBox_mOption")
        self.lineEdit_port = QtWidgets.QLineEdit(self.groupBox3)
        self.lineEdit_port.setEnabled(False)
        self.lineEdit_port.setGeometry(QtCore.QRect(480, 85, 71, 21))
        self.lineEdit_port.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lineEdit_port.setToolTip("")
        self.lineEdit_port.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_port.setObjectName("lineEdit_port")
        self.label_93 = QtWidgets.QLabel(self.groupBox3)
        self.label_93.setGeometry(QtCore.QRect(455, 85, 31, 21))
        self.label_93.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_93.setObjectName("label_93")
        self.combo8 = QtWidgets.QComboBox(self.groupBox3)
        self.combo8.setEnabled(True)
        self.combo8.setGeometry(QtCore.QRect(350, 135, 201, 21))
        self.combo8.setEditable(False)
        self.combo8.setObjectName("combo8")
        self.combo9 = QtWidgets.QComboBox(self.groupBox3)
        self.combo9.setEnabled(True)
        self.combo9.setGeometry(QtCore.QRect(350, 160, 201, 21))
        self.combo9.setEditable(False)
        self.combo9.setObjectName("combo9")
        self.label_94 = QtWidgets.QLabel(self.groupBox3)
        self.label_94.setGeometry(QtCore.QRect(280, 135, 71, 21))
        self.label_94.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_94.setObjectName("label_94")
        self.label_95 = QtWidgets.QLabel(self.groupBox3)
        self.label_95.setGeometry(QtCore.QRect(280, 160, 71, 21))
        self.label_95.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_95.setObjectName("label_95")
        self.lineEdit20 = QtWidgets.QLineEdit(self.tab_2)
        self.lineEdit20.setGeometry(QtCore.QRect(460, 285, 92, 21))
        self.lineEdit20.setText("")
        self.lineEdit20.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit20.setObjectName("lineEdit20")
        self.label_32 = QtWidgets.QLabel(self.tab_2)
        self.label_32.setGeometry(QtCore.QRect(190, 285, 81, 21))
        self.label_32.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_32.setObjectName("label_32")
        self.label_33 = QtWidgets.QLabel(self.tab_2)
        self.label_33.setGeometry(QtCore.QRect(375, 285, 81, 21))
        self.label_33.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_33.setObjectName("label_33")
        self.label_29 = QtWidgets.QLabel(self.tab_2)
        self.label_29.setGeometry(QtCore.QRect(190, 260, 81, 21))
        self.label_29.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_29.setObjectName("label_29")
        self.lineEdit19 = QtWidgets.QLineEdit(self.tab_2)
        self.lineEdit19.setGeometry(QtCore.QRect(275, 285, 92, 21))
        self.lineEdit19.setText("")
        self.lineEdit19.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit19.setObjectName("lineEdit19")
        self.label_28 = QtWidgets.QLabel(self.tab_2)
        self.label_28.setGeometry(QtCore.QRect(0, 260, 81, 21))
        self.label_28.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_28.setObjectName("label_28")
        self.label_31 = QtWidgets.QLabel(self.tab_2)
        self.label_31.setGeometry(QtCore.QRect(0, 285, 81, 21))
        self.label_31.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_31.setObjectName("label_31")
        self.lineEdit18 = QtWidgets.QLineEdit(self.tab_2)
        self.lineEdit18.setGeometry(QtCore.QRect(85, 285, 92, 21))
        self.lineEdit18.setText("")
        self.lineEdit18.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit18.setObjectName("lineEdit18")
        self.label_30 = QtWidgets.QLabel(self.tab_2)
        self.label_30.setGeometry(QtCore.QRect(365, 260, 91, 21))
        self.label_30.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_30.setObjectName("label_30")
        self.combo16 = QtWidgets.QComboBox(self.tab_2)
        self.combo16.setGeometry(QtCore.QRect(275, 260, 91, 21))
        self.combo16.setEditable(False)
        self.combo16.setObjectName("combo16")
        self.lineEdit15 = QtWidgets.QLineEdit(self.tab_2)
        self.lineEdit15.setGeometry(QtCore.QRect(85, 260, 92, 21))
        self.lineEdit15.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit15.setObjectName("lineEdit15")
        self.combo17 = QtWidgets.QComboBox(self.tab_2)
        self.combo17.setGeometry(QtCore.QRect(460, 260, 91, 21))
        self.combo17.setEditable(False)
        self.combo17.setObjectName("combo17")
        self.tabWidget.addTab(self.tab_2, "")
        self.tab_3 = QtWidgets.QWidget()
        self.tab_3.setObjectName("tab_3")
        self.pushButton_read = QtWidgets.QPushButton(self.tab_3)
        self.pushButton_read.setGeometry(QtCore.QRect(450, 28, 101, 23))
        self.pushButton_read.setObjectName("pushButton_read")
        self.label_38 = QtWidgets.QLabel(self.tab_3)
        self.label_38.setGeometry(QtCore.QRect(-5, 230, 61, 20))
        self.label_38.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_38.setObjectName("label_38")
        self.label_39 = QtWidgets.QLabel(self.tab_3)
        self.label_39.setGeometry(QtCore.QRect(-5, 251, 61, 20))
        self.label_39.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_39.setObjectName("label_39")
        self.label_40 = QtWidgets.QLabel(self.tab_3)
        self.label_40.setGeometry(QtCore.QRect(-5, 272, 61, 20))
        self.label_40.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_40.setObjectName("label_40")
        self.label_41 = QtWidgets.QLabel(self.tab_3)
        self.label_41.setGeometry(QtCore.QRect(10, 187, 111, 20))
        self.label_41.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_41.setObjectName("label_41")
        self.label_85 = QtWidgets.QLabel(self.tab_3)
        self.label_85.setGeometry(QtCore.QRect(275, 207, 61, 20))
        self.label_85.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_85.setObjectName("label_85")
        self.label_86 = QtWidgets.QLabel(self.tab_3)
        self.label_86.setGeometry(QtCore.QRect(275, 249, 61, 20))
        self.label_86.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_86.setObjectName("label_86")
        self.label_87 = QtWidgets.QLabel(self.tab_3)
        self.label_87.setGeometry(QtCore.QRect(275, 228, 61, 20))
        self.label_87.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_87.setObjectName("label_87")
        self.label_88 = QtWidgets.QLabel(self.tab_3)
        self.label_88.setGeometry(QtCore.QRect(-5, 292, 61, 20))
        self.label_88.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_88.setObjectName("label_88")
        self.label_89 = QtWidgets.QLabel(self.tab_3)
        self.label_89.setGeometry(QtCore.QRect(275, 270, 61, 20))
        self.label_89.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_89.setObjectName("label_89")
        self.label_90 = QtWidgets.QLabel(self.tab_3)
        self.label_90.setGeometry(QtCore.QRect(275, 291, 61, 20))
        self.label_90.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_90.setObjectName("label_90")
        self.comboBox_kei = QtWidgets.QComboBox(self.tab_3)
        self.comboBox_kei.setGeometry(QtCore.QRect(110, 186, 161, 20))
        self.comboBox_kei.setFocusPolicy(QtCore.Qt.NoFocus)
        self.comboBox_kei.setObjectName("comboBox_kei")
        self.lineEdit_lat = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_lat.setGeometry(QtCore.QRect(60, 229, 211, 20))
        self.lineEdit_lat.setFocusPolicy(QtCore.Qt.WheelFocus)
        self.lineEdit_lat.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_lat.setObjectName("lineEdit_lat")
        self.lineEdit_lng = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_lng.setGeometry(QtCore.QRect(60, 250, 211, 20))
        self.lineEdit_lng.setFocusPolicy(QtCore.Qt.WheelFocus)
        self.lineEdit_lng.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_lng.setObjectName("lineEdit_lng")
        self.lineEdit_h1 = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_h1.setGeometry(QtCore.QRect(60, 271, 211, 20))
        self.lineEdit_h1.setFocusPolicy(QtCore.Qt.WheelFocus)
        self.lineEdit_h1.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_h1.setObjectName("lineEdit_h1")
        self.lineEdit_g = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_g.setGeometry(QtCore.QRect(60, 292, 211, 20))
        self.lineEdit_g.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lineEdit_g.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_g.setObjectName("lineEdit_g")
        self.lineEdit_x = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_x.setGeometry(QtCore.QRect(340, 206, 211, 20))
        self.lineEdit_x.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lineEdit_x.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_x.setObjectName("lineEdit_x")
        self.lineEdit_y = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_y.setGeometry(QtCore.QRect(340, 227, 211, 20))
        self.lineEdit_y.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lineEdit_y.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_y.setObjectName("lineEdit_y")
        self.lineEdit_h2 = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_h2.setGeometry(QtCore.QRect(340, 248, 211, 20))
        self.lineEdit_h2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lineEdit_h2.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_h2.setObjectName("lineEdit_h2")
        self.lineEdit_m = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_m.setGeometry(QtCore.QRect(340, 269, 211, 20))
        self.lineEdit_m.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lineEdit_m.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_m.setObjectName("lineEdit_m")
        self.lineEdit_s = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_s.setGeometry(QtCore.QRect(340, 290, 211, 20))
        self.lineEdit_s.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lineEdit_s.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_s.setObjectName("lineEdit_s")
        self.lineEdit_ratio = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_ratio.setGeometry(QtCore.QRect(151, 5, 41, 20))
        self.lineEdit_ratio.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.lineEdit_ratio.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_ratio.setObjectName("lineEdit_ratio")
        self.label_43 = QtWidgets.QLabel(self.tab_3)
        self.label_43.setGeometry(QtCore.QRect(197, 5, 31, 20))
        self.label_43.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_43.setObjectName("label_43")
        self.radioButton_fix = QtWidgets.QRadioButton(self.tab_3)
        self.radioButton_fix.setGeometry(QtCore.QRect(10, 7, 41, 16))
        self.radioButton_fix.setChecked(True)
        self.radioButton_fix.setObjectName("radioButton_fix")
        self.radioButton_all = QtWidgets.QRadioButton(self.tab_3)
        self.radioButton_all.setGeometry(QtCore.QRect(57, 7, 41, 16))
        self.radioButton_all.setObjectName("radioButton_all")
        self.radioButton_ratio = QtWidgets.QRadioButton(self.tab_3)
        self.radioButton_ratio.setGeometry(QtCore.QRect(100, 7, 51, 16))
        self.radioButton_ratio.setObjectName("radioButton_ratio")
        self.lineEdit_n = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_n.setGeometry(QtCore.QRect(273, 5, 51, 20))
        self.lineEdit_n.setFocusPolicy(QtCore.Qt.NoFocus)
        self.lineEdit_n.setText("")
        self.lineEdit_n.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_n.setObjectName("lineEdit_n")
        self.label_44 = QtWidgets.QLabel(self.tab_3)
        self.label_44.setGeometry(QtCore.QRect(243, 5, 31, 20))
        self.label_44.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_44.setObjectName("label_44")
        self.label_45 = QtWidgets.QLabel(self.tab_3)
        self.label_45.setGeometry(QtCore.QRect(330, 5, 21, 20))
        self.label_45.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_45.setObjectName("label_45")
        self.pushButton_save = QtWidgets.QPushButton(self.tab_3)
        self.pushButton_save.setGeometry(QtCore.QRect(120, 315, 101, 23))
        self.pushButton_save.setObjectName("pushButton_save")
        self.pushButton_SemiDyna = QtWidgets.QPushButton(self.tab_3)
        self.pushButton_SemiDyna.setGeometry(QtCore.QRect(9, 315, 101, 23))
        self.pushButton_SemiDyna.setObjectName("pushButton_SemiDyna")
        self.lineEdit_log = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_log.setGeometry(QtCore.QRect(62, 30, 381, 20))
        self.lineEdit_log.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.lineEdit_log.setToolTip("")
        self.lineEdit_log.setText("")
        self.lineEdit_log.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.lineEdit_log.setObjectName("lineEdit_log")
        self.pushButton_read2 = QtWidgets.QPushButton(self.tab_3)
        self.pushButton_read2.setGeometry(QtCore.QRect(450, 5, 101, 23))
        self.pushButton_read2.setObjectName("pushButton_read2")
        self.label_58 = QtWidgets.QLabel(self.tab_3)
        self.label_58.setGeometry(QtCore.QRect(10, 29, 51, 20))
        self.label_58.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_58.setObjectName("label_58")
        self.lineEdit_ih = QtWidgets.QLineEdit(self.tab_3)
        self.lineEdit_ih.setGeometry(QtCore.QRect(60, 208, 211, 20))
        self.lineEdit_ih.setFocusPolicy(QtCore.Qt.WheelFocus)
        self.lineEdit_ih.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_ih.setObjectName("lineEdit_ih")
        self.label_91 = QtWidgets.QLabel(self.tab_3)
        self.label_91.setGeometry(QtCore.QRect(-5, 209, 61, 20))
        self.label_91.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_91.setObjectName("label_91")
        self.pushButton_logsave = QtWidgets.QPushButton(self.tab_3)
        self.pushButton_logsave.setGeometry(QtCore.QRect(230, 315, 101, 23))
        self.pushButton_logsave.setObjectName("pushButton_logsave")
        self.pushButton_kml = QtWidgets.QPushButton(self.tab_3)
        self.pushButton_kml.setGeometry(QtCore.QRect(340, 315, 101, 23))
        self.pushButton_kml.setObjectName("pushButton_kml")
        self.textEdit_log = QtWidgets.QTextEdit(self.tab_3)
        self.textEdit_log.setGeometry(QtCore.QRect(10, 55, 541, 126))
        self.textEdit_log.setFocusPolicy(QtCore.Qt.ClickFocus)
        self.textEdit_log.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAsNeeded)
        self.textEdit_log.setLineWrapMode(QtWidgets.QTextEdit.NoWrap)
        self.textEdit_log.setObjectName("textEdit_log")
        self.pushButton_sima = QtWidgets.QPushButton(self.tab_3)
        self.pushButton_sima.setGeometry(QtCore.QRect(450, 315, 101, 23))
        self.pushButton_sima.setObjectName("pushButton_sima")
        self.check_tenki = QtWidgets.QCheckBox(self.tab_3)
        self.check_tenki.setEnabled(False)
        self.check_tenki.setGeometry(QtCore.QRect(500, 187, 51, 16))
        self.check_tenki.setObjectName("check_tenki")
        self.groupBox_3 = QtWidgets.QGroupBox(self.tab_3)
        self.groupBox_3.setGeometry(QtCore.QRect(290, 186, 201, 18))
        self.groupBox_3.setTitle("")
        self.groupBox_3.setObjectName("groupBox_3")
        self.check_file = QtWidgets.QRadioButton(self.groupBox_3)
        self.check_file.setGeometry(QtCore.QRect(8, 2, 51, 16))
        self.check_file.setChecked(True)
        self.check_file.setObjectName("check_file")
        self.check_trans2 = QtWidgets.QRadioButton(self.groupBox_3)
        self.check_trans2.setGeometry(QtCore.QRect(60, 2, 71, 16))
        self.check_trans2.setObjectName("check_trans2")
        self.check_trans = QtWidgets.QRadioButton(self.groupBox_3)
        self.check_trans.setGeometry(QtCore.QRect(130, 2, 69, 16))
        self.check_trans.setObjectName("check_trans")
        self.tabWidget.addTab(self.tab_3, "")
        self.tab_4 = QtWidgets.QWidget()
        self.tab_4.setObjectName("tab_4")
        self.comboBox_kei2 = QtWidgets.QComboBox(self.tab_4)
        self.comboBox_kei2.setGeometry(QtCore.QRect(102, 170, 181, 20))
        self.comboBox_kei2.setObjectName("comboBox_kei2")
        self.label_42 = QtWidgets.QLabel(self.tab_4)
        self.label_42.setGeometry(QtCore.QRect(10, 170, 101, 20))
        self.label_42.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_42.setObjectName("label_42")
        self.par = QtWidgets.QLineEdit(self.tab_4)
        self.par.setGeometry(QtCore.QRect(110, 65, 441, 20))
        self.par.setAlignment(QtCore.Qt.AlignCenter)
        self.par.setObjectName("par")
        self.le_b1 = QtWidgets.QLineEdit(self.tab_4)
        self.le_b1.setGeometry(QtCore.QRect(102, 110, 181, 20))
        self.le_b1.setAlignment(QtCore.Qt.AlignCenter)
        self.le_b1.setObjectName("le_b1")
        self.le_l1 = QtWidgets.QLineEdit(self.tab_4)
        self.le_l1.setGeometry(QtCore.QRect(102, 140, 181, 20))
        self.le_l1.setAlignment(QtCore.Qt.AlignCenter)
        self.le_l1.setObjectName("le_l1")
        self.le_x1 = QtWidgets.QLineEdit(self.tab_4)
        self.le_x1.setGeometry(QtCore.QRect(102, 200, 181, 20))
        self.le_x1.setAlignment(QtCore.Qt.AlignCenter)
        self.le_x1.setObjectName("le_x1")
        self.le_y1 = QtWidgets.QLineEdit(self.tab_4)
        self.le_y1.setGeometry(QtCore.QRect(102, 230, 181, 20))
        self.le_y1.setAlignment(QtCore.Qt.AlignCenter)
        self.le_y1.setObjectName("le_y1")
        self.le_h1 = QtWidgets.QLineEdit(self.tab_4)
        self.le_h1.setGeometry(QtCore.QRect(102, 260, 181, 20))
        self.le_h1.setAlignment(QtCore.Qt.AlignCenter)
        self.le_h1.setObjectName("le_h1")
        self.groupBox = QtWidgets.QGroupBox(self.tab_4)
        self.groupBox.setGeometry(QtCore.QRect(10, 10, 266, 46))
        self.groupBox.setObjectName("groupBox")
        self.genki_konki = QtWidgets.QRadioButton(self.groupBox)
        self.genki_konki.setGeometry(QtCore.QRect(30, 20, 91, 16))
        self.genki_konki.setObjectName("genki_konki")
        self.konki_genki = QtWidgets.QRadioButton(self.groupBox)
        self.konki_genki.setGeometry(QtCore.QRect(150, 20, 91, 16))
        self.konki_genki.setChecked(True)
        self.konki_genki.setObjectName("konki_genki")
        self.label_46 = QtWidgets.QLabel(self.tab_4)
        self.label_46.setGeometry(QtCore.QRect(10, 65, 101, 20))
        self.label_46.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_46.setObjectName("label_46")
        self.groupBox_2 = QtWidgets.QGroupBox(self.tab_4)
        self.groupBox_2.setGeometry(QtCore.QRect(283, 10, 266, 46))
        self.groupBox_2.setObjectName("groupBox_2")
        self.opt_bl = QtWidgets.QRadioButton(self.groupBox_2)
        self.opt_bl.setGeometry(QtCore.QRect(30, 20, 91, 16))
        self.opt_bl.setObjectName("opt_bl")
        self.opt_xy = QtWidgets.QRadioButton(self.groupBox_2)
        self.opt_xy.setGeometry(QtCore.QRect(140, 20, 101, 16))
        self.opt_xy.setChecked(True)
        self.opt_xy.setObjectName("opt_xy")
        self.label_47 = QtWidgets.QLabel(self.tab_4)
        self.label_47.setGeometry(QtCore.QRect(10, 110, 81, 20))
        self.label_47.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_47.setObjectName("label_47")
        self.label_48 = QtWidgets.QLabel(self.tab_4)
        self.label_48.setGeometry(QtCore.QRect(10, 140, 81, 20))
        self.label_48.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_48.setObjectName("label_48")
        self.label_49 = QtWidgets.QLabel(self.tab_4)
        self.label_49.setGeometry(QtCore.QRect(10, 200, 81, 20))
        self.label_49.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_49.setObjectName("label_49")
        self.label_50 = QtWidgets.QLabel(self.tab_4)
        self.label_50.setGeometry(QtCore.QRect(10, 230, 81, 20))
        self.label_50.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_50.setObjectName("label_50")
        self.label_51 = QtWidgets.QLabel(self.tab_4)
        self.label_51.setGeometry(QtCore.QRect(10, 260, 81, 20))
        self.label_51.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_51.setObjectName("label_51")
        self.pushButton_keisan = QtWidgets.QPushButton(self.tab_4)
        self.pushButton_keisan.setGeometry(QtCore.QRect(10, 315, 271, 23))
        self.pushButton_keisan.setObjectName("pushButton_keisan")
        self.label_52 = QtWidgets.QLabel(self.tab_4)
        self.label_52.setGeometry(QtCore.QRect(310, 230, 51, 20))
        self.label_52.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_52.setObjectName("label_52")
        self.le_b2 = QtWidgets.QLineEdit(self.tab_4)
        self.le_b2.setGeometry(QtCore.QRect(370, 110, 181, 20))
        self.le_b2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.le_b2.setAlignment(QtCore.Qt.AlignCenter)
        self.le_b2.setObjectName("le_b2")
        self.le_l2 = QtWidgets.QLineEdit(self.tab_4)
        self.le_l2.setGeometry(QtCore.QRect(370, 140, 181, 20))
        self.le_l2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.le_l2.setAlignment(QtCore.Qt.AlignCenter)
        self.le_l2.setObjectName("le_l2")
        self.le_x2 = QtWidgets.QLineEdit(self.tab_4)
        self.le_x2.setGeometry(QtCore.QRect(370, 170, 181, 20))
        self.le_x2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.le_x2.setAlignment(QtCore.Qt.AlignCenter)
        self.le_x2.setObjectName("le_x2")
        self.le_h2 = QtWidgets.QLineEdit(self.tab_4)
        self.le_h2.setGeometry(QtCore.QRect(370, 230, 181, 20))
        self.le_h2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.le_h2.setAlignment(QtCore.Qt.AlignCenter)
        self.le_h2.setObjectName("le_h2")
        self.label_53 = QtWidgets.QLabel(self.tab_4)
        self.label_53.setGeometry(QtCore.QRect(310, 170, 51, 20))
        self.label_53.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_53.setObjectName("label_53")
        self.label_54 = QtWidgets.QLabel(self.tab_4)
        self.label_54.setGeometry(QtCore.QRect(310, 200, 51, 20))
        self.label_54.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_54.setObjectName("label_54")
        self.label_55 = QtWidgets.QLabel(self.tab_4)
        self.label_55.setGeometry(QtCore.QRect(310, 110, 51, 20))
        self.label_55.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_55.setObjectName("label_55")
        self.le_y2 = QtWidgets.QLineEdit(self.tab_4)
        self.le_y2.setGeometry(QtCore.QRect(370, 200, 181, 20))
        self.le_y2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.le_y2.setAlignment(QtCore.Qt.AlignCenter)
        self.le_y2.setObjectName("le_y2")
        self.label_56 = QtWidgets.QLabel(self.tab_4)
        self.label_56.setGeometry(QtCore.QRect(310, 140, 51, 20))
        self.label_56.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_56.setObjectName("label_56")
        self.pushButton_hozon = QtWidgets.QPushButton(self.tab_4)
        self.pushButton_hozon.setGeometry(QtCore.QRect(290, 315, 261, 23))
        self.pushButton_hozon.setObjectName("pushButton_hozon")
        self.label_57 = QtWidgets.QLabel(self.tab_4)
        self.label_57.setGeometry(QtCore.QRect(370, 90, 181, 20))
        self.label_57.setAlignment(QtCore.Qt.AlignCenter)
        self.label_57.setObjectName("label_57")
        self.label_59 = QtWidgets.QLabel(self.tab_4)
        self.label_59.setGeometry(QtCore.QRect(102, 90, 181, 20))
        self.label_59.setAlignment(QtCore.Qt.AlignCenter)
        self.label_59.setObjectName("label_59")
        self.le_geoid = QtWidgets.QLineEdit(self.tab_4)
        self.le_geoid.setGeometry(QtCore.QRect(370, 260, 181, 20))
        self.le_geoid.setFocusPolicy(QtCore.Qt.NoFocus)
        self.le_geoid.setAlignment(QtCore.Qt.AlignCenter)
        self.le_geoid.setObjectName("le_geoid")
        self.le_h3 = QtWidgets.QLineEdit(self.tab_4)
        self.le_h3.setGeometry(QtCore.QRect(370, 290, 181, 20))
        self.le_h3.setFocusPolicy(QtCore.Qt.NoFocus)
        self.le_h3.setAlignment(QtCore.Qt.AlignCenter)
        self.le_h3.setObjectName("le_h3")
        self.label_60 = QtWidgets.QLabel(self.tab_4)
        self.label_60.setGeometry(QtCore.QRect(310, 260, 51, 20))
        self.label_60.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_60.setObjectName("label_60")
        self.label_61 = QtWidgets.QLabel(self.tab_4)
        self.label_61.setGeometry(QtCore.QRect(300, 290, 61, 20))
        self.label_61.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
        self.label_61.setObjectName("label_61")
        self.tabWidget.addTab(self.tab_4, "")
        self.tab_5 = QtWidgets.QWidget()
        self.tab_5.setObjectName("tab_5")
        self.kei = QtWidgets.QComboBox(self.tab_5)
        self.kei.setEnabled(True)
        self.kei.setGeometry(QtCore.QRect(100, 10, 251, 22))
        font = QtGui.QFont()
        font.setFamily("MS UI Gothic")
        font.setPointSize(9)
        self.kei.setFont(font)
        self.kei.setEditable(False)
        self.kei.setMaxVisibleItems(21)
        self.kei.setObjectName("kei")
        self.label_h = QtWidgets.QLabel(self.tab_5)
        self.label_h.setGeometry(QtCore.QRect(340, 180, 101, 20))
        self.label_h.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.label_h.setText("")
        self.label_h.setScaledContents(False)
        self.label_h.setAlignment(QtCore.Qt.AlignCenter)
        self.label_h.setObjectName("label_h")
        self.x1 = QtWidgets.QLineEdit(self.tab_5)
        self.x1.setEnabled(False)
        self.x1.setGeometry(QtCore.QRect(120, 140, 101, 20))
        font = QtGui.QFont()
        font.setPointSize(10)
        font.setBold(False)
        font.setWeight(50)
        self.x1.setFont(font)
        self.x1.setText("")
        self.x1.setAlignment(QtCore.Qt.AlignCenter)
        self.x1.setObjectName("x1")
        self.label_62 = QtWidgets.QLabel(self.tab_5)
        self.label_62.setEnabled(True)
        self.label_62.setGeometry(QtCore.QRect(10, 160, 101, 20))
        self.label_62.setAlignment(QtCore.Qt.AlignCenter)
        self.label_62.setObjectName("label_62")
        self.label_y2 = QtWidgets.QLabel(self.tab_5)
        self.label_y2.setGeometry(QtCore.QRect(230, 205, 101, 20))
        self.label_y2.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.label_y2.setText("")
        self.label_y2.setScaledContents(False)
        self.label_y2.setAlignment(QtCore.Qt.AlignCenter)
        self.label_y2.setObjectName("label_y2")
        self.y1 = QtWidgets.QLineEdit(self.tab_5)
        self.y1.setEnabled(False)
        self.y1.setGeometry(QtCore.QRect(230, 140, 101, 20))
        font = QtGui.QFont()
        font.setPointSize(10)
        font.setBold(False)
        font.setWeight(50)
        self.y1.setFont(font)
        self.y1.setAlignment(QtCore.Qt.AlignCenter)
        self.y1.setObjectName("y1")
        self.label_63 = QtWidgets.QLabel(self.tab_5)
        self.label_63.setEnabled(True)
        self.label_63.setGeometry(QtCore.QRect(450, 160, 101, 20))
        self.label_63.setAlignment(QtCore.Qt.AlignCenter)
        self.label_63.setObjectName("label_63")
        self.label_64 = QtWidgets.QLabel(self.tab_5)
        self.label_64.setEnabled(False)
        self.label_64.setGeometry(QtCore.QRect(230, 120, 101, 20))
        self.label_64.setAlignment(QtCore.Qt.AlignCenter)
        self.label_64.setObjectName("label_64")
        self.label_ratio = QtWidgets.QLabel(self.tab_5)
        self.label_ratio.setGeometry(QtCore.QRect(450, 180, 101, 20))
        self.label_ratio.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.label_ratio.setText("")
        self.label_ratio.setScaledContents(False)
        self.label_ratio.setAlignment(QtCore.Qt.AlignCenter)
        self.label_ratio.setObjectName("label_ratio")
        self.label_65 = QtWidgets.QLabel(self.tab_5)
        self.label_65.setEnabled(True)
        self.label_65.setGeometry(QtCore.QRect(120, 160, 101, 20))
        self.label_65.setAlignment(QtCore.Qt.AlignCenter)
        self.label_65.setObjectName("label_65")
        self.label_x2 = QtWidgets.QLabel(self.tab_5)
        self.label_x2.setGeometry(QtCore.QRect(120, 205, 101, 20))
        self.label_x2.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.label_x2.setText("")
        self.label_x2.setScaledContents(False)
        self.label_x2.setAlignment(QtCore.Qt.AlignCenter)
        self.label_x2.setObjectName("label_x2")
        self.epoch = QtWidgets.QPushButton(self.tab_5)
        self.epoch.setEnabled(True)
        self.epoch.setGeometry(QtCore.QRect(45, 204, 66, 22))
        font = QtGui.QFont()
        font.setPointSize(9)
        self.epoch.setFont(font)
        self.epoch.setWhatsThis("")
        self.epoch.setCheckable(True)
        self.epoch.setAutoExclusive(False)
        self.epoch.setAutoDefault(False)
        self.epoch.setDefault(False)
        self.epoch.setObjectName("epoch")
        self.label_66 = QtWidgets.QLabel(self.tab_5)
        self.label_66.setEnabled(False)
        self.label_66.setGeometry(QtCore.QRect(340, 120, 101, 20))
        self.label_66.setAlignment(QtCore.Qt.AlignCenter)
        self.label_66.setObjectName("label_66")
        self.label_68 = QtWidgets.QLabel(self.tab_5)
        self.label_68.setEnabled(True)
        self.label_68.setGeometry(QtCore.QRect(230, 160, 101, 20))
        self.label_68.setAlignment(QtCore.Qt.AlignCenter)
        self.label_68.setObjectName("label_68")
        self.d = QtWidgets.QLineEdit(self.tab_5)
        self.d.setEnabled(False)
        self.d.setGeometry(QtCore.QRect(450, 140, 101, 20))
        font = QtGui.QFont()
        font.setPointSize(10)
        font.setBold(False)
        font.setWeight(50)
        self.d.setFont(font)
        self.d.setFocusPolicy(QtCore.Qt.NoFocus)
        self.d.setAlignment(QtCore.Qt.AlignCenter)
        self.d.setObjectName("d")
        self.lineEdit_pn = QtWidgets.QLineEdit(self.tab_5)
        self.lineEdit_pn.setGeometry(QtCore.QRect(479, 205, 55, 20))
        self.lineEdit_pn.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_pn.setObjectName("lineEdit_pn")
        self.label_1 = QtWidgets.QLabel(self.tab_5)
        self.label_1.setEnabled(False)
        self.label_1.setGeometry(QtCore.QRect(120, 120, 101, 20))
        self.label_1.setAlignment(QtCore.Qt.AlignCenter)
        self.label_1.setObjectName("label_1")
        self.label_y = QtWidgets.QLabel(self.tab_5)
        self.label_y.setGeometry(QtCore.QRect(230, 180, 101, 20))
        self.label_y.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.label_y.setText("")
        self.label_y.setScaledContents(False)
        self.label_y.setAlignment(QtCore.Qt.AlignCenter)
        self.label_y.setObjectName("label_y")
        self.label_69 = QtWidgets.QLabel(self.tab_5)
        self.label_69.setEnabled(False)
        self.label_69.setGeometry(QtCore.QRect(450, 120, 101, 20))
        self.label_69.setAlignment(QtCore.Qt.AlignCenter)
        self.label_69.setObjectName("label_69")
        self.label_x = QtWidgets.QLabel(self.tab_5)
        self.label_x.setGeometry(QtCore.QRect(120, 180, 101, 20))
        self.label_x.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.label_x.setText("")
        self.label_x.setScaledContents(False)
        self.label_x.setAlignment(QtCore.Qt.AlignCenter)
        self.label_x.setObjectName("label_x")
        self.label_time = QtWidgets.QLabel(self.tab_5)
        self.label_time.setGeometry(QtCore.QRect(10, 180, 101, 20))
        self.label_time.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.label_time.setText("")
        self.label_time.setScaledContents(False)
        self.label_time.setAlignment(QtCore.Qt.AlignCenter)
        self.label_time.setObjectName("label_time")
        self.a = QtWidgets.QLineEdit(self.tab_5)
        self.a.setEnabled(False)
        self.a.setGeometry(QtCore.QRect(340, 140, 101, 20))
        font = QtGui.QFont()
        font.setPointSize(10)
        font.setBold(False)
        font.setWeight(50)
        self.a.setFont(font)
        self.a.setFocusPolicy(QtCore.Qt.NoFocus)
        self.a.setAlignment(QtCore.Qt.AlignCenter)
        self.a.setObjectName("a")
        self.check2 = QtWidgets.QCheckBox(self.tab_5)
        self.check2.setGeometry(QtCore.QRect(10, 141, 91, 16))
        self.check2.setObjectName("check2")
        self.label_70 = QtWidgets.QLabel(self.tab_5)
        self.label_70.setEnabled(True)
        self.label_70.setGeometry(QtCore.QRect(340, 160, 101, 20))
        self.label_70.setAlignment(QtCore.Qt.AlignCenter)
        self.label_70.setObjectName("label_70")
        self.lineEdit_epoch = QtWidgets.QLineEdit(self.tab_5)
        self.lineEdit_epoch.setEnabled(True)
        self.lineEdit_epoch.setGeometry(QtCore.QRect(10, 205, 31, 20))
        self.lineEdit_epoch.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_epoch.setObjectName("lineEdit_epoch")
        self.label_h2 = QtWidgets.QLabel(self.tab_5)
        self.label_h2.setGeometry(QtCore.QRect(340, 205, 101, 20))
        self.label_h2.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.label_h2.setText("")
        self.label_h2.setScaledContents(False)
        self.label_h2.setAlignment(QtCore.Qt.AlignCenter)
        self.label_h2.setObjectName("label_h2")
        self.label_71 = QtWidgets.QLabel(self.tab_5)
        self.label_71.setEnabled(True)
        self.label_71.setGeometry(QtCore.QRect(450, 205, 31, 20))
        self.label_71.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_71.setObjectName("label_71")
        self.comboBox_sentence = QtWidgets.QComboBox(self.tab_5)
        self.comboBox_sentence.setGeometry(QtCore.QRect(310, 40, 121, 22))
        self.comboBox_sentence.setObjectName("comboBox_sentence")
        self.label_72 = QtWidgets.QLabel(self.tab_5)
        self.label_72.setGeometry(QtCore.QRect(260, 41, 50, 16))
        self.label_72.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_72.setObjectName("label_72")
        self.lineEdit_Ratio = QtWidgets.QLineEdit(self.tab_5)
        self.lineEdit_Ratio.setEnabled(False)
        self.lineEdit_Ratio.setGeometry(QtCore.QRect(470, 40, 51, 20))
        self.lineEdit_Ratio.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_Ratio.setObjectName("lineEdit_Ratio")
        self.label_84 = QtWidgets.QLabel(self.tab_5)
        self.label_84.setGeometry(QtCore.QRect(440, 41, 111, 16))
        font = QtGui.QFont()
        font.setPointSize(9)
        self.label_84.setFont(font)
        self.label_84.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_84.setObjectName("label_84")
        self.label_73 = QtWidgets.QLabel(self.tab_5)
        self.label_73.setGeometry(QtCore.QRect(10, 41, 31, 20))
        self.label_73.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_73.setObjectName("label_73")
        self.comboBox_port = QtWidgets.QComboBox(self.tab_5)
        self.comboBox_port.setGeometry(QtCore.QRect(40, 40, 76, 22))
        self.comboBox_port.setObjectName("comboBox_port")
        self.comboBox_baudrate = QtWidgets.QComboBox(self.tab_5)
        self.comboBox_baudrate.setGeometry(QtCore.QRect(175, 40, 76, 22))
        self.comboBox_baudrate.setObjectName("comboBox_baudrate")
        self.label_74 = QtWidgets.QLabel(self.tab_5)
        self.label_74.setGeometry(QtCore.QRect(125, 41, 51, 16))
        self.label_74.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_74.setObjectName("label_74")
        self.groupBox_time = QtWidgets.QGroupBox(self.tab_5)
        self.groupBox_time.setGeometry(QtCore.QRect(360, 8, 191, 26))
        self.groupBox_time.setTitle("")
        self.groupBox_time.setObjectName("groupBox_time")
        self.radioButton_time1 = QtWidgets.QRadioButton(self.groupBox_time)
        self.radioButton_time1.setGeometry(QtCore.QRect(10, 5, 71, 16))
        self.radioButton_time1.setChecked(True)
        self.radioButton_time1.setObjectName("radioButton_time1")
        self.radioButton_time2 = QtWidgets.QRadioButton(self.groupBox_time)
        self.radioButton_time2.setGeometry(QtCore.QRect(83, 5, 111, 16))
        self.radioButton_time2.setObjectName("radioButton_time2")
        self.textLog = QtWidgets.QTextEdit(self.tab_5)
        self.textLog.setGeometry(QtCore.QRect(10, 230, 541, 81))
        self.textLog.setObjectName("textLog")
        self.switch_on2 = QtWidgets.QPushButton(self.tab_5)
        self.switch_on2.setGeometry(QtCore.QRect(10, 315, 101, 25))
        self.switch_on2.setWhatsThis("")
        self.switch_on2.setCheckable(True)
        self.switch_on2.setChecked(False)
        self.switch_on2.setAutoExclusive(False)
        self.switch_on2.setAutoDefault(True)
        self.switch_on2.setDefault(False)
        self.switch_on2.setObjectName("switch_on2")
        self.KML = QtWidgets.QPushButton(self.tab_5)
        self.KML.setGeometry(QtCore.QRect(340, 315, 101, 25))
        self.KML.setWhatsThis("")
        self.KML.setAutoExclusive(False)
        self.KML.setAutoDefault(True)
        self.KML.setDefault(False)
        self.KML.setObjectName("KML")
        self.GPX = QtWidgets.QPushButton(self.tab_5)
        self.GPX.setGeometry(QtCore.QRect(120, 315, 101, 25))
        self.GPX.setWhatsThis("")
        self.GPX.setAutoExclusive(False)
        self.GPX.setAutoDefault(True)
        self.GPX.setDefault(False)
        self.GPX.setObjectName("GPX")
        self.SIMA = QtWidgets.QPushButton(self.tab_5)
        self.SIMA.setGeometry(QtCore.QRect(230, 315, 101, 25))
        self.SIMA.setWhatsThis("")
        self.SIMA.setAutoExclusive(False)
        self.SIMA.setAutoDefault(True)
        self.SIMA.setDefault(False)
        self.SIMA.setObjectName("SIMA")
        self.clear_log = QtWidgets.QPushButton(self.tab_5)
        self.clear_log.setGeometry(QtCore.QRect(450, 315, 101, 25))
        self.clear_log.setWhatsThis("")
        self.clear_log.setAutoExclusive(False)
        self.clear_log.setAutoDefault(True)
        self.clear_log.setDefault(False)
        self.clear_log.setObjectName("clear_log")
        self.label_75 = QtWidgets.QLabel(self.tab_5)
        self.label_75.setGeometry(QtCore.QRect(10, 10, 101, 20))
        self.label_75.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.label_75.setObjectName("label_75")
        self.read_sima = QtWidgets.QPushButton(self.tab_5)
        self.read_sima.setGeometry(QtCore.QRect(10, 67, 81, 25))
        self.read_sima.setWhatsThis("")
        self.read_sima.setAutoExclusive(False)
        self.read_sima.setAutoDefault(True)
        self.read_sima.setDefault(False)
        self.read_sima.setObjectName("read_sima")
        self.lineEdit_pn2 = QtWidgets.QLineEdit(self.tab_5)
        self.lineEdit_pn2.setGeometry(QtCore.QRect(10, 96, 171, 22))
        self.lineEdit_pn2.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_pn2.setObjectName("lineEdit_pn2")
        self.kensaku = QtWidgets.QPushButton(self.tab_5)
        self.kensaku.setGeometry(QtCore.QRect(100, 67, 81, 25))
        self.kensaku.setWhatsThis("")
        self.kensaku.setAutoExclusive(False)
        self.kensaku.setAutoDefault(True)
        self.kensaku.setDefault(False)
        self.kensaku.setObjectName("kensaku")
        self.listWidget = QtWidgets.QListWidget(self.tab_5)
        self.listWidget.setGeometry(QtCore.QRect(190, 67, 361, 51))
        self.listWidget.setObjectName("listWidget")
        self.check_leaflet = QtWidgets.QCheckBox(self.tab_5)
        self.check_leaflet.setGeometry(QtCore.QRect(538, 207, 21, 16))
        self.check_leaflet.setText("")
        self.check_leaflet.setChecked(True)
        self.check_leaflet.setObjectName("check_leaflet")
        self.label_84.raise_()
        self.kei.raise_()
        self.label_h.raise_()
        self.x1.raise_()
        self.label_62.raise_()
        self.label_y2.raise_()
        self.y1.raise_()
        self.label_63.raise_()
        self.label_64.raise_()
        self.label_ratio.raise_()
        self.label_65.raise_()
        self.label_x2.raise_()
        self.epoch.raise_()
        self.label_66.raise_()
        self.label_68.raise_()
        self.d.raise_()
        self.lineEdit_pn.raise_()
        self.label_1.raise_()
        self.label_y.raise_()
        self.label_69.raise_()
        self.label_x.raise_()
        self.label_time.raise_()
        self.a.raise_()
        self.check2.raise_()
        self.label_70.raise_()
        self.lineEdit_epoch.raise_()
        self.label_h2.raise_()
        self.label_71.raise_()
        self.comboBox_sentence.raise_()
        self.label_72.raise_()
        self.lineEdit_Ratio.raise_()
        self.label_73.raise_()
        self.comboBox_port.raise_()
        self.comboBox_baudrate.raise_()
        self.label_74.raise_()
        self.groupBox_time.raise_()
        self.textLog.raise_()
        self.switch_on2.raise_()
        self.KML.raise_()
        self.GPX.raise_()
        self.SIMA.raise_()
        self.clear_log.raise_()
        self.label_75.raise_()
        self.read_sima.raise_()
        self.lineEdit_pn2.raise_()
        self.kensaku.raise_()
        self.listWidget.raise_()
        self.check_leaflet.raise_()
        self.tabWidget.addTab(self.tab_5, "")
        self.tab_6 = QtWidgets.QWidget()
        self.tab_6.setObjectName("tab_6")
        self.pushButton_install = QtWidgets.QPushButton(self.tab_6)
        self.pushButton_install.setEnabled(True)
        self.pushButton_install.setGeometry(QtCore.QRect(10, 40, 541, 23))
        self.pushButton_install.setObjectName("pushButton_install")
        self.pushButton_Desktop = QtWidgets.QPushButton(self.tab_6)
        self.pushButton_Desktop.setEnabled(True)
        self.pushButton_Desktop.setGeometry(QtCore.QRect(10, 100, 541, 23))
        self.pushButton_Desktop.setText("起動用ファイル作成（Raspberry Pi）")
        self.pushButton_Desktop.setObjectName("pushButton_Desktop")
        self.pushButton_com = QtWidgets.QPushButton(self.tab_6)
        self.pushButton_com.setEnabled(True)
        self.pushButton_com.setGeometry(QtCore.QRect(10, 70, 541, 23))
        self.pushButton_com.setObjectName("pushButton_com")
        self.pushButton_VBS = QtWidgets.QPushButton(self.tab_6)
        self.pushButton_VBS.setGeometry(QtCore.QRect(10, 130, 541, 23))
        self.pushButton_VBS.setObjectName("pushButton_VBS")
        self.textEdit_2 = QtWidgets.QTextEdit(self.tab_6)
        self.textEdit_2.setGeometry(QtCore.QRect(10, 160, 541, 171))
        self.textEdit_2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.textEdit_2.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
        self.textEdit_2.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
        self.textEdit_2.setObjectName("textEdit_2")
        self.lineEdit_URL = QtWidgets.QLineEdit(self.tab_6)
        self.lineEdit_URL.setGeometry(QtCore.QRect(10, 11, 541, 20))
        self.lineEdit_URL.setObjectName("lineEdit_URL")
        self.tabWidget.addTab(self.tab_6, "")
        self.lineEdit_str2str_path = QtWidgets.QLineEdit(self)
        self.lineEdit_str2str_path.setGeometry(QtCore.QRect(280, 375, 271, 20))
        self.lineEdit_str2str_path.setObjectName("lineEdit_str2str_path")
        self.lineEdit_rtkstart_path = QtWidgets.QLineEdit(self)
        self.lineEdit_rtkstart_path.setGeometry(QtCore.QRect(10, 395, 261, 20))
        self.lineEdit_rtkstart_path.setObjectName("lineEdit_rtkstart_path")
        self.lineEdit_rtkshut_path = QtWidgets.QLineEdit(self)
        self.lineEdit_rtkshut_path.setGeometry(QtCore.QRect(280, 395, 271, 20))
        self.lineEdit_rtkshut_path.setObjectName("lineEdit_rtkshut_path")
        self.lineEdit_conf_path = QtWidgets.QLineEdit(self)
        self.lineEdit_conf_path.setGeometry(QtCore.QRect(280, 415, 271, 20))
        self.lineEdit_conf_path.setObjectName("lineEdit_conf_path")
        self.lineEdit_makefile_path = QtWidgets.QLineEdit(self)
        self.lineEdit_makefile_path.setGeometry(QtCore.QRect(10, 375, 261, 20))
        self.lineEdit_makefile_path.setObjectName("lineEdit_makefile_path")
        self.lineEdit_rtkrcv_path = QtWidgets.QLineEdit(self)
        self.lineEdit_rtkrcv_path.setGeometry(QtCore.QRect(10, 415, 261, 20))
        self.lineEdit_rtkrcv_path.setObjectName("lineEdit_rtkrcv_path")

        self.tabWidget.setCurrentIndex(0)
        self.tabWidget.currentChanged['int'].connect(self.lineEdit_ih.setFocus) # type: ignore
        self.lineEdit_lat.returnPressed.connect(self.lineEdit_lng.setFocus) # type: ignore
        self.lineEdit_lng.returnPressed.connect(self.lineEdit_h1.setFocus) # type: ignore
        self.lineEdit_h1.returnPressed.connect(self.pushButton_read2.setFocus) # type: ignore
        self.lineEdit_ih.returnPressed.connect(self.lineEdit_lat.setFocus) # type: ignore
        self.radioButton_ratio.clicked.connect(self.lineEdit_ratio.setFocus) # type: ignore
        self.base_lat.returnPressed.connect(self.base_lon.setFocus) # type: ignore
        self.base_lon.returnPressed.connect(self.base_alt.setFocus) # type: ignore
        QtCore.QMetaObject.connectSlotsByName(self)
        self.setTabOrder(self.tabWidget, self.combo_port)
        self.setTabOrder(self.combo_port, self.combo_baudrate)
        self.setTabOrder(self.combo_baudrate, self.combo_ByteSize)
        self.setTabOrder(self.combo_ByteSize, self.combo_Parity)
        self.setTabOrder(self.combo_Parity, self.combo_StopBits)
        self.setTabOrder(self.combo_StopBits, self.combo_FlowControl)
        self.setTabOrder(self.combo_FlowControl, self.base_lat)
        self.setTabOrder(self.base_lat, self.base_lon)
        self.setTabOrder(self.base_lon, self.base_alt)
        self.setTabOrder(self.base_alt, self.radio_Output1)
        self.setTabOrder(self.radio_Output1, self.radio_Output2)
        self.setTabOrder(self.radio_Output2, self.lineEdit_Host)
        self.setTabOrder(self.lineEdit_Host, self.lineEdit_Port)
        self.setTabOrder(self.lineEdit_Port, self.lineEdit_Mountpoint)
        self.setTabOrder(self.lineEdit_Mountpoint, self.lineEdit_ID)
        self.setTabOrder(self.lineEdit_ID, self.lineEdit_Pass)
        self.setTabOrder(self.lineEdit_Pass, self.combo_cmd)
        self.setTabOrder(self.combo_cmd, self.checkBox_String)
        self.setTabOrder(self.checkBox_String, self.textEdit_String)
        self.setTabOrder(self.textEdit_String, self.checkBox_conv)
        self.setTabOrder(self.checkBox_conv, self.textEdit_msg)
        self.setTabOrder(self.textEdit_msg, self.combo_sh)
        self.setTabOrder(self.combo_sh, self.switch_on)
        self.setTabOrder(self.switch_on, self.save)
        self.setTabOrder(self.save, self.combo1)
        self.setTabOrder(self.combo1, self.combo2)
        self.setTabOrder(self.combo2, self.lineEdit3)
        self.setTabOrder(self.lineEdit3, self.lineEdit4)
        self.setTabOrder(self.lineEdit4, self.combo5)
        self.setTabOrder(self.combo5, self.combo6)
        self.setTabOrder(self.combo6, self.combo7)
        self.setTabOrder(self.combo7, self.combo21)
        self.setTabOrder(self.combo21, self.combo22)
        self.setTabOrder(self.combo22, self.combo23)
        self.setTabOrder(self.combo23, self.combo24)
        self.setTabOrder(self.combo24, self.lineEdit_out1path)
        self.setTabOrder(self.lineEdit_out1path, self.lineEdit_out2path)
        self.setTabOrder(self.lineEdit_out2path, self.combo8)
        self.setTabOrder(self.combo8, self.combo9)
        self.setTabOrder(self.combo9, self.combo10)
        self.setTabOrder(self.combo10, self.combo11)
        self.setTabOrder(self.combo11, self.lineEdit12)
        self.setTabOrder(self.lineEdit12, self.lineEditL1)
        self.setTabOrder(self.lineEditL1, self.lineEditL2)
        self.setTabOrder(self.lineEditL2, self.lineEditL5)
        self.setTabOrder(self.lineEditL5, self.combo_Rover)
        self.setTabOrder(self.combo_Rover, self.combo_Base)
        self.setTabOrder(self.combo_Base, self.lineEdit14)
        self.setTabOrder(self.lineEdit14, self.lineEdit15)
        self.setTabOrder(self.lineEdit15, self.combo16)
        self.setTabOrder(self.combo16, self.combo17)
        self.setTabOrder(self.combo17, self.lineEdit18)
        self.setTabOrder(self.lineEdit18, self.lineEdit19)
        self.setTabOrder(self.lineEdit19, self.lineEdit20)
        self.setTabOrder(self.lineEdit20, self.combo_path)
        self.setTabOrder(self.combo_path, self.pushButton2)
        self.setTabOrder(self.pushButton2, self.pushButton1)
        self.setTabOrder(self.pushButton1, self.pushButton3)
        self.setTabOrder(self.pushButton3, self.lineEdit_URL)
        self.setTabOrder(self.lineEdit_URL, self.pushButton_install)
        self.setTabOrder(self.pushButton_install, self.pushButton_com)
        self.setTabOrder(self.pushButton_com, self.pushButton_Desktop)
        self.setTabOrder(self.pushButton_Desktop, self.pushButton_VBS)
        self.setTabOrder(self.pushButton_VBS, self.lineEdit_ih)
        self.setTabOrder(self.lineEdit_ih, self.lineEdit_lat)
        self.setTabOrder(self.lineEdit_lat, self.lineEdit_lng)
        self.setTabOrder(self.lineEdit_lng, self.lineEdit_h1)
        self.setTabOrder(self.lineEdit_h1, self.check_file)
        self.setTabOrder(self.check_file, self.check_trans2)
        self.setTabOrder(self.check_trans2, self.check_trans)
        self.setTabOrder(self.check_trans, self.check_tenki)
        self.setTabOrder(self.check_tenki, self.radioButton_fix)
        self.setTabOrder(self.radioButton_fix, self.radioButton_all)
        self.setTabOrder(self.radioButton_all, self.radioButton_ratio)
        self.setTabOrder(self.radioButton_ratio, self.pushButton_read)
        self.setTabOrder(self.pushButton_read, self.pushButton_read2)
        self.setTabOrder(self.pushButton_read2, self.pushButton_logsave)
        self.setTabOrder(self.pushButton_logsave, self.pushButton_kml)
        self.setTabOrder(self.pushButton_kml, self.pushButton_SemiDyna)
        self.setTabOrder(self.pushButton_SemiDyna, self.pushButton_save)
        self.setTabOrder(self.pushButton_save, self.pushButton_sima)
        self.setTabOrder(self.pushButton_sima, self.genki_konki)
        self.setTabOrder(self.genki_konki, self.konki_genki)
        self.setTabOrder(self.konki_genki, self.opt_bl)
        self.setTabOrder(self.opt_bl, self.opt_xy)
        self.setTabOrder(self.opt_xy, self.par)
        self.setTabOrder(self.par, self.le_b1)
        self.setTabOrder(self.le_b1, self.le_l1)
        self.setTabOrder(self.le_l1, self.comboBox_kei2)
        self.setTabOrder(self.comboBox_kei2, self.le_x1)
        self.setTabOrder(self.le_x1, self.le_y1)
        self.setTabOrder(self.le_y1, self.le_h1)
        self.setTabOrder(self.le_h1, self.pushButton_keisan)
        self.setTabOrder(self.pushButton_keisan, self.pushButton_hozon)
        self.setTabOrder(self.pushButton_hozon, self.kei)
        self.setTabOrder(self.kei, self.radioButton_time1)
        self.setTabOrder(self.radioButton_time1, self.radioButton_time2)
        self.setTabOrder(self.radioButton_time2, self.comboBox_port)
        self.setTabOrder(self.comboBox_port, self.comboBox_baudrate)
        self.setTabOrder(self.comboBox_baudrate, self.comboBox_sentence)
        self.setTabOrder(self.comboBox_sentence, self.lineEdit_Ratio)
        self.setTabOrder(self.lineEdit_Ratio, self.read_sima)
        self.setTabOrder(self.read_sima, self.lineEdit_pn2)
        self.setTabOrder(self.lineEdit_pn2, self.kensaku)
        self.setTabOrder(self.kensaku, self.listWidget)
        self.setTabOrder(self.listWidget, self.check2)
        self.setTabOrder(self.check2, self.x1)
        self.setTabOrder(self.x1, self.y1)
        self.setTabOrder(self.y1, self.lineEdit_pn)
        self.setTabOrder(self.lineEdit_pn, self.check_leaflet)
        self.setTabOrder(self.check_leaflet, self.lineEdit_epoch)
        self.setTabOrder(self.lineEdit_epoch, self.epoch)
        self.setTabOrder(self.epoch, self.switch_on2)
        self.setTabOrder(self.switch_on2, self.GPX)
        self.setTabOrder(self.GPX, self.SIMA)
        self.setTabOrder(self.SIMA, self.KML)
        self.setTabOrder(self.KML, self.clear_log)
        self.setTabOrder(self.clear_log, self.textLog)

        _translate = QtCore.QCoreApplication.translate
        self.setWindowTitle(_translate("self", "RTK_TOOL 3　Ver.2022.07.19"))
        self.groupBox1.setTitle(_translate("self", "Input (Serial)"))
        self.label_6.setText(_translate("self", "Byte Size"))
        self.label_5.setText(_translate("self", "Baudrate"))
        self.label.setText(_translate("self", "Port"))
        self.label_7.setText(_translate("self", "Parity"))
        self.label_8.setText(_translate("self", "Stop Bits"))
        self.label_15.setText(_translate("self", "Flow Cotrol"))
        self.base_lon.setToolTip(_translate("self", "ex. 160.16.134.72"))
        self.base_lat.setToolTip(_translate("self", "ex. 160.16.134.72"))
        self.label_78.setText(_translate("self", "経度"))
        self.base_alt.setToolTip(_translate("self", "ex. 160.16.134.72"))
        self.label_77.setText(_translate("self", "緯度"))
        self.label_79.setText(_translate("self", "楕円体高"))
        self.label_80.setText(_translate("self", "基準局座標"))
        self.save.setText(_translate("self", "登録"))
        self.switch_on.setToolTip(_translate("self", "切断は、Ctrl + C"))
        self.switch_on.setText(_translate("self", "接続"))
        self.label_17.setText(_translate("self", "Select Mountpoint"))
        self.groupBox2.setTitle(_translate("self", "Output"))
        self.label_9.setText(_translate("self", "Mountpoint"))
        self.label_10.setText(_translate("self", "Port"))
        self.label_11.setText(_translate("self", "NTRIP Caster Host"))
        self.lineEdit_Host.setToolTip(_translate("self", "ex. 160.16.134.72"))
        self.lineEdit_Port.setToolTip(_translate("self", "ex. 80"))
        self.lineEdit_Mountpoint.setToolTip(_translate("self", "ex. CQ-UBLOX"))
        self.label_12.setText(_translate("self", "User-ID"))
        self.lineEdit_ID.setToolTip(_translate("self", "ex. guest"))
        self.label_13.setText(_translate("self", "Password"))
        self.lineEdit_Pass.setToolTip(_translate("self", "ex. guest"))
        self.label_76.setText(_translate("self", "cmdfile"))
        self.checkBox_String.setText(_translate("self", "基準局情報 (改行不可)"))
        self.textEdit_String.setHtml(_translate("self", "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"
"<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
"p, li { white-space: pre-wrap; }\n"
"</style></head><body style=\" font-family:\'MS UI Gothic\'; font-size:9pt; font-weight:400; font-style:normal;\">\n"
"<p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p></body></html>"))
        self.sample.setToolTip(_translate("self", "切断は、Ctrl + C"))
        self.sample.setText(_translate("self", "Sample"))
        self.textEdit_msg.setHtml(_translate("self", "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"
"<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
"p, li { white-space: pre-wrap; }\n"
"</style></head><body style=\" font-family:\'MS UI Gothic\'; font-size:9pt; font-weight:400; font-style:normal;\">\n"
"<p style=\"-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><br /></p></body></html>"))
        self.checkBox_conv.setText(_translate("self", "ubx→rtcm3変換"))
        self.sample2.setToolTip(_translate("self", "切断は、Ctrl + C"))
        self.sample2.setText(_translate("self", "Sample"))
        self.radio_Output1.setText(_translate("self", "NTRIP Server"))
        self.radio_Output2.setText(_translate("self", "TCP Server"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab), _translate("self", "STR2STR（基準局）"))
        self.pushButton1.setToolTip(_translate("self", "STR2STRのMountpointからinpstr1-path,inpstr2-pathに転記します。"))
        self.pushButton1.setText(_translate("self", "転記"))
        self.pushButton2.setText(_translate("self", "接続"))
        self.pushButton3.setText(_translate("self", "登録"))
        self.label_67.setText(_translate("self", "Select Mountpoint"))
        self.label_27.setText(_translate("self", "pos1-exclsats"))
        self.lineEdit12.setToolTip(_translate("self", "(deg)"))
        self.lineEdit12.setText(_translate("self", "20"))
        self.lineEdit3.setToolTip(_translate("self", "ex. ttyACM0:115200:8:n:1:off"))
        self.lineEdit3.setText(_translate("self", "ttyACM0:115200:8:n:1:off"))
        self.label_18.setText(_translate("self", "inpstr1-format"))
        self.lineEditL1.setToolTip(_translate("self", "(dBHz)"))
        self.lineEditL1.setText(_translate("self", "35,35,35,35,35,35,35,35,35"))
        self.label_16.setText(_translate("self", "inpstr2-path"))
        self.label_25.setText(_translate("self", "pos1-elmask"))
        self.label_21.setText(_translate("self", "outstr1-path"))
        self.label_3.setText(_translate("self", "inpstr2-type"))
        self.label_20.setText(_translate("self", "misc-navmsgsel"))
        self.label_26.setText(_translate("self", "pos1-snrmask L1"))
        self.label_4.setText(_translate("self", "inpstr1-path"))
        self.label_22.setText(_translate("self", "outstr2-path"))
        self.lineEdit4.setToolTip(_translate("self", "ex. guest:guest@160.16.134.72:80/CQ-UBLOX"))
        self.label_23.setText(_translate("self", "pos1-posmode"))
        self.label_19.setText(_translate("self", "inpstr2-format"))
        self.label_24.setText(_translate("self", "pos1-frequency"))
        self.label_2.setText(_translate("self", "inpstr1-type"))
        self.label_34.setText(_translate("self", "outstr1-type"))
        self.label_35.setText(_translate("self", "outstr2-type"))
        self.label_36.setText(_translate("self", "outstr1-format"))
        self.label_37.setText(_translate("self", "outstr2-format"))
        self.label_81.setText(_translate("self", "L2"))
        self.lineEditL2.setToolTip(_translate("self", "(dBHz)"))
        self.lineEditL2.setText(_translate("self", "35,35,35,35,35,35,35,35,35"))
        self.lineEditL5.setToolTip(_translate("self", "(dBHz)"))
        self.lineEditL5.setText(_translate("self", "35,35,35,35,35,35,35,35,35"))
        self.label_82.setText(_translate("self", "L5"))
        self.lineEdit14.setToolTip(_translate("self", "(prn ...)"))
        self.lineEdit14.setText(_translate("self", "C02"))
        self.label_83.setText(_translate("self", "pos1-snrmask  rover"))
        self.label_92.setText(_translate("self", "base"))
        self.lineEdit_out1path.setText(_translate("self", "/home/pi/RTK_TOOL3/log/"))
        self.lineEdit_out2path.setText(_translate("self", "/home/pi/RTK_TOOL3/log/"))
        self.checkBox_mOption.setText(_translate("self", "-m Option"))
        self.lineEdit_port.setText(_translate("self", "52001"))
        self.label_93.setText(_translate("self", "Port"))
        self.label_94.setText(_translate("self", "file-cmdfile1"))
        self.label_95.setText(_translate("self", "file-cmdfile2"))
        self.lineEdit20.setToolTip(_translate("self", "ex. 80.3300"))
        self.label_32.setText(_translate("self", "ant2-pos2"))
        self.label_33.setText(_translate("self", "ant2-pos3"))
        self.label_29.setText(_translate("self", "pos2-armode"))
        self.lineEdit19.setToolTip(_translate("self", "ex. 139.739691700"))
        self.label_28.setText(_translate("self", "pos1-navsys"))
        self.label_31.setText(_translate("self", "ant2-pos1"))
        self.lineEdit18.setToolTip(_translate("self", "ex. 35.731012060"))
        self.label_30.setText(_translate("self", "ant2-postype"))
        self.lineEdit15.setToolTip(_translate("self", "1:gps+2:sbas+4:glo+8:gal+16:qzs+32:comp"))
        self.lineEdit15.setText(_translate("self", "61"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab_2), _translate("self", "RTKRCV（移動局）"))
        self.pushButton_read.setToolTip(_translate("self", "ファイルパスに全角文字が含まれると読み込めません。"))
        self.pushButton_read.setText(_translate("self", "読込"))
        self.label_38.setText(_translate("self", "緯度"))
        self.label_39.setText(_translate("self", "経度"))
        self.label_40.setText(_translate("self", "楕円体高"))
        self.label_41.setText(_translate("self", "平面直角座標系"))
        self.label_85.setText(_translate("self", "Ｘ座標"))
        self.label_86.setText(_translate("self", "標高"))
        self.label_87.setText(_translate("self", "Ｙ座標"))
        self.label_88.setText(_translate("self", "ジオイド高"))
        self.label_89.setText(_translate("self", "真北方向角"))
        self.label_90.setText(_translate("self", "縮尺係数"))
        self.lineEdit_ratio.setToolTip(_translate("self", "0:全て　3:Fix解"))
        self.lineEdit_ratio.setText(_translate("self", "999.9"))
        self.label_43.setText(_translate("self", "以上"))
        self.radioButton_fix.setText(_translate("self", "Fix"))
        self.radioButton_all.setText(_translate("self", "All"))
        self.radioButton_ratio.setText(_translate("self", "Ratio"))
        self.lineEdit_n.setToolTip(_translate("self", "0:全て　3:Fix解"))
        self.label_44.setText(_translate("self", "該当"))
        self.label_45.setText(_translate("self", "点"))
        self.pushButton_save.setToolTip(_translate("self", "ファイルパスに全角文字が含まれると保存できません。"))
        self.pushButton_save.setText(_translate("self", "結果保存"))
        self.pushButton_SemiDyna.setToolTip(_translate("self", "ファイルパスに全角文字が含まれると読み込めません。"))
        self.pushButton_SemiDyna.setText(_translate("self", "SemiDynaEXE"))
        self.pushButton_read2.setToolTip(_translate("self", "ファイルパスに全角文字が含まれると読み込めません。"))
        self.pushButton_read2.setText(_translate("self", "計算"))
        self.label_58.setText(_translate("self", "ﾛｸﾞﾌｧｲﾙ"))
        self.label_91.setText(_translate("self", "器械高"))
        self.pushButton_logsave.setToolTip(_translate("self", "<html><head/><body><p>抽出したログを保存します。</p><p>ファイルパスに全角文字が含まれると保存できません。</p></body></html>"))
        self.pushButton_logsave.setText(_translate("self", "ログ保存"))
        self.pushButton_kml.setToolTip(_translate("self", "ファイルパスに全角文字が含まれると作成できません。"))
        self.pushButton_kml.setText(_translate("self", "KML変換"))
        self.pushButton_sima.setToolTip(_translate("self", "ファイルパスに全角文字が含まれると保存できません。"))
        self.pushButton_sima.setText(_translate("self", "SIMA変換"))
        self.check_tenki.setText(_translate("self", "転記"))
        self.check_file.setText(_translate("self", "FILE"))
        self.check_trans2.setText(_translate("self", "BL→XY"))
        self.check_trans.setText(_translate("self", "XY→BL"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab_3), _translate("self", "平均計算"))
        self.comboBox_kei2.setToolTip(_translate("self", "系番号1〜19を指定する"))
        self.label_42.setText(_translate("self", "平面直角座標系"))
        self.par.setText(_translate("self", "SemiDyna2019.par"))
        self.le_b1.setToolTip(_translate("self", "小数点以下８桁まで指定可(degree) "))
        self.le_l1.setToolTip(_translate("self", "小数点以下８桁まで指定可(degree) "))
        self.le_x1.setToolTip(_translate("self", "小数点以下３桁まで指定可(m) "))
        self.le_y1.setToolTip(_translate("self", "小数点以下３桁まで指定可(m) "))
        self.le_h1.setToolTip(_translate("self", "小数点以下３桁まで指定可(m) "))
        self.groupBox.setTitle(_translate("self", "補正方向"))
        self.genki_konki.setText(_translate("self", "元期→今期"))
        self.konki_genki.setText(_translate("self", "今期→元期"))
        self.label_46.setText(_translate("self", "使用するパラメータ"))
        self.groupBox_2.setTitle(_translate("self", "座標値の入力"))
        self.opt_bl.setText(_translate("self", "緯度・経度"))
        self.opt_xy.setText(_translate("self", "平面直角座標"))
        self.label_47.setText(_translate("self", "緯度"))
        self.label_48.setText(_translate("self", "経度"))
        self.label_49.setText(_translate("self", "Ｘ座標"))
        self.label_50.setText(_translate("self", "Ｙ座標"))
        self.label_51.setText(_translate("self", "標高"))
        self.pushButton_keisan.setText(_translate("self", "計算"))
        self.label_52.setText(_translate("self", "標高"))
        self.label_53.setText(_translate("self", "Ｘ座標"))
        self.label_54.setText(_translate("self", "Ｙ座標"))
        self.label_55.setText(_translate("self", "緯度"))
        self.label_56.setText(_translate("self", "経度"))
        self.pushButton_hozon.setToolTip(_translate("self", "ファイルパスに全角文字が含まれると保存できません。"))
        self.pushButton_hozon.setText(_translate("self", "保存"))
        self.label_57.setText(_translate("self", "補正結果"))
        self.label_59.setText(_translate("self", "入力値"))
        self.label_60.setText(_translate("self", "ジオイド高"))
        self.label_61.setText(_translate("self", "楕円体高"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab_4), _translate("self", "SemiDynaEXE"))
        self.label_62.setText(_translate("self", "Time"))
        self.label_63.setText(_translate("self", "Ratio"))
        self.label_64.setText(_translate("self", "Y"))
        self.label_65.setText(_translate("self", "X"))
        self.epoch.setText(_translate("self", "開始"))
        self.label_66.setText(_translate("self", "方向角"))
        self.label_68.setText(_translate("self", "Y"))
        self.label_1.setText(_translate("self", "X"))
        self.label_69.setText(_translate("self", "距離"))
        self.check2.setText(_translate("self", "測点探索"))
        self.label_70.setText(_translate("self", "H"))
        self.lineEdit_epoch.setToolTip(_translate("self", "エポック"))
        self.lineEdit_epoch.setText(_translate("self", "10"))
        self.label_71.setText(_translate("self", "点名"))
        self.label_72.setText(_translate("self", "Sentence"))
        self.lineEdit_Ratio.setText(_translate("self", "999.9"))
        self.label_84.setText(_translate("self", "Ratio            　 以上"))
        self.label_73.setText(_translate("self", "Port"))
        self.label_74.setText(_translate("self", "Baudrate"))
        self.radioButton_time1.setText(_translate("self", "PC_time"))
        self.radioButton_time2.setToolTip(_translate("self", "または GPS_time"))
        self.radioButton_time2.setText(_translate("self", "UTC/GPS_time"))
        self.switch_on2.setText(_translate("self", "受信開始"))
        self.KML.setText(_translate("self", "KML"))
        self.GPX.setText(_translate("self", "GPX"))
        self.SIMA.setText(_translate("self", "SIMA"))
        self.clear_log.setText(_translate("self", "消去"))
        self.label_75.setText(_translate("self", "平面直角座標系"))
        self.read_sima.setText(_translate("self", "SIMA読込"))
        self.kensaku.setText(_translate("self", "検索"))
        self.check_leaflet.setToolTip(_translate("self", "チェックすると平均値算出後、地図にﾌﾟﾛｯﾄします。"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab_5), _translate("self", "Logger"))
        self.pushButton_install.setText(_translate("self", "RTKLIB のインストール（Raspberry Pi）"))
        self.pushButton_com.setText(_translate("self", "COMポート確認（Raspberry Pi）"))
        self.pushButton_VBS.setText(_translate("self", "起動用VBScript作成（Windows）"))
        self.textEdit_2.setHtml(_translate("self", "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"
"<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
"p, li { white-space: pre-wrap; }\n"
"</style></head><body style=\" font-family:\'MS UI Gothic\'; font-size:9pt; font-weight:400; font-style:normal;\">\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">　RTKRCV（移動局）の接続・切断方法</p>\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" color:#00aa7f;\">　-------接続-------</span></p>\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">　[接続] -&gt; Click</p>\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">　start -&gt; Enter</p>\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">　status 1 -&gt; Enter</p>\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style=\" color:#00aa7f;\">　-------切断-------</span></p>\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">　Ctrl + C</p>\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">　stop -&gt; Enter</p>\n"
"<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">　shutdown -&gt; Enter</p></body></html>"))
        self.lineEdit_URL.setText(_translate("self", "https://github.com/tomojitakasu/RTKLIB/releases/download/v2.4.3-b33/RTKLIB_2.4.3_b33.zip"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab_6), _translate("self", "Setting"))
        self.lineEdit_str2str_path.setToolTip(_translate("self", "str2str.sh_dir"))
        self.lineEdit_rtkstart_path.setToolTip(_translate("self", "rtkstar.sh_path"))
        self.lineEdit_rtkshut_path.setToolTip(_translate("self", "rtkshut.sh_path"))
        self.lineEdit_conf_path.setToolTip(_translate("self", "rtk.conf_path"))
        self.lineEdit_makefile_path.setToolTip(_translate("self", "makefile_path"))
        self.lineEdit_rtkrcv_path.setToolTip(_translate("self", "rtkrcv_run.sh_dir_path"))

# フォルダ作成-----------------------------------------------------------------------------------------------------
        if not os.path.exists(os.path.dirname(__file__) + '/log'):
            try:
                os.mkdir(os.path.dirname(__file__) + '/log')
            except:
                pass
        if not os.path.exists(os.path.dirname(__file__) + u'/data'):
            try:
                os.mkdir(os.path.dirname(__file__) + u'/data')
            except:
                pass
        if not os.path.exists(os.path.dirname(__file__) + u'/NtripCasterHost'):
            try:
                os.mkdir(os.path.dirname(__file__) + u'/NtripCasterHost')
            except:
                pass
        if not os.path.exists(os.path.dirname(__file__) + u'/RTK_CONF'):
            try:
                os.mkdir(os.path.dirname(__file__) + u'/RTK_CONF')
            except:
                pass

# Path情報---------------------------------------------------------------------------------------------------
        if sys.platform == "win32":
            pass
        else:
            osp = os.path.dirname(__file__).split('/')
            if os.path.isdir('/home/' + osp[2] + '/RTKLIB/app/consapp/'):
                makefile_path = '/home/' + osp[2] + '/RTKLIB/app/consapp/'
            else:
                makefile_path = '/home/' + osp[2] + '/RTKLIB/app/'
            try:
                self.lineEdit_makefile_path.setText(makefile_path)
                
                str2str_path = makefile_path + 'str2str/gcc/'
                self.lineEdit_str2str_path.setText(str2str_path)

                rtkstart_path = makefile_path + 'rtkrcv/gcc/rtkstart.sh'
                self.lineEdit_rtkstart_path.setText(rtkstart_path)

                rtkshut_path = makefile_path + 'rtkrcv/gcc/rtkshut.sh'
                self.lineEdit_rtkshut_path.setText(rtkshut_path)

                rtkrcv_path = makefile_path + 'rtkrcv/gcc/'
                self.lineEdit_rtkrcv_path.setText(rtkrcv_path)

                conf_path = makefile_path + 'rtkrcv/conf/'
                self.lineEdit_conf_path.setText(conf_path)
                #QMessageBox.information(self, u'チェック', makefile_path + '\n' +  str2str_path + '\n' + rtkstart_path + '\n' + rtkshut_path + '\n' + rtkrcv_path + '\n' + conf_path + '\n')
            except:
                pass


# STR2STR----------------------------------------------------------------------------------------------------------
        self.combo_port.addItem(u'ttyACM0')
        self.combo_port.addItem(u'ttyACM1')
        self.combo_port.addItem(u'ttyACM2')
        self.combo_port.addItem(u'ttyACM3')
        self.combo_port.addItem(u'ttyUSB0')
        self.combo_port.addItem(u'ttyUSB1')
        self.combo_port.addItem(u'ttyUSB2')
        self.combo_port.addItem(u'ttyUSB3')
        self.combo_port.setCurrentIndex(0)
        self.combo_baudrate.addItem(u'2400')
        self.combo_baudrate.addItem(u'4800')
        self.combo_baudrate.addItem(u'9600')
        self.combo_baudrate.addItem(u'14400')
        self.combo_baudrate.addItem(u'19200')
        self.combo_baudrate.addItem(u'38400')
        self.combo_baudrate.addItem(u'57600')
        self.combo_baudrate.addItem(u'115200')
        self.combo_baudrate.addItem(u'230400')
        self.combo_baudrate.addItem(u'460800')
        self.combo_baudrate.addItem(u'921600')
        self.combo_baudrate.setCurrentIndex(7)
        self.combo_ByteSize.addItem(u'7')
        self.combo_ByteSize.addItem(u'8')
        self.combo_ByteSize.setCurrentIndex(1)
        self.combo_Parity.addItem(u'None')
        self.combo_Parity.addItem(u'Even')
        self.combo_Parity.addItem(u'Odd')
        self.combo_Parity.setCurrentIndex(0)
        self.combo_StopBits.addItem(u'1')
        self.combo_StopBits.addItem(u'2')
        self.combo_StopBits.setCurrentIndex(0)
        self.combo_FlowControl.addItem(u'None')
        self.combo_FlowControl.addItem(u'RTS/CTS')
        self.combo_FlowControl.setCurrentIndex(0)

# RTKRCV-----------------------------------------------------------------------------------------------------------
        self.combo1.addItem(u'off')
        self.combo1.addItem(u'serial')
        self.combo1.addItem(u'file')
        self.combo1.addItem(u'tcpsvr')
        self.combo1.addItem(u'tcpcli')
        self.combo1.addItem(u'ntripcli')
        self.combo1.addItem(u'ftp')
        self.combo1.addItem(u'http')
        self.combo1.setCurrentIndex(1)
        self.combo2.addItem(u'off')
        self.combo2.addItem(u'serial')
        self.combo2.addItem(u'file')
        self.combo2.addItem(u'tcpsvr')
        self.combo2.addItem(u'tcpcli')
        self.combo2.addItem(u'ntripcli')
        self.combo2.addItem(u'ftp')
        self.combo2.addItem(u'http')
        self.combo2.setCurrentIndex(5)
        self.combo5.addItem(u'rtcm2')
        self.combo5.addItem(u'rtcm3')
        self.combo5.addItem(u'oem4')
        self.combo5.addItem(u'oem3')
        self.combo5.addItem(u'ubx')
        self.combo5.addItem(u'ss2')
        self.combo5.addItem(u'hemis')
        self.combo5.addItem(u'skytraq')
        self.combo5.addItem(u'sp3')
        self.combo5.setCurrentIndex(4)
        self.combo6.addItem(u'rtcm2')
        self.combo6.addItem(u'rtcm3')
        self.combo6.addItem(u'oem4')
        self.combo6.addItem(u'oem3')
        self.combo6.addItem(u'ubx')
        self.combo6.addItem(u'ss2')
        self.combo6.addItem(u'hemis')
        self.combo6.addItem(u'skytraq')
        self.combo6.addItem(u'sp3')
        self.combo6.setCurrentIndex(4)
        self.combo7.addItem(u'all')
        self.combo7.addItem(u'rover')
        self.combo7.addItem(u'base')
        self.combo7.addItem(u'corr')
        self.combo7.setCurrentIndex(1)
        self.combo8.addItem(u'')
        self.combo8.addItem(u'ubx_m8t_bds_raw_1hz.cmd')
        self.combo8.addItem(u'ubx_m8t_bds_raw_5hz.cmd')
        self.combo8.addItem(u'ubx_m8t_glo_raw_1hz.cmd')
        self.combo8.addItem(u'ubx_m8t_glo_raw_5hz.cmd')
        self.combo8.addItem(u'ubx_m8n_bds_raw_1hz.cmd')
        self.combo8.addItem(u'ubx_m8n_glo_raw_1hz.cmd')
        self.combo8.addItem(u'ubx__raw_1hz.cmd')
        self.combo8.addItem(u'ubx__raw_5hz.cmd')
        self.combo8.addItem(u'ubx__raw_10hz.cmd')
        self.combo8.addItem(u'oem4_raw_1hz.cmd')
        self.combo8.addItem(u'oem4_raw_5hz.cmd')
        self.combo8.addItem(u'oem4_raw_10hz.cmd')
        self.combo8.addItem(u'oem4_raw_20hz.cmd')
        self.combo8.addItem(u'oem4_rtcm2_1hz.cmd')
        self.combo8.addItem(u'oem4_rtcm2_10hz.cmd')
        self.combo8.addItem(u'oem4_rtcm3_1hz.cmd')
        self.combo8.addItem(u'oem4_rtcm3_10hz.cmd')
        self.combo8.setCurrentIndex(0)
        self.combo9.addItem(u'')
        self.combo9.addItem(u'ubx_m8t_bds_raw_1hz.cmd')
        self.combo9.addItem(u'ubx_m8t_bds_raw_5hz.cmd')
        self.combo9.addItem(u'ubx_m8t_glo_raw_1hz.cmd')
        self.combo9.addItem(u'ubx_m8t_glo_raw_5hz.cmd')
        self.combo9.addItem(u'ubx_m8n_bds_raw_1hz.cmd')
        self.combo9.addItem(u'ubx_m8n_glo_raw_1hz.cmd')
        self.combo9.addItem(u'ubx__raw_1hz.cmd')
        self.combo9.addItem(u'ubx__raw_5hz.cmd')
        self.combo9.addItem(u'ubx__raw_10hz.cmd')
        self.combo9.addItem(u'oem4_raw_1hz.cmd')
        self.combo9.addItem(u'oem4_raw_5hz.cmd')
        self.combo9.addItem(u'oem4_raw_10hz.cmd')
        self.combo9.addItem(u'oem4_raw_20hz.cmd')
        self.combo9.addItem(u'oem4_rtcm2_1hz.cmd')
        self.combo9.addItem(u'oem4_rtcm2_10hz.cmd')
        self.combo9.addItem(u'oem4_rtcm3_1hz.cmd')
        self.combo9.addItem(u'oem4_rtcm3_10hz.cmd')
        self.combo9.setCurrentIndex(0)
        self.combo10.addItem(u'single')
        self.combo10.addItem(u'dgps')
        self.combo10.addItem(u'kinematic')
        self.combo10.addItem(u'statice')
        self.combo10.addItem(u'movingbase')
        self.combo10.addItem(u'fixed')
        self.combo10.addItem(u'ppp-kine')
        self.combo10.addItem(u'ppp-static')
        self.combo10.setCurrentIndex(2)
        self.combo11.addItem(u'l1')
        self.combo11.addItem(u'l1+l2')
        self.combo11.addItem(u'l1+l2+l5')
        self.combo11.setCurrentIndex(0)
        self.combo16.addItem(u'off')
        self.combo16.addItem(u'continuous')
        self.combo16.addItem(u'instantaneous')
        self.combo16.addItem(u'fix-and-hold')
        self.combo16.setCurrentIndex(3)
        self.combo17.addItem(u'llh')
        self.combo17.addItem(u'xyz')
        self.combo17.addItem(u'single')
        self.combo17.addItem(u'posfile')
        self.combo17.addItem(u'rinexhead')
        self.combo17.addItem(u'rtcm')
        self.combo17.setCurrentIndex(0)
        self.combo21.addItem(u'off')
        self.combo21.addItem(u'serial')
        self.combo21.addItem(u'file')
        self.combo21.addItem(u'tcpsvr')
        self.combo21.addItem(u'tcpcli')
        self.combo21.addItem(u'ntripsvr')
        self.combo21.setCurrentIndex(2)
        self.combo22.addItem(u'off')
        self.combo22.addItem(u'serial')
        self.combo22.addItem(u'file')
        self.combo22.addItem(u'tcpsvr')
        self.combo22.addItem(u'tcpcli')
        self.combo22.addItem(u'ntripsvr')
        self.combo22.setCurrentIndex(2)
        self.combo23.addItem(u'llh')
        self.combo23.addItem(u'xyz')
        self.combo23.addItem(u'enu')
        self.combo23.addItem(u'nmea')
        self.combo23.setCurrentIndex(0)
        self.combo24.addItem(u'llh')
        self.combo24.addItem(u'xyz')
        self.combo24.addItem(u'enu')
        self.combo24.addItem(u'nmea')
        self.combo24.setCurrentIndex(0)
        self.combo_Rover.addItem(u'off')
        self.combo_Rover.addItem(u'on')
        self.combo_Rover.setCurrentIndex(0)
        self.combo_Base.addItem(u'off')
        self.combo_Base.addItem(u'on')
        self.combo_Base.setCurrentIndex(0)
        self.combo_cmd.addItem(u'')
        self.combo_cmd.addItem(u'ubx_m8t_bds_raw_1hz.cmd')
        self.combo_cmd.addItem(u'ubx_m8t_bds_raw_5hz.cmd')
        self.combo_cmd.addItem(u'ubx_m8t_glo_raw_1hz.cmd')
        self.combo_cmd.addItem(u'ubx_m8t_glo_raw_5hz.cmd')
        self.combo_cmd.addItem(u'ubx_m8n_bds_raw_1hz.cmd')
        self.combo_cmd.addItem(u'ubx_m8n_glo_raw_1hz.cmd')
        self.combo_cmd.addItem(u'ubx__raw_1hz.cmd')
        self.combo_cmd.addItem(u'ubx__raw_5hz.cmd')
        self.combo_cmd.addItem(u'ubx__raw_10hz.cmd')
        self.combo_cmd.addItem(u'oem4_raw_1hz.cmd')
        self.combo_cmd.addItem(u'oem4_raw_5hz.cmd')
        self.combo_cmd.addItem(u'oem4_raw_10hz.cmd')
        self.combo_cmd.addItem(u'oem4_raw_20hz.cmd')
        self.combo_cmd.addItem(u'oem4_rtcm2_1hz.cmd')
        self.combo_cmd.addItem(u'oem4_rtcm2_10hz.cmd')
        self.combo_cmd.addItem(u'oem4_rtcm3_1hz.cmd')
        self.combo_cmd.addItem(u'oem4_rtcm3_10hz.cmd')
        self.combo_cmd.setCurrentIndex(0)

# 平均計算---------------------------------------------------------------------------------------------------------
        self.comboBox_kei.addItem(u' 1系')
        self.comboBox_kei.addItem(u' 2系')
        self.comboBox_kei.addItem(u' 3系')
        self.comboBox_kei.addItem(u' 4系')
        self.comboBox_kei.addItem(u' 5系')
        self.comboBox_kei.addItem(u' 6系')
        self.comboBox_kei.addItem(u' 7系')
        self.comboBox_kei.addItem(u' 8系')
        self.comboBox_kei.addItem(u' 9系')
        self.comboBox_kei.addItem(u'10系')
        self.comboBox_kei.addItem(u'11系')
        self.comboBox_kei.addItem(u'12系')
        self.comboBox_kei.addItem(u'13系')
        self.comboBox_kei.addItem(u'14系')
        self.comboBox_kei.addItem(u'15系')
        self.comboBox_kei.addItem(u'16系')
        self.comboBox_kei.addItem(u'17系')
        self.comboBox_kei.addItem(u'18系')
        self.comboBox_kei.addItem(u'19系')
        self.comboBox_kei.setCurrentIndex(12)

# SemiDynaEXE------------------------------------------------------------------------------------------------------
        self.comboBox_kei2.addItem(u' 1系')
        self.comboBox_kei2.addItem(u' 2系')
        self.comboBox_kei2.addItem(u' 3系')
        self.comboBox_kei2.addItem(u' 4系')
        self.comboBox_kei2.addItem(u' 5系')
        self.comboBox_kei2.addItem(u' 6系')
        self.comboBox_kei2.addItem(u' 7系')
        self.comboBox_kei2.addItem(u' 8系')
        self.comboBox_kei2.addItem(u' 9系')
        self.comboBox_kei2.addItem(u'10系')
        self.comboBox_kei2.addItem(u'11系')
        self.comboBox_kei2.addItem(u'12系')
        self.comboBox_kei2.addItem(u'13系')
        self.comboBox_kei2.addItem(u'14系')
        self.comboBox_kei2.addItem(u'15系')
        self.comboBox_kei2.addItem(u'16系')
        self.comboBox_kei2.addItem(u'17系')
        self.comboBox_kei2.addItem(u'18系')
        self.comboBox_kei2.addItem(u'19系')
        self.comboBox_kei2.setCurrentIndex(12)

# Logger-----------------------------------------------------------------------------------------------------------
        self.kei.addItem(u'世界測地系 （JGD2011）  1 系 ： EPSG:6669')
        self.kei.addItem(u'世界測地系 （JGD2011）  2 系 ： EPSG:6670')
        self.kei.addItem(u'世界測地系 （JGD2011）  3 系 ： EPSG:6671')
        self.kei.addItem(u'世界測地系 （JGD2011）  4 系 ： EPSG:6672')
        self.kei.addItem(u'世界測地系 （JGD2011）  5 系 ： EPSG:6673')
        self.kei.addItem(u'世界測地系 （JGD2011）  6 系 ： EPSG:6674')
        self.kei.addItem(u'世界測地系 （JGD2011）  7 系 ： EPSG:6675')
        self.kei.addItem(u'世界測地系 （JGD2011）  8 系 ： EPSG:6676')
        self.kei.addItem(u'世界測地系 （JGD2011）  9 系 ： EPSG:6677')
        self.kei.addItem(u'世界測地系 （JGD2011） 10 系 ： EPSG:6678')
        self.kei.addItem(u'世界測地系 （JGD2011） 11 系 ： EPSG:6679')
        self.kei.addItem(u'世界測地系 （JGD2011） 12 系 ： EPSG:6680')
        self.kei.addItem(u'世界測地系 （JGD2011） 13 系 ： EPSG:6681')
        self.kei.addItem(u'世界測地系 （JGD2011） 14 系 ： EPSG:6682')
        self.kei.addItem(u'世界測地系 （JGD2011） 15 系 ： EPSG:6683')
        self.kei.addItem(u'世界測地系 （JGD2011） 16 系 ： EPSG:6684')
        self.kei.addItem(u'世界測地系 （JGD2011） 17 系 ： EPSG:6685')
        self.kei.addItem(u'世界測地系 （JGD2011） 18 系 ： EPSG:6686')
        self.kei.addItem(u'世界測地系 （JGD2011） 19 系 ： EPSG:6687')
        self.kei.setCurrentIndex(12)
        self.comboBox_port.addItem(u'COM1')
        self.comboBox_port.addItem(u'COM2')
        self.comboBox_port.addItem(u'COM3')
        self.comboBox_port.addItem(u'COM4')
        self.comboBox_port.addItem(u'COM5')
        self.comboBox_port.addItem(u'COM6')
        self.comboBox_port.addItem(u'COM7')
        self.comboBox_port.addItem(u'COM8')
        self.comboBox_port.addItem(u'COM9')
        self.comboBox_port.addItem(u'COM10')
        self.comboBox_port.addItem(u'COM11')
        self.comboBox_port.addItem(u'COM12')
        self.comboBox_port.addItem(u'ttyUSB0')
        self.comboBox_port.addItem(u'ttyUSB1')
        self.comboBox_port.addItem(u'ttyACM0')
        self.comboBox_port.addItem(u'ttyACM1')
        self.comboBox_port.addItem(u'ttyACM2')
        self.comboBox_port.setCurrentIndex(2)
        self.comboBox_baudrate.addItem(u'4800')
        self.comboBox_baudrate.addItem(u'9600')
        self.comboBox_baudrate.addItem(u'14400')
        self.comboBox_baudrate.addItem(u'19200')
        self.comboBox_baudrate.addItem(u'38400')
        self.comboBox_baudrate.addItem(u'57600')
        self.comboBox_baudrate.addItem(u'115200')
        self.comboBox_baudrate.addItem(u'230400')
        self.comboBox_baudrate.addItem(u'460800')
        self.comboBox_baudrate.addItem(u'921600')
        self.comboBox_baudrate.setCurrentIndex(1)
        self.comboBox_sentence.addItem(u'GNRMC/GPRMC')
        self.comboBox_sentence.addItem(u'GNGGA/GPGGA')
        self.comboBox_sentence.addItem(u'GNGLL/GPGLL')
        self.comboBox_sentence.addItem(u'NMEA')
        self.comboBox_sentence.addItem(u'RTKNAVI_FIX')
        self.comboBox_sentence.addItem(u'RTKNAVI_ALL')
        self.comboBox_sentence.addItem(u'RTKNAVI_RATIO')
        self.comboBox_sentence.addItem(u'TCP_FIX')
        self.comboBox_sentence.addItem(u'TCP_ALL')
        self.comboBox_sentence.addItem(u'TCP_RATIO')
        self.comboBox_sentence.setCurrentIndex(0)

# Setting----------------------------------------------------------------------------------------------------------
        if sys.platform == "win32":
            self.pushButton_install.setEnabled(False)
            self.pushButton_com.setEnabled(False)
            self.pushButton_VBS.setEnabled(True)
            self.pushButton_Desktop.setEnabled(False)
        else:
            self.pushButton_install.setEnabled(True)
            self.pushButton_com.setEnabled(True)
            self.pushButton_VBS.setEnabled(False)
            self.pushButton_Desktop.setEnabled(True)

# RTK_TOOL3.iniより設定復元----------------------------------------------------------------------------------------

        # ファイルリストを追加（NtripCasterHost）
        global flag2
        flag2 = 0
        datdir = os.path.dirname(__file__) + u'/NtripCasterHost'
        self.combo_sh.clear()
        self.combo_sh.addItem('')
        for root, dirs, files in os.walk(datdir):
            for file in files:
                if file.lower()[-4:] == '.dat' and file.lower()[-8:] != '_msg.dat':
                    self.combo_sh.addItem(str(file).replace('.dat', ''))
        flag2 = 1

        # ファイルリストを追加（RTK_CONF）
        datdir = os.path.dirname(__file__) + u'/RTK_CONF'
        self.combo_path.clear()
        self.combo_path.addItem('')
        for root, dirs, files in os.walk(datdir):
            for file in files:
                if file.lower()[-4:] == '.dat':
                    self.combo_path.addItem(str(file).replace('.dat', ''))

        settingfname = os.path.dirname(__file__) + u'/RTK_TOOL3.ini'
        if os.path.exists(settingfname):
            try:
                for line in codecs.open(settingfname,'r', 'utf-8'):
                    dat = line.replace('\n','').split('=')
                    # STR2STR----------------------------------------------------------------------
                    if 'select_mountpoint1' in line:
                        try:
                            self.combo_sh.setCurrentIndex(int(dat[1]))       #select_mountpoint1
                        except:
                            self.combo_sh.setCurrentIndex(0)
                    elif 'serial_port' in line:
                        self.combo_port.setCurrentIndex(int(dat[1]))         #serial_port
                    elif 'serial_baudrate' in line:
                        self.combo_baudrate.setCurrentIndex(int(dat[1]))     #serial_baudrate
                    elif 'serial_bytesize' in line:
                        self.combo_ByteSize.setCurrentIndex(int(dat[1]))     #serial_bytesize
                    elif 'serial_parity' in line:
                        self.combo_Parity.setCurrentIndex(int(dat[1]))       #serial_parity
                    elif 'serial_stopbits' in line:
                        self.combo_StopBits.setCurrentIndex(int(dat[1]))     #serial_stopbits
                    elif 'serial_flowcontrol' in line:
                        self.combo_FlowControl.setCurrentIndex(int(dat[1]))  #serial_flowcontrol
                    elif 'ntrip_host' in line:
                        self.lineEdit_Host.setText(dat[1])                   #ntrip_host
                    elif 'ntrip_port' in line:
                        self.lineEdit_Port.setText(dat[1])                   #ntrip_port
                    elif 'ntrip_mountpoint' in line:
                        self.lineEdit_Mountpoint.setText(dat[1])             #ntrip_mountpoint
                    elif 'ntrip_id' in line:
                        self.lineEdit_ID.setText(dat[1])                     #ntrip_id
                    elif 'ntrip_password' in line:
                        self.lineEdit_Pass.setText(dat[1])                   #ntrip_password
                    elif 'ntrip_string' in line:
                        self.textEdit_String.clear()                         #ntrip_string
                        self.textEdit_String.append(dat[1])
                    elif 'cmd' in line:
                        self.combo_cmd.setCurrentIndex(int(dat[1]))          #cmd
                    elif 'ntrip_msg' in line:
                        self.textEdit_msg.clear()                            #ntrip_msg
                        self.textEdit_msg.append(dat[1])
                    elif 'string_check' in line:
                        if dat[1] =='0':                                     #string_check
                            self.checkBox_String.setChecked(False)
                        else:
                            self.checkBox_String.setChecked(True)
                    elif 'conv_check' in line:
                        if dat[1] =='0':                                     #conv_check
                            self.checkBox_conv.setChecked(False)
                        else:
                            self.checkBox_conv.setChecked(True)
                    elif 'lat' in line:
                        self.base_lat.setText(dat[1])                        #lat
                    elif 'lon' in line:
                        self.base_lon.setText(dat[1])                        #lon
                    elif 'alt' in line:
                        self.base_alt.setText(dat[1])                        #alt
                    elif 'Output' in line:                                   #Output ('' = NTRIP Server／'TCP' = TCP Server)
                        if dat[1] == '':
                            self.radio_Output1.setChecked(True)
                            self.lineEdit_Host.setEnabled(True)
                            self.lineEdit_ID.setEnabled(True)
                            self.lineEdit_Pass.setEnabled(True)
                        else:
                            self.radio_Output2.setChecked(True)
                            self.lineEdit_Host.setEnabled(False)
                            self.lineEdit_ID.setEnabled(False)
                            self.lineEdit_Pass.setEnabled(False)
                    # RTKRCV-----------------------------------------------------------------------
                    elif 'select_mountpoint2' in line:
                        try:
                            self.combo_path.setCurrentIndex(int(dat[1]))     #select_mountpoint2
                        except:
                            self.combo_path.setCurrentIndex(0)
                    elif 'inpstr1-type' in line:
                        self.combo1.setCurrentIndex(int(dat[1]))             #inpstr1-type
                    elif 'inpstr2-type' in line:
                        self.combo2.setCurrentIndex(int(dat[1]))             #inpstr2-type
                    elif 'inpstr1-path' in line:
                        self.lineEdit3.setText(dat[1])                       #inpstr1-path
                    elif 'inpstr2-path' in line:
                        self.lineEdit4.setText(dat[1])                       #inpstr2-path
                    elif 'inpstr1-format' in line:
                        self.combo5.setCurrentIndex(int(dat[1]))             #inpstr1-format
                    elif 'inpstr2-format' in line:
                        self.combo6.setCurrentIndex(int(dat[1]))             #inpstr2-format
                    elif 'misc-navmsgsel' in line:
                        self.combo7.setCurrentIndex(int(dat[1]))             #misc-navmsgsel
                    elif 'file-cmdfile1' in line:
                        self.combo8.setCurrentIndex(int(dat[1]))             #file-cmdfile1
                    elif 'file-cmdfile2' in line:
                        self.combo9.setCurrentIndex(int(dat[1]))             #file-cmdfile2
                    elif 'pos1-posmode' in line:
                        self.combo10.setCurrentIndex(int(dat[1]))            #pos1-posmode
                    elif 'pos1-frequency' in line:
                        self.combo11.setCurrentIndex(int(dat[1]))            #pos1-frequency
                    elif 'pos1-elmask' in line:
                        self.lineEdit12.setText(dat[1])                      #pos1-elmask
                    elif 'pos1-snrmask_rover' in line:
                        self.combo_Rover.setCurrentIndex(int(dat[1]))        #pos1-snrmask_rover
                    elif 'pos1-snrmask_base' in line:
                        self.combo_Base.setCurrentIndex(int(dat[1]))         #pos1-snrmask_base
                    elif 'pos1-snrmask_L1' in line:
                        self.lineEditL1.setText(dat[1])                      #pos1-snrmask_L1
                    elif 'pos1-snrmask_L2' in line:
                        self.lineEditL2.setText(dat[1])                      #pos1-snrmask_L2
                    elif 'pos1-snrmask_L5' in line:
                        self.lineEditL5.setText(dat[1])                      #pos1-snrmask_L5
                    elif 'pos1-exclsats' in line:
                        self.lineEdit14.setText(dat[1])                      #pos1-exclsats
                    elif 'pos1-navsys' in line:
                        self.lineEdit15.setText(dat[1])                      #pos1-navsys
                    elif 'pos2-armode' in line:
                        self.combo16.setCurrentIndex(int(dat[1]))            #pos2-armode
                    elif 'ant2-postype' in line:
                        self.combo17.setCurrentIndex(int(dat[1]))            #ant2-postype
                    elif 'ant2-pos1' in line:
                        self.lineEdit18.setText(dat[1])                      #ant2-pos1
                    elif 'ant2-pos2' in line:
                        self.lineEdit19.setText(dat[1])                      #ant2-pos2
                    elif 'ant2-pos3' in line:
                        self.lineEdit20.setText(dat[1])                      #ant2-pos3
                    elif 'outstr1-type' in line:
                        self.combo21.setCurrentIndex(int(dat[1]))            #outstr1-type
                    elif 'outstr2-type' in line:
                        self.combo22.setCurrentIndex(int(dat[1]))            #outstr2-type
                    elif 'outstr1-format' in line:
                        self.combo23.setCurrentIndex(int(dat[1]))            #outstr1-format
                    elif 'outstr2-format' in line:
                        self.combo24.setCurrentIndex(int(dat[1]))            #outstr2-format
                    elif 'outstr1-path' in line:
                        self.lineEdit_out1path.setText(dat[1])               #outstr1-path
                    elif 'outstr2-path' in line:
                        self.lineEdit_out2path.setText(dat[1])               #outstr2-path
                    elif 'm-option' in line:
                        if dat[1] == '1':
                            self.checkBox_mOption.setChecked(True)           #m-option
                        else:
                            self.checkBox_mOption.setChecked(False)
                    # 平均計算---------------------------------------------------------------------
                    elif 'kei1' in line:
                        self.comboBox_kei.setCurrentIndex(int(dat[1]))       #kei1
                    # SemiDynaEXE------------------------------------------------------------------
                    elif 'kei2' in line:
                        self.comboBox_kei2.setCurrentIndex(int(dat[1]))      #kei2
                    elif 'par' in line:
                        self.par.setText(dat[1].replace('\n', ''))           #par
                        if dat[1].replace('\n', '') == '':
                            self.par.setText('SemiDyna2019.par')
                    # Logger-----------------------------------------------------------------------
                    elif 'kei3' in line:
                        self.kei.setCurrentIndex(int(dat[1]))                #kei3
                    elif 'logger_port' in line:
                        self.comboBox_port.setCurrentIndex(int(dat[1]))      #logger_port
                    elif 'logger_baudrate' in line:
                        self.comboBox_baudrate.setCurrentIndex(int(dat[1]))  #logger_baudrate
                    elif 'sentence' in line:
                        self.comboBox_sentence.setCurrentIndex(int(dat[1]))  #sentence
                    elif 'time' in line:
                        if dat[1] == '1':                                    #time
                            self.radioButton_time1.setChecked(True)
                            self.radioButton_time2.setChecked(False)
                        else:
                            self.radioButton_time1.setChecked(False)
                            self.radioButton_time2.setChecked(True)
                    elif 'leaflet' in line:
                        if dat[1] == '1':
                            self.check_leaflet.setChecked(True)              #leaflet
                        else:
                            self.check_leaflet.setChecked(False)             #leaflet
            except:
                # STR2STR--------------------------------------------------------------------------
                self.combo_sh.setCurrentIndex(0)                             #select_mountpoint1
                self.combo_port.setCurrentIndex(0)                           #serial_port
                self.combo_baudrate.setCurrentIndex(7)                       #serial_baudrate
                self.combo_ByteSize.setCurrentIndex(1)                       #serial_bytesize
                self.combo_Parity.setCurrentIndex(0)                         #serial_parity
                self.combo_StopBits.setCurrentIndex(0)                       #serial_stopbits
                self.combo_FlowControl.setCurrentIndex(0)                    #serial_flowcontrol
                self.lineEdit_Host.setText('')                               #ntrip_host
                self.lineEdit_Port.setText('')                               #ntrip_port
                self.lineEdit_Mountpoint.setText('')                         #ntrip_mountpoint
                self.lineEdit_ID.setText('')                                 #ntrip_id
                self.lineEdit_Pass.setText('')                               #ntrip_password
                self.textEdit_String.clear()                                 #ntrip_string
                self.combo_cmd.setCurrentIndex(0)                            #cmd
                self.textEdit_msg.clear()                                    #ntrip_msg
                self.checkBox_String.setChecked(False)                       #check_string
                self.checkBox_conv.setChecked(False)                         #check_conv
                self.base_lat.setText('')                                    #lat
                self.base_lon.setText('')                                    #lon
                self.base_alt.setText('')                                    #alt
                # RTKRCV---------------------------------------------------------------------------
                self.combo_path.setCurrentIndex(0)                           #select_mountpoint2
                self.combo1.setCurrentIndex(1)                               #inpstr1-type
                self.combo2.setCurrentIndex(5)                               #inpstr2-type
                self.lineEdit3.setText('ttyACM0:115200:8:n:1:off')           #inpstr1-path
                self.lineEdit4.setText('')                                   #inpstr2-path
                self.combo5.setCurrentIndex(4)                               #inpstr1-format
                self.combo6.setCurrentIndex(4)                               #inpstr2-format
                self.combo7.setCurrentIndex(1)                               #misc-navmsgsel
                self.combo8.setCurrentIndex(0)                               #file-cmdfile1
                self.combo9.setCurrentIndex(0)                               #file-cmdfile2
                self.combo10.setCurrentIndex(2)                              #pos1-posmode
                self.combo11.setCurrentIndex(0)                              #pos1-frequency
                self.lineEdit12.setText('20')                                #pos1-elmask
                self.combo_Rover.setCurrentIndex(0)                          #pos1-snrmask_rover
                self.combo_Base.setCurrentIndex(0)                           #pos1-snrmask_base
                self.lineEditL1.setText('35,35,35,35,35,35,35,35,35')        #pos1-snrmask_L1
                self.lineEditL2.setText('35,35,35,35,35,35,35,35,35')        #pos1-snrmask_L2
                self.lineEditL5.setText('35,35,35,35,35,35,35,35,35')        #pos1-snrmask_L5
                self.lineEdit14.setText('C02')                               #pos1-exclsats
                self.lineEdit15.setText('61')                                #pos1-navsys
                self.combo16.setCurrentIndex(3)                              #pos2-armode
                self.combo17.setCurrentIndex(0)                              #ant2-postype
                self.lineEdit18.setText(u'Lat')                              #ant2-pos1
                self.lineEdit19.setText(u'Lon')                              #ant2-pos2
                self.lineEdit20.setText(u'Alt')                              #ant2-pos3
                self.combo21.setCurrentIndex(2)                              #outstr1-type
                self.combo22.setCurrentIndex(2)                              #outstr2-type
                self.combo23.setCurrentIndex(0)                              #outstr1-format
                self.combo24.setCurrentIndex(0)                              #outstr2-format
                self.lineEdit_out1path.setText('/home/' + osp[2] + '/RTK_TOOL3/log/')    #outstr1-path
                self.lineEdit_out2path.setText('/home/' + osp[2] + '/RTK_TOOL3/log/')    #outstr2-path
                self.checkBox_mOption.setChecked(True)                       #m-option
                # 平均計算-------------------------------------------------------------------------
                self.comboBox_kei.setCurrentIndex(12)                        #kei1
                # SemiDynaEXE----------------------------------------------------------------------
                self.comboBox_kei2.setCurrentIndex(12)                       #kei2
                self.par.setText('SemiDyna2019.par')                         #par
                # Logger---------------------------------------------------------------------------
                self.kei.setCurrentIndex(12)                                 #kei3
                self.comboBox_port.setCurrentIndex(0)                        #logger_port
                self.comboBox_baudrate.setCurrentIndex(1)                    #logger_baudrate
                self.comboBox_sentence.setCurrentIndex(0)                    #sentence
                self.radioButton_time1.setChecked(True)                      #time
                self.radioButton_time2.setChecked(False)
                self.check_leaflet.setChecked(True)                          #leaflet
        else:
            # STR2STR-----------------------------------------------------------------------------
            self.combo_sh.setCurrentIndex(0)                                 #select_mountpoint1
            self.combo_port.setCurrentIndex(0)                               #serial_port
            self.combo_baudrate.setCurrentIndex(7)                           #serial_baudrate
            self.combo_ByteSize.setCurrentIndex(1)                           #serial_bytesize
            self.combo_Parity.setCurrentIndex(0)                             #serial_parity
            self.combo_StopBits.setCurrentIndex(0)                           #serial_stopbits
            self.combo_FlowControl.setCurrentIndex(0)                        #serial_flowcontrol
            self.lineEdit_Host.setText('')                                   #ntrip_host
            self.lineEdit_Port.setText('')                                   #ntrip_port
            self.lineEdit_Mountpoint.setText('')                             #ntrip_mountpoint
            self.lineEdit_ID.setText('')                                     #ntrip_id
            self.lineEdit_Pass.setText('')                                   #ntrip_password
            self.textEdit_String.clear()                                     #ntrip_string
            self.combo_cmd.setCurrentIndex(0)                                #cmd
            self.textEdit_msg.clear()                                        #ntrip_msg
            self.checkBox_String.setChecked(False)                           #check_string
            self.checkBox_conv.setChecked(False)                             #check_conv
            self.base_lat.setText('')                                        #lat
            self.base_lon.setText('')                                        #lon
            self.base_alt.setText('')                                        #alt
            # RTKRCV-----------------------------------------------------------------------------
            self.combo_path.setCurrentIndex(0)                               #select_mountpoint2
            self.combo1.setCurrentIndex(1)                                   #inpstr1-type
            self.combo2.setCurrentIndex(5)                                   #inpstr2-type
            self.lineEdit3.setText('ttyACM0:115200:8:n:1:off')               #inpstr1-path
            self.lineEdit4.setText('')                                       #inpstr2-path
            self.combo5.setCurrentIndex(4)                                   #inpstr1-format
            self.combo6.setCurrentIndex(4)                                   #inpstr2-format
            self.combo7.setCurrentIndex(1)                                   #misc-navmsgsel
            self.combo8.setCurrentIndex(0)                                   #file-cmdfile1
            self.combo9.setCurrentIndex(0)                                   #file-cmdfile2
            self.combo10.setCurrentIndex(2)                                  #pos1-posmode
            self.combo11.setCurrentIndex(0)                                  #pos1-frequency
            self.lineEdit12.setText('20')                                    #pos1-elmask
            self.combo_Rover.setCurrentIndex(0)                              #pos1-snrmask_rove
            self.combo_Base.setCurrentIndex(0)                               #pos1-snrmask_base
            self.lineEditL1.setText('35,35,35,35,35,35,35,35,35')            #pos1-snrmask_L1
            self.lineEditL2.setText('35,35,35,35,35,35,35,35,35')            #pos1-snrmask_L2
            self.lineEditL5.setText('35,35,35,35,35,35,35,35,35')            #pos1-snrmask_L5
            self.lineEdit14.setText('C02')                                   #pos1-exclsats
            self.lineEdit15.setText('61')                                    #pos1-navsys
            self.combo16.setCurrentIndex(3)                                  #pos2-armode
            self.combo17.setCurrentIndex(0)                                  #ant2-postype
            self.lineEdit18.setText(u'Lat')                                  #ant2-pos1
            self.lineEdit19.setText(u'Lon')                                  #ant2-pos2
            self.lineEdit20.setText(u'Alt')                                  #ant2-pos3
            self.combo21.setCurrentIndex(2)                                  #outstr1-type
            self.combo22.setCurrentIndex(2)                                  #outstr2-type
            self.combo23.setCurrentIndex(0)                                  #outstr1-format
            self.combo24.setCurrentIndex(0)                                  #outstr2-format
            self.lineEdit_out1path.setText('/home/' + osp[2] + '/RTK_TOOL3/log/')        #outstr1-path
            self.lineEdit_out2path.setText('/home/' + osp[2] + '/RTK_TOOL3/log/')        #outstr2-path
            self.checkBox_mOption.setChecked(True)                           #m-option
            # 平均計算---------------------------------------------------------------------------
            self.comboBox_kei.setCurrentIndex(12)                            #kei1
            # SemiDynaEXE------------------------------------------------------------------------
            self.comboBox_kei2.setCurrentIndex(12)                           #kei2
            self.par.setText('SemiDyna2019.par')                             #par
            # Logger-----------------------------------------------------------------------------                                                         
            self.kei.setCurrentIndex(12)                                     #kei3
            self.comboBox_port.setCurrentIndex(0)                            #logger_port
            self.comboBox_baudrate.setCurrentIndex(1)                        #logger_baudrate
            self.comboBox_sentence.setCurrentIndex(0)                        #sentence
            self.radioButton_time1.setChecked(True)                          #time
            self.radioButton_time2.setChecked(False)
            self.check_leaflet.setChecked(True)                              #leaflet
            self.save_setting()

        self.show()

# signal-----------------------------------------------------------------------------------------------------------
        self.combo_sh.currentIndexChanged.connect(self.SetList)
        self.combo_path.currentIndexChanged.connect(self.SetList2)
        self.switch_on.clicked.connect(self.on_off)
        self.save.clicked.connect(self.sh_save)
        self.pushButton1.clicked.connect(self.getPath)
        self.pushButton2.clicked.connect(self.on_off2)
        self.pushButton3.clicked.connect(self.sh_save2)
        self.pushButton_install.clicked.connect(self.rtklib_install)
        self.pushButton_Desktop.clicked.connect(self.make_sh)
        self.pushButton_read.clicked.connect(self.read_log)
        self.pushButton_read2.clicked.connect(self.saikeisan)
        self.pushButton_save.clicked.connect(self.save_result)
        self.pushButton_com.clicked.connect(self.check_com)
        self.pushButton_SemiDyna.clicked.connect(self.tenki)
        self.pushButton_keisan.clicked.connect(self.SemiDynaEXE)
        self.pushButton_hozon.clicked.connect(self.hozon)
        self.pushButton_logsave.clicked.connect(self.logsave)
        self.pushButton_kml.clicked.connect(self.kml)
        self.pushButton_sima.clicked.connect(self.sima)
        self.pushButton_VBS.clicked.connect(self.make_vbs)
        self.switch_on2.toggled.connect(self.on_off3)
        self.clear_log.clicked.connect(self.clearlog)
        self.check2.clicked.connect(self.SetEnable)
        self.GPX.clicked.connect(self.gpx_save)
        self.SIMA.clicked.connect(self.sima_save)
        self.KML.clicked.connect(self.kml_save)
        self.kei.setCurrentIndex(12)
        self.epoch.clicked.connect(self.changeText)
        self.comboBox_sentence.currentIndexChanged.connect(self.SetEnable2)
        self.read_sima.clicked.connect(self.open_sima)
        self.listWidget.itemClicked.connect(self.itemClick)
        self.kensaku.clicked.connect(self.knsk)
        self.sample.clicked.connect(self.sample_string)
        self.sample2.clicked.connect(self.sample_msg)
        self.check_trans.clicked.connect(self.ChangeTitle)
        self.check_trans2.clicked.connect(self.ChangeTitle)
        self.check_file.clicked.connect(self.ChangeTitle)
        self.combo21.currentIndexChanged.connect(self.SetPath1)
        self.combo22.currentIndexChanged.connect(self.SetPath2)
        self.radio_Output1.clicked.connect(self.SetOutput)
        self.radio_Output2.clicked.connect(self.SetOutput)


# 共通-------------------------------------------------------------------------------------------------------------
    # ×ボタンがクリックされた時
    def closeEvent(self,event):
        self.save_setting()

    # 設定保存
    def save_setting(self):
        settingfname = os.path.dirname(__file__) + u'/RTK_TOOL3.ini'
        setting_text = ''
        for line in codecs.open(settingfname,'r', 'utf-8'):
            dat = line.replace('\n','').split('=')
            # STR2STR
            if 'select_mountpoint1' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_sh.currentIndex()) + '\n'                     #select_mountpoint1
            elif 'serial_port' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_port.currentIndex()) + '\n'                   #serial_port
            elif 'serial_baudrate' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_baudrate.currentIndex()) + '\n'               #serial_baudrate
            elif 'serial_bytesize' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_ByteSize.currentIndex()) + '\n'               #serial_bytesize
            elif 'serial_parity' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_Parity.currentIndex()) + '\n'                 #serial_parity
            elif 'serial_stopbits' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_StopBits.currentIndex()) + '\n'               #serial_stopbits
            elif 'serial_flowcontrol' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_FlowControl.currentIndex()) + '\n'            #serial_flowcontrol
            elif 'ntrip_host' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit_Host.text() + '\n'                             #ntrip_host
            elif 'ntrip_port' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit_Port.text() + '\n'                             #ntrip_port
            elif 'ntrip_mountpoint' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit_Mountpoint.text() + '\n'                       #ntrip_mountpoint
            elif 'ntrip_id' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit_ID.text() + '\n'                               #ntrip_id
            elif 'ntrip_password' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit_Pass.text() + '\n'                             #ntrip_password
            elif 'ntrip_string' in line:
                setting_text = setting_text + dat[0] + '=' + self.textEdit_String.toPlainText().replace('\n', '') + '\n'  #ntrip_string
            elif 'cmd' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_cmd.currentIndex()) + '\n'                    #cmd
            elif 'string_check' in line:
                if self.checkBox_String.isChecked():                                                                      #string_check
                    setting_text = setting_text + dat[0] + '=1\n'
                else:
                    setting_text = setting_text + dat[0] + '=0\n'
            elif 'conv_check' in line:
                if self.checkBox_conv.isChecked():                                                                        #conv_check
                    setting_text = setting_text + dat[0] + '=1\n'
                else:
                    setting_text = setting_text + dat[0] + '=0\n'
            elif 'ntrip_msg' in line:
                setting_text = setting_text + dat[0] + '=' + self.textEdit_msg.toPlainText().replace('\n', '') + '\n'     #ntrip_msg
            elif 'lat' in line:
                setting_text = setting_text + dat[0] + '=' + self.base_lat.text() + '\n'                                  #lat
            elif 'lon' in line:
                setting_text = setting_text + dat[0] + '=' + self.base_lon.text() + '\n'                                  #lon
            elif 'alt' in line:
                setting_text = setting_text + dat[0] + '=' + self.base_alt.text() + '\n'                                  #alt
            elif 'Output' in line:                                                                                        #Output (NTRIP Server = ''／TCP Server = 'TCP')
                if self.radio_Output1.isChecked():
                    setting_text = setting_text + dat[0] + '=' + '\n'
                else:
                    setting_text = setting_text + dat[0] + '=TCP' + '\n'
            # RTKRCV
            elif 'select_mountpoint2' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_path.currentIndex()) + '\n'                   #select_mountpoint2
            elif 'inpstr1-type' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo1.currentIndex()) + '\n'                       #inpstr1-type
            elif 'inpstr2-type' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo2.currentIndex()) + '\n'                       #inpstr2-type
            elif 'inpstr1-path' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit3.text() + '\n'                                 #inpstr1-path
            elif 'inpstr2-path' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit4.text() + '\n'                                 #inpstr2-path
            elif 'inpstr1-format' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo5.currentIndex()) + '\n'                       #inpstr1-format
            elif 'inpstr2-format' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo6.currentIndex()) + '\n'                       #inpstr2-format
            elif 'misc-navmsgsel' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo7.currentIndex()) + '\n'                       #misc-navmsgsel
            elif 'file-cmdfile1' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo8.currentIndex()) + '\n'                       #file-cmdfile1
            elif 'file-cmdfile2' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo9.currentIndex()) + '\n'                       #file-cmdfile2
            elif 'pos1-posmode' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo10.currentIndex()) + '\n'                      #pos1-posmode
            elif 'pos1-frequency' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo11.currentIndex()) + '\n'                      #pos1-frequency
            elif 'pos1-elmask' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit12.text() + '\n'                                #pos1-elmask
            elif 'pos1-snrmask_rove' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_Rover.currentIndex()) + '\n'                  #pos1-snrmask_rove
            elif 'pos1-snrmask_base' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo_Base.currentIndex()) + '\n'                   #pos1-snrmask_base
            elif 'pos1-snrmask_L1' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEditL1.text() + '\n'                                #pos1-snrmask_L1
            elif 'pos1-snrmask_L2' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEditL2.text() + '\n'                                #pos1-snrmask_L2
            elif 'pos1-snrmask_L5' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEditL5.text() + '\n'                                #pos1-snrmask_L5
            elif 'pos1-exclsats' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit14.text() + '\n'                                #pos1-exclsats
            elif 'pos1-navsys' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit15.text() + '\n'                                #pos1-navsys
            elif 'pos2-armode' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo16.currentIndex()) + '\n'                      #pos2-armode
            elif 'ant2-postype' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo17.currentIndex()) + '\n'                      #ant2-postype
            elif 'ant2-pos1' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit18.text() + '\n'                                #ant2-pos1
            elif 'ant2-pos2' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit19.text() + '\n'                                #ant2-pos2
            elif 'ant2-pos3' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit20.text() + '\n'                                #ant2-pos3
            elif 'outstr1-type' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo21.currentIndex()) + '\n'                      #outstr1-type
            elif 'outstr2-type' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo22.currentIndex()) + '\n'                      #outstr2-type
            elif 'outstr1-format' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo23.currentIndex()) + '\n'                      #outstr1-format
            elif 'outstr2-format' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.combo24.currentIndex()) + '\n'                      #outstr2-format
            elif 'outstr1-path' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit_out1path.text() + '\n'                        #outstr1-path
            elif 'outstr2-path' in line:
                setting_text = setting_text + dat[0] + '=' + self.lineEdit_out2path.text() + '\n'                        #outstr2-path
            elif 'm-option' in line:
                if self.checkBox_mOption.isChecked():
                    setting_text = setting_text + dat[0] + '=1\n'                                                         #m-option
                else:
                    setting_text = setting_text + dat[0] + '=0\n'
            # 平均計算
            elif 'kei1' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.comboBox_kei.currentIndex()) + '\n'                 #kei1
            # SemiDynaEXE
            elif 'kei2' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.comboBox_kei2.currentIndex()) + '\n'                #kei2
            elif 'par' in line:
                setting_text = setting_text + dat[0] + '=' + self.par.text() + '\n'                                       #par
            # Logger
            elif 'kei3' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.kei.currentIndex()) + '\n'                          #kei3
            elif 'logger_port' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.comboBox_port.currentIndex()) + '\n'                #logger_port
            elif 'logger_baudrate' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.comboBox_baudrate.currentIndex()) + '\n'            #logger_baudrate
            elif 'sentence' in line:
                setting_text = setting_text + dat[0] + '=' + str(self.comboBox_sentence.currentIndex()) + '\n'            #sentence
            elif 'time' in line:
                if self.radioButton_time1.isChecked(): 
                    setting_text = setting_text + dat[0] + '=1\n'                                                         #time
                else:
                    setting_text = setting_text + dat[0] + '=0\n'
            elif 'leaflet' in line:
                if self.check_leaflet.isChecked():
                    setting_text = setting_text + dat[0] + '=1\n'                                                         #leaflet
                else:
                    setting_text = setting_text + dat[0] + '=0\n'
            else:
                setting_text = setting_text + line

        f = codecs.open(settingfname, 'w', 'utf-8')
        f.write(setting_text)
        f.close()

# STR2STR---------------------------------------------------------------------------------------------------------------------------------------------------------------------

    # 保存（STR2STR）
    def sh_save(self):
        if self.radio_Output1.isChecked():
            if self.lineEdit_Host.text() == '':
                QMessageBox.information(self,u'エラー', u'NTRIP Caster Host は、必須です。')
                self.lineEdit_Host.setFocus()
                return
        if self.lineEdit_Port.text() == '':
            QMessageBox.information(self,u'エラー', u'Port は、必須です。')
            self.lineEdit_Port.setFocus()
            return
        if self.lineEdit_Mountpoint.text() == '':
            QMessageBox.information(self,u'エラー', u'Mountpoint（TCP Serverの場合は保存ファイル名）は、必須です。')
            self.lineEdit_Mountpoint.setFocus()
            return
        global flag2
        flag2 = 0
        dat1 = self.combo_port.currentIndex()                           # Port
        dat2 = self.combo_baudrate.currentIndex()                       # Baudrate
        dat3 = self.combo_ByteSize.currentIndex()                       # ByteSize
        dat4 = self.combo_Parity.currentIndex()                         # Parity
        dat5 = self.combo_StopBits.currentIndex()                       # StopBits
        dat6 = self.combo_FlowControl.currentIndex()                    # FlowControl
        dat7 = self.lineEdit_Host.text()                                # Host
        dat8 = self.lineEdit_Port.text()                                # Port
        dat9 = self.lineEdit_Mountpoint.text()                          # Mountpoint
        dat10 = self.lineEdit_ID.text()                                 # ID
        dat11 = self.lineEdit_Pass.text()                               # Pass
        dat12 = self.textEdit_String.toPlainText().replace('\n', '')    # String
        dat13 = self.combo_cmd.currentIndex()                           # cmd
        if self.checkBox_String.isChecked():                            # String Check
            dat14 = '1'
        else:
            dat14 = '0'
        if self.checkBox_conv.isChecked():                              # conv Check
            dat15 = '1'
        else:
            dat15 = '0'
        dat16 = self.textEdit_msg.toPlainText().replace('\n', '')       # msg
        dat17 = self.base_lat.text()                                    # lat
        dat18 = self.base_lon.text()                                    # lon
        dat19 = self.base_alt.text()                                    # alt
        if self.radio_Output1.isChecked():                              # NTRIP Server or TCP Server (''=NTRIP Server,'TCP'=TCP Server)
            dat20 = ''
        else:
            dat20 = 'TCP'
        dat = str(dat1) + ',' + str(dat2) + ',' + str(dat3) + ',' + str(dat4) + ',' + str(dat5) + ',' + str(dat6) + ',' + str(dat7) + ',' + str(dat8) + ',' + str(dat9) + ',' + str(dat10) + ',' + str(dat11) + ',"' + str(dat12) + '",' + str(dat13) + ',' + str(dat14) + ',' + str(dat15) + ',' + str(dat17) + ',' + str(dat18) + ',' + str(dat19) + ',' + str(dat20) + ','
        dat2 = str(dat16)
        datname = os.path.dirname(__file__) + u'/NtripCasterHost/' + dat9 + '.dat'
        datname2 = os.path.dirname(__file__) + u'/NtripCasterHost/' + dat9 + '_msg.dat'
        if os.path.exists(datname):
            result = QMessageBox.question(self,u'上書き確認', datname + u' は、既に存在します。\n上書きしてもよろしいですか？',QMessageBox.Yes | QMessageBox.No,QMessageBox.No)
            if result == QMessageBox.Yes:
                self.combo_sh.addItem(dat9)
                fname = codecs.open(datname, 'w', 'utf-8')
                fname.write(dat)
                fname.close()
                fname = codecs.open(datname2, 'w', 'utf-8')
                fname.write(dat2)
                fname.close()
                QMessageBox.information(self, u'登録', dat9 + u'を登録しました。')
            else:
                return
        else:
            self.combo_sh.addItem(dat9)
            fname = codecs.open(datname, 'w', 'utf-8')
            fname.write(dat)
            fname.close()
            fname = codecs.open(datname2, 'w', 'utf-8')
            fname.write(dat2)
            fname.close()
            QMessageBox.information(self, u'登録', dat9 + u'を登録しました。')
        # ファイルリストの取得
        datdir = os.path.dirname(__file__) + u'/NtripCasterHost'
        self.combo_sh.clear()
        self.combo_sh.addItem('')
        for root, dirs, files in os.walk(datdir):
            for file in files:
                if file.lower()[-4:] == '.dat' and file.lower()[-8:] != '_msg.dat':
                    self.combo_sh.addItem(str(file).replace('.dat', ''))
        i = 0
        for count in range(self.combo_sh.count()):
            if count > 0:
              data = self.combo_sh.itemText(count)
              if data == dat9:
                  i = count
        self.combo_sh.setCurrentIndex(i)

        # RaspberryPi用接続ファイル作成
        sh_text = 'cd ' + self.lineEdit_str2str_path.text() + '\n'

        if not self.checkBox_String.isChecked() or self.textEdit_String.toPlainText() == '':
            strop = ''
        else:
            strop = ':"' + self.textEdit_String.toPlainText().replace('\n', '') + '"'

        if not self.checkBox_conv.isChecked() or self.textEdit_msg.toPlainText() == '':
            msgop = ''
            fmt1 = ''
            fmt2 = ''
        else:
            msgop = ' -msg "' + self.textEdit_msg.toPlainText().replace('\n', '') + '"'
            fmt1 = '#ubx'
            fmt2 = '#rtcm3'

        if self.base_lat.text() != '' and self.base_lon.text() != '' and self.base_alt.text() != '':
            posop = ' -p ' + self.base_lat.text() + ' ' + self.base_lon.text() + ' ' + self.base_alt.text()
        else:
            posop = ''

        if self.combo_cmd.currentText() == '':
            cmdop = ''
        else:
            cmdop = ' -c ../../../data/' + self.combo_cmd.currentText()

        port = self.combo_port.currentText()
        brate = self.combo_baudrate.currentText()
        bsize = self.combo_ByteSize.currentText()
        if self.combo_Parity.currentText() == 'None':
            parity = 'n'
        elif self.combo_Parity.currentText() == 'Even':
            parity = 'e'
        else:
            parity = 'o'
        stopb = self.combo_StopBits.currentText()
        if self.combo_FlowControl.currentText() == 'None':
            fctr = 'off'
        else:
            fctr = 'rts'

        if self.radio_Output1.isChecked():
            sh_text = sh_text + './str2str' + cmdop + ' -in serial://' + port + ':' + brate + ':' + bsize + ':' + parity + ':' + stopb + ':' + fctr + fmt1 + ' -out ntrips://' + self.lineEdit_ID.text() + ':' + self.lineEdit_Pass.text() + '@' + self.lineEdit_Host.text() + ':' + self.lineEdit_Port.text() + '/' + self.lineEdit_Mountpoint.text() + str(strop) + fmt2 + str(msgop) + str(posop) + '\n'
        else:
            sh_text = sh_text + './str2str' + cmdop + ' -in serial://' + port + ':' + brate + ':' + bsize + ':' + parity + ':' + stopb + ':' + fctr + fmt1 + ' -out tcpsvr://:' + self.lineEdit_Port.text() + str(strop) + fmt2 + str(msgop) + str(posop) + '\n'

        if sys.platform == "win32":
            fname = open(os.path.dirname(__file__) + '/str2str.sh', 'w')
        else:
            fname = open(self.lineEdit_str2str_path.text() + 'str2str.sh', 'w')
        fname.write(sh_text)
        fname.close()
        flag2 = 1

        # 実行権限付与
        if sys.platform == "win32":
            return
        cmd = 'chmod 755 ' + self.lineEdit_str2str_path.text() + 'str2str.sh'
        subprocess.check_output(cmd,shell=True)

    # 接続・切断（STR2STR）
    def on_off(self):
        # RaspberryPi用接続ファイル作成
        sh_text = 'cd ' + self.lineEdit_str2str_path.text() + '\n'

        if not self.checkBox_String.isChecked() or self.textEdit_String.toPlainText() == '':
            strop = ''
        else:
            strop = ':"' + self.textEdit_String.toPlainText().replace('\n', '') + '"'

        if not self.checkBox_conv.isChecked() or self.textEdit_msg.toPlainText() == '':
            msgop = ''
            fmt1 = ''
            fmt2 = ''
        else:
            msgop = ' -msg "' + self.textEdit_msg.toPlainText().replace('\n', '') + '"'
            fmt1 = '#ubx'
            fmt2 = '#rtcm3'

        if self.base_lat.text() != '' and self.base_lon.text() != '' and self.base_alt.text() != '':
            posop = ' -p ' + self.base_lat.text() + ' ' + self.base_lon.text() + ' ' + self.base_alt.text()
        else:
            posop = ''

        if self.combo_cmd.currentText() == '':
            cmdop = ''
        else:
            cmdop = ' -c ../../../data/' + self.combo_cmd.currentText()

        port = self.combo_port.currentText()
        brate = self.combo_baudrate.currentText()
        bsize = self.combo_ByteSize.currentText()
        if self.combo_Parity.currentText() == 'None':
            parity = 'n'
        elif self.combo_Parity.currentText() == 'Even':
            parity = 'e'
        else:
            parity = 'o'
        stopb = self.combo_StopBits.currentText()
        if self.combo_FlowControl.currentText() == 'None':
            fctr = 'off'
        else:
            fctr = 'rts'

        if self.radio_Output1.isChecked():
            sh_text = sh_text + './str2str' + cmdop + ' -in serial://' + port + ':' + brate + ':' + bsize + ':' + parity + ':' + stopb + ':' + fctr + fmt1 + ' -out ntrips://' + self.lineEdit_ID.text() + ':' + self.lineEdit_Pass.text() + '@' + self.lineEdit_Host.text() + ':' + self.lineEdit_Port.text() + '/' + self.lineEdit_Mountpoint.text() + str(strop) + fmt2 + str(msgop) + str(posop) + '\n'
        else:
            sh_text = sh_text + './str2str' + cmdop + ' -in serial://' + port + ':' + brate + ':' + bsize + ':' + parity + ':' + stopb + ':' + fctr + fmt1 + ' -out tcpsvr://:' + self.lineEdit_Port.text() + str(strop) + fmt2 + str(msgop) + str(posop) + '\n'

        if sys.platform == "win32":
            fname = open(os.path.dirname(__file__) + '/str2str.sh', 'w')
        else:
            fname = open(self.lineEdit_str2str_path.text() + 'str2str.sh', 'w')
        fname.write(sh_text)
        fname.close()
        global flag2
        flag2 = 1
        if sys.platform == "win32":
            QMessageBox.information(self, u'OS未対応', u'Windowsでは接続できません。')
            return
        cmd = 'chmod 755 ' + self.lineEdit_str2str_path.text() + 'str2str.sh'
        subprocess.check_output(cmd,shell=True)
        cmd = 'lxterminal -e ' + self.lineEdit_str2str_path.text() + 'str2str.sh'
        subprocess.call(cmd,shell=True)

    # リスト選択
    def SetList(self):
        if flag2 == 0:
            return
        if self.combo_sh.currentIndex() == 0:
            return
        datname = os.path.dirname(__file__) + u'/NtripCasterHost/' + self.combo_sh.currentText() + '.dat'
        try:
            for line in open(datname,'r'):
                dat0 = line.split('"')
                dat = dat0[0].split(',')
                dat2 = dat0[2].split(',')
            self.combo_port.setCurrentIndex(int(dat[0]))         # Port
            self.combo_baudrate.setCurrentIndex(int(dat[1]))     # Baudrate
            self.combo_ByteSize.setCurrentIndex(int(dat[2]))     # ByteSize
            self.combo_Parity.setCurrentIndex(int(dat[3]))       # Parity
            self.combo_StopBits.setCurrentIndex(int(dat[4]))     # StopBits
            self.combo_FlowControl.setCurrentIndex(int(dat[5]))  # FlowControl
            self.lineEdit_Host.setText(dat[6])                   # Host
            self.lineEdit_Port.setText(dat[7])                   # Port
            self.lineEdit_Mountpoint.setText(dat[8])             # Mountpoint
            self.lineEdit_ID.setText(dat[9])                     # ID
            self.lineEdit_Pass.setText(dat[10])                  # Password
            self.textEdit_String.clear()                         # String
            self.textEdit_String.append(dat0[1])
            self.combo_cmd.setCurrentIndex(int(dat2[1]))         # cmd
            if dat2[2] =='0':                                    # String Check
                self.checkBox_String.setChecked(False)
            else:
                self.checkBox_String.setChecked(True)
            if dat2[3] =='0':                                    # conv Check
                self.checkBox_conv.setChecked(False)
            else:
                self.checkBox_conv.setChecked(True)
            self.base_lat.setText(dat2[4])                       # lat
            self.base_lon.setText(dat2[5])                       # lon
            self.base_alt.setText(dat2[6])                       # alt
            if dat2[7] == '':                                    # Output
                self.radio_Output1.setChecked(True)
                self.lineEdit_Host.setEnabled(True)
                self.lineEdit_ID.setEnabled(True)
                self.lineEdit_Pass.setEnabled(True)
            else:
                self.radio_Output2.setChecked(True)
                self.lineEdit_Host.setEnabled(False)
                self.lineEdit_ID.setEnabled(False)
                self.lineEdit_Pass.setEnabled(False)
        except:
            for line in open(datname,'r'):
                dat = line.split(',')
            self.combo_port.setCurrentIndex(int(dat[0]))         # Port
            self.combo_baudrate.setCurrentIndex(int(dat[1]))     # Baudrate
            self.combo_ByteSize.setCurrentIndex(int(dat[2]))     # ByteSize
            self.combo_Parity.setCurrentIndex(int(dat[3]))       # Parity
            self.combo_StopBits.setCurrentIndex(int(dat[4]))     # StopBits
            self.combo_FlowControl.setCurrentIndex(int(dat[5]))  # FlowControl
            self.lineEdit_Host.setText(dat[6])                   # Host
            self.lineEdit_Port.setText(dat[7])                   # Port
            self.lineEdit_Mountpoint.setText(dat[8])             # Mountpoint
            self.lineEdit_ID.setText(dat[9])                     # ID
            self.lineEdit_Pass.setText(dat[10])                  # Password
            self.textEdit_String.clear()                         # String
            self.checkBox_String.setChecked(False)               # String Check
            self.textEdit_msg.clear()                            # msg
            self.checkBox_conv.setChecked(False)                 # conv Check
            self.radio_Output1.setChecked(True)                  # Output = NTRIP Server
        datname = os.path.dirname(__file__) + u'/NtripCasterHost/' + self.combo_sh.currentText() + '_msg.dat'
        self.textEdit_msg.clear()                                # msg
        try:
            for line in open(datname,'r'):
                dat = line
            self.textEdit_msg.setText(dat)
        except:
            pass

    # sample_stringセット
    def sample_string(self):
        if self.textEdit_String.toPlainText() != '':
            result = QMessageBox.question(self,u'上書き確認', u'基準局情報は上書きされます。\n実行してもよろしいですか？',QMessageBox.Yes | QMessageBox.No,QMessageBox.No)
            if result == QMessageBox.No:
                return
        self.textEdit_String.clear()
        self.textEdit_String.append('Hokkaido;RTCM 3.3;;;GPS+GLO+GAL+BDS+QZS;SNIP;JPN;0.00;0.00;1;0;sNTRIP;none;N;N;0;;')
        self.checkBox_String.setChecked(True)

    # sample_msgセット
    def sample_msg(self):
        if self.textEdit_msg.toPlainText() != '':
            result = QMessageBox.question(self,u'上書き確認', u'messageは上書きされます。\n実行してもよろしいですか？',QMessageBox.Yes | QMessageBox.No,QMessageBox.No)
            if result == QMessageBox.No:
                return
        self.textEdit_msg.clear()
        self.textEdit_msg.append('1005(10),1019(1),1020(1),1042(1),1044(1),1046(1),1077(1),1087(1),1097(1),1107(1),1117(1),1127(1),1230(1)')
        self.checkBox_conv.setChecked(True)

    # Output 切替
    def SetOutput(self):
        if self.radio_Output1.isChecked():
            self.lineEdit_Host.setEnabled(True)
            self.lineEdit_ID.setEnabled(True)
            self.lineEdit_Pass.setEnabled(True)
        else:
            self.lineEdit_Host.setEnabled(False)
            self.lineEdit_ID.setEnabled(False)
            self.lineEdit_Pass.setEnabled(False)


# RTKRCV----------------------------------------------------------------------------------------------------------------------------------------------------------------------

    # 保存（RTKRCV）
    def sh_save2(self):
        if sys.platform == "win32":
            conf_name = os.path.dirname(__file__) + '/rtk.conf'
        else:
            conf_name = self.lineEdit_conf_path.text() + 'rtk.conf'
        self.save_setting()
        inpstr1_type = self.combo1.currentIndex()
        inpstr2_type = self.combo2.currentIndex()
        inpstr1_path = self.lineEdit3.text()
        inpstr2_path = self.lineEdit4.text()
        inpstr1_format = self.combo5.currentIndex()
        inpstr2_format = self.combo6.currentIndex()
        misc_navmsgsel = self.combo7.currentIndex()
        pos1_posmode = self.combo10.currentIndex()
        pos1_frequency = self.combo11.currentIndex()
        pos1_elmask = self.lineEdit12.text()
        rover = self.combo_Rover.currentIndex()
        base = self.combo_Base.currentIndex()
        pos1_snrmask_L1 = self.lineEditL1.text()
        pos1_snrmask_L2 = self.lineEditL2.text()
        pos1_snrmask_L5 = self.lineEditL5.text()
        pos1_exclsats = self.lineEdit14.text()
        pos1_navsys = self.lineEdit15.text()
        pos2_armode = self.combo16.currentIndex()
        ant2_postype = self.combo17.currentIndex()
        ant2_pos1 = self.lineEdit18.text()
        ant2_pos2 = self.lineEdit19.text()
        ant2_pos3 = self.lineEdit20.text()
        outstr1_type = self.combo21.currentIndex()
        outstr2_type = self.combo22.currentIndex()
        outstr1_format = self.combo23.currentIndex()
        outstr2_format = self.combo24.currentIndex()
        file_cmdfile1 = self.combo8.currentIndex()
        file_cmdfile2 = self.combo9.currentIndex()
        outstr1_path = self.lineEdit_out1path.text()
        outstr2_path = self.lineEdit_out2path.text()
        dat = str(inpstr1_type) + '$' + str(inpstr2_type) + '$' + str(inpstr1_path) + '$' + str(inpstr2_path) + '$' + str(inpstr1_format) + '$' + str(inpstr2_format) + '$' + str(misc_navmsgsel) + '$' + str(file_cmdfile1) + '$' + str(file_cmdfile2) + '$' + str(pos1_posmode) + '$' + str(pos1_frequency) + '$' + str(pos1_elmask) + '$' + str(rover) + '$' + str(base) + '$' + str(pos1_snrmask_L1) + '$' + str(pos1_snrmask_L2) + '$' + str(pos1_snrmask_L5) + '$' + str(pos1_exclsats) + '$' + str(pos1_navsys) + '$' + str(pos2_armode) + '$' + str(ant2_postype) + '$' + str(ant2_pos1) + '$' + str(ant2_pos2) + '$' + str(ant2_pos3) + '$' + str(outstr1_type) + '$' + str(outstr2_type) + '$' + str(outstr1_format) + '$' + str(outstr2_format) + '$' + str(file_cmdfile1) + '$' + str(file_cmdfile2) + '$' + str(outstr1_path) + '$' + str(outstr2_path)
        mp = inpstr2_path.split('/')
        conf_name2 = os.path.dirname(__file__) + u'/RTK_CONF/' + mp[1] + '.dat'
        if os.path.exists(conf_name2):
            result = QMessageBox.question(self,u'上書き確認', conf_name + u' は、既に存在します。\n上書きしてもよろしいですか？',QMessageBox.Yes | QMessageBox.No,QMessageBox.No)
            if result == QMessageBox.Yes:
                f = codecs.open(conf_name2, 'w', 'utf-8')
                f.write(dat)
                f.close()
            else:
                return
        else:
            f = codecs.open(conf_name2, 'w', 'utf-8')
            f.write(dat)
            f.close()
        # ファイルリストの取得
        datdir = os.path.dirname(__file__) + u'/RTK_CONF'
        self.combo_path.clear()
        self.combo_path.addItem('')
        for root, dirs, files in os.walk(datdir):
            for file in files:
                if file.lower()[-4:] == '.dat':
                    self.combo_path.addItem(str(file).replace('.dat', ''))
        i = 0
        for count in range(self.combo_path.count()):
            if count > 0:
              data = self.combo_path.itemText(count)
              if data == mp[1]:
                  i = count
        self.combo_path.setCurrentIndex(i)
        # Raspbian用設定ファイル作成
        inpstr1_type = self.combo1.currentIndex()
        inpstr2_type = self.combo2.currentIndex()
        inpstr1_path = self.lineEdit3.text()
        inpstr2_path = self.lineEdit4.text()
        inpstr1_format = self.combo5.currentIndex()
        inpstr2_format = self.combo6.currentIndex()
        misc_navmsgsel = self.combo7.currentIndex()
        pos1_posmode = self.combo10.currentIndex()
        pos1_frequency = self.combo11.currentIndex()
        pos1_elmask = self.lineEdit12.text()
        rover = self.combo_Rover.currentIndex()
        base = self.combo_Base.currentIndex()
        pos1_snrmask_L1 = self.lineEditL1.text()
        pos1_snrmask_L2 = self.lineEditL2.text()
        pos1_snrmask_L5 = self.lineEditL5.text()
        pos1_exclsats = self.lineEdit14.text()
        pos1_navsys = self.lineEdit15.text()
        pos2_armode = self.combo16.currentIndex()
        ant2_postype = self.combo17.currentIndex()
        ant2_pos1 = self.lineEdit18.text()
        ant2_pos2 = self.lineEdit19.text()
        ant2_pos3 = self.lineEdit20.text()
        outstr1_type = self.combo21.currentIndex()
        outstr2_type = self.combo22.currentIndex()
        outstr1_format = self.combo23.currentIndex()
        outstr2_format = self.combo24.currentIndex()
        file_cmdfile1 = self.combo8.currentIndex()
        file_cmdfile2 = self.combo9.currentIndex()
        outstr1_path = self.lineEdit_out1path.text()
        outstr2_path = self.lineEdit_out2path.text()
        dat = ''
        d2 = str(datetime.datetime.today()).replace('-','').replace(':','').replace(' ','').split('.')
        if sys.platform == "win32":
            if not os.path.exists(conf_name):
                f = codecs.open(conf_name, 'w', 'utf-8')
                f.write('')
                f.close()
            dat = dat + 'inpstr1-type    = ' + self.combo1.itemText(inpstr1_type) + '\n'
            dat = dat + 'inpstr2-type    = ' + self.combo2.itemText(inpstr2_type) + '\n'
            dat = dat + 'inpstr1-path    = ' + inpstr1_path + '\n'
            dat = dat + 'inpstr2-path    = ' + inpstr2_path + '\n'
            dat = dat + 'inpstr1-format  = ' + self.combo5.itemText(inpstr1_format) + '\n'
            dat = dat + 'inpstr2-format  = ' + self.combo6.itemText(inpstr2_format) + '\n'
            dat = dat + 'misc-navmsgsel  = ' + self.combo7.itemText(misc_navmsgsel) + '\n'
            dat = dat + 'outstr1-type    = ' + self.combo21.itemText(outstr1_type) + '\n'
            dat = dat + 'outstr2-type    = ' + self.combo22.itemText(outstr2_type) + '\n'
            dat = dat + 'outstr1-format  = ' + self.combo23.itemText(outstr1_format) + '\n'
            dat = dat + 'outstr2-format  = ' + self.combo24.itemText(outstr2_format) + '\n'
            dat = dat + 'pos1-posmode    = ' + self.combo10.itemText(pos1_posmode) + '\n'
            dat = dat + 'pos1-frequency  = ' + self.combo11.itemText(pos1_frequency) + '\n'
            dat = dat + 'pos1-elmask     = ' + pos1_elmask + '\n'
            dat = dat + 'pos1-snrmask_r  = ' + self.combo_Rover.itemText(rover) + '\n'
            dat = dat + 'pos1-snrmask_b  = ' + self.combo_Base.itemText(base) + '\n'
            dat = dat + 'pos1-snrmask_L1 = ' + pos1_snrmask_L1 + '\n'
            dat = dat + 'pos1-snrmask_L2 = ' + pos1_snrmask_L2 + '\n'
            dat = dat + 'pos1-snrmask_L5 = ' + pos1_snrmask_L5 + '\n'
            dat = dat + 'pos1-exclsats   = ' + pos1_exclsats + '\n'
            dat = dat + 'pos1-navsys     = ' + pos1_navsys + '\n'
            dat = dat + 'pos2-armode     = ' + self.combo16.itemText(pos2_armode) + '\n'
            dat = dat + 'ant2-postype    = ' + self.combo17.itemText(ant2_postype) + '\n'
            dat = dat + 'ant2-pos1       = ' + ant2_pos1 + '\n'
            dat = dat + 'ant2-pos2       = ' + ant2_pos2 + '\n'
            dat = dat + 'ant2-pos3       = ' + ant2_pos3 + '\n'
            dat = dat + 'out-degform     = deg\n'
            dat = dat + 'out-height      = ellipsoidal\n'
            dat = dat + 'file-cmdfile1   = ' + self.combo8.itemText(file_cmdfile1) + '\n'
            dat = dat + 'file-cmdfile2   = ' + self.combo9.itemText(file_cmdfile2) + '\n'
            if self.combo21.itemText(outstr1_type) == 'file':
                r1 = self.lineEdit_out1path.text()[-1:]
                if r1 == '/':
                    dat = dat + 'outstr1-path    = ' + self.lineEdit_out1path.text() + d2[0] + '_out1.log\n'
                else:
                    dat = dat + 'outstr1-path    = ' + self.lineEdit_out1path.text() + '/' + d2[0] + '_out1.log\n'
            else:
               dat = dat + 'outstr1-path    = ' + self.lineEdit_out1path.text() + '\n'
            if self.combo22.itemText(outstr2_type) == 'file':
                return
                r1 = self.lineEdit_out2path.text()[-1:]
                if r1 == '/':
                    dat = dat + 'outstr2-path    = ' + self.lineEdit_out2path.text() + d2[0] + '_out2.log\n'
                else:
                    dat = dat + 'outstr2-path    = ' + self.lineEdit_out2path.text() + '/' + d2[0] + '_out2.log\n'
            else:
                dat = dat + 'outstr2-path    = ' + self.lineEdit_out2path.text() + '\n'
        else:
            cmdfile1 = 0
            cmdfile2 = 0
            for line in open(conf_name, 'r'):
                d = line.split('=')
                if 'inpstr1-type' in line:
                    line = d[0] + '=' + self.combo1.itemText(inpstr1_type) + '\n'
                if 'inpstr2-type' in line:
                    line = d[0] + '=' + self.combo2.itemText(inpstr2_type) + '\n'
                if 'inpstr1-path' in line:
                    line = d[0] + '=' + inpstr1_path + '\n'
                if 'inpstr2-path' in line:
                    line = d[0] + '=' + inpstr2_path + '\n'
                if 'inpstr1-format' in line:
                    line = d[0] + '=' + self.combo5.itemText(inpstr1_format) + '\n'
                if 'inpstr2-format' in line:
                    line = d[0] + '=' + self.combo6.itemText(inpstr2_format) + '\n'
                if 'misc-navmsgsel' in line:
                    line = d[0] + '=' + self.combo7.itemText(misc_navmsgsel) + '\n'
                if 'outstr1-type' in line:
                    line = d[0] + '=' + self.combo21.itemText(outstr1_type) + '\n'
                if 'outstr2-type' in line:
                    line = d[0] + '=' + self.combo22.itemText(outstr2_type) + '\n'
                if 'outstr1-format' in line:
                    line = d[0] + '=' + self.combo23.itemText(outstr1_format) + '\n'
                if 'outstr2-format' in line:
                    line = d[0] + '=' + self.combo24.itemText(outstr2_format) + '\n'
                if 'pos1-posmode' in line:
                    line = d[0] + '=' + self.combo10.itemText(pos1_posmode) + '\n'
                if 'pos1-frequency' in line:
                    line = d[0] + '=' + self.combo11.itemText(pos1_frequency) + '\n'
                if 'pos1-elmask' in line:
                    line = d[0] + '=' + pos1_elmask + '\n'
                if 'pos1-snrmask_r' in line:
                    line = d[0] + '=' + self.combo_Rover.itemText(rover) + '\n'
                if 'pos1-snrmask_b' in line:
                    line = d[0] + '=' + self.combo_Base.itemText(base) + '\n'
                if 'pos1-snrmask_L1' in line:
                    line = d[0] + '=' + pos1_snrmask_L1 + '\n'
                if 'pos1-snrmask_L2' in line:
                    line = d[0] + '=' + pos1_snrmask_L2 + '\n'
                if 'pos1-snrmask_L5' in line:
                    line = d[0] + '=' + pos1_snrmask_L5 + '\n'
                if  'pos1-exclsats' in line:
                    line = d[0] + '=' + pos1_exclsats + '\n'
                if 'pos1-navsys' in line:
                    line = d[0] + '=' + pos1_navsys + '\n'
                if 'pos2-armode' in line:
                    line = d[0] + '=' + self.combo16.itemText(pos2_armode) + '\n'
                if  'ant2-postype' in line:
                    line = d[0] + '=' + self.combo17.itemText(ant2_postype) + '\n'
                if 'ant2-pos1' in line:
                    line = d[0] + '=' + ant2_pos1 + '\n'
                if 'ant2-pos2' in line:
                    line = d[0] + '=' + ant2_pos2 + '\n'
                if 'ant2-pos3' in line:
                    line = d[0] + '=' + ant2_pos3 + '\n'
                if 'out-degform' in line:
                    line = 'out-degform        =deg        # (0:deg,1:dms)\n'
                if 'out-height' in line:
                    line = 'out-height         =ellipsoidal # (0:ellipsoidal,1:geodetic)\n'
                if 'outstr1-path' in line:
                    if outstr1_type == 2:
                            r1 = self.lineEdit_out1path.text()[-1:]
                            if r1 == '/':
                                line = 'outstr1-path       =' + self.lineEdit_out1path.text() + d2[0] + '_out1.log\n'
                            else:
                                line = 'outstr1-path       =' + self.lineEdit_out1path.text() + '/' + d2[0] + '_out1.log\n'
                    else:
                        if 'outstr1-path' in line:
                            line = 'outstr1-path       =' + self.lineEdit_out1path.text() + '\n'
                if 'outstr2-path' in line:
                    if outstr2_type == 2:
                            r1 = self.lineEdit_out2path.text()[-1:]
                            if r1 == '/':
                                line = 'outstr2-path       =' + self.lineEdit_out2path.text() + d2[0] + '_out2.log\n'
                            else:
                                line = 'outstr2-path       =' + self.lineEdit_out2path.text() + '/' + d2[0] + '_out2.log\n'
                    else:
                        if 'outstr2-path' in line:
                            line = 'outstr2-path       =' + self.lineEdit_out2path.text() + '\n'
                if 'file-cmdfile1' in line:
                    if self.combo8.currentIndex() == 0:
                        line = d[0] + '=\n'
                    else:
                        line = d[0] + '=../../../data/' + self.combo8.itemText(file_cmdfile1) + '\n'
                    cmdfile1 = 1
                if 'file-cmdfile2' in line:
                    if self.combo9.currentIndex() == 0:
                        line = d[0] + '=\n'
                    else:
                        line = d[0] + '=../../../data/' + self.combo9.itemText(file_cmdfile2) + '\n'
                    cmdfile2 = 1
                dat = dat + line
            if cmdfile1 == 0:
                if self.combo8.currentIndex() == 0:
                    line = 'file-cmdfile1      =\n'
                else:
                    line = 'file-cmdfile1      =../../../data/' + self.combo8.itemText(file_cmdfile1) + '\n'
                dat = dat + line
            if cmdfile2 == 0:
                if self.combo9.currentIndex() == 0:
                    line = 'file-cmdfile2      =\n'
                else:
                    line = 'file-cmdfile2      =../../../data/' + self.combo9.itemText(file_cmdfile2) + '\n'
                dat = dat + line
        fname = open(conf_name, 'w')
        fname.write(dat)
        fname.close()
        if sys.platform == "win32":
            return
        sh_text = 'cd ' + self.lineEdit_rtkrcv_path.text() + '\n'
        if self.checkBox_mOption.isChecked():
            sh_text = sh_text + 'lxterminal -e ./rtkrcv -o ' + conf_name + ' -m 52001\n'
        else:
            sh_text = sh_text + 'lxterminal -e ./rtkrcv -o ' + conf_name + '\n'
        fname = open(self.lineEdit_rtkrcv_path.text() + 'rtkrcv_run.sh', 'w')
        fname.write(sh_text)
        fname.close()
        cmd = 'chmod 755 ' + self.lineEdit_rtkrcv_path.text() + 'rtkrcv_run.sh'
        subprocess.check_output(cmd,shell=True)

    # 接続・切断（RTKRCV）
    def on_off2(self):
        # Raspbian用設定ファイル作成
        if sys.platform == "win32":
            conf_name = os.path.dirname(__file__) + '/rtk.conf'
        else:
            conf_name = self.lineEdit_conf_path.text() + 'rtk.conf'

        inpstr1_type = self.combo1.currentIndex()
        inpstr2_type = self.combo2.currentIndex()
        inpstr1_path = self.lineEdit3.text()
        inpstr2_path = self.lineEdit4.text()
        inpstr1_format = self.combo5.currentIndex()
        inpstr2_format = self.combo6.currentIndex()
        misc_navmsgsel = self.combo7.currentIndex()
        pos1_posmode = self.combo10.currentIndex()
        pos1_frequency = self.combo11.currentIndex()
        pos1_elmask = self.lineEdit12.text()
        rover = self.combo_Rover.currentIndex()
        base = self.combo_Base.currentIndex()
        pos1_snrmask_L1 = self.lineEditL1.text()
        pos1_snrmask_L2 = self.lineEditL2.text()
        pos1_snrmask_L5 = self.lineEditL5.text()
        pos1_exclsats = self.lineEdit14.text()
        pos1_navsys = self.lineEdit15.text()
        pos2_armode = self.combo16.currentIndex()
        ant2_postype = self.combo17.currentIndex()
        ant2_pos1 = self.lineEdit18.text()
        ant2_pos2 = self.lineEdit19.text()
        ant2_pos3 = self.lineEdit20.text()
        outstr1_type = self.combo21.currentIndex()
        outstr2_type = self.combo22.currentIndex()
        outstr1_format = self.combo23.currentIndex()
        outstr2_format = self.combo24.currentIndex()
        file_cmdfile1 = self.combo8.currentIndex()
        file_cmdfile2 = self.combo9.currentIndex()
        outstr1_path = self.lineEdit_out1path.text()
        outstr2_path = self.lineEdit_out2path.text()
        if outstr1_type == 4 or outstr2_type == 4:
            self.checkBox_mOption.setChecked(True)
        dat = ''
        d2 = str(datetime.datetime.today()).replace('-','').replace(':','').replace(' ','').split('.')
        if sys.platform == "win32":
            if not os.path.exists(conf_name):
                f = codecs.open(conf_name, 'w', 'utf-8')
                f.write('')
                f.close()
            dat = dat + 'inpstr1-type    = ' + self.combo1.itemText(inpstr1_type) + '\n'
            dat = dat + 'inpstr2-type    = ' + self.combo2.itemText(inpstr2_type) + '\n'
            dat = dat + 'inpstr1-path    = ' + inpstr1_path + '\n'
            dat = dat + 'inpstr2-path    = ' + inpstr2_path + '\n'
            dat = dat + 'inpstr1-format  = ' + self.combo5.itemText(inpstr1_format) + '\n'
            dat = dat + 'inpstr2-format  = ' + self.combo6.itemText(inpstr2_format) + '\n'
            dat = dat + 'misc-navmsgsel  = ' + self.combo7.itemText(misc_navmsgsel) + '\n'
            dat = dat + 'outstr1-type    = ' + self.combo21.itemText(outstr1_type) + '\n'
            dat = dat + 'outstr2-type    = ' + self.combo22.itemText(outstr2_type) + '\n'
            dat = dat + 'outstr1-format  = ' + self.combo23.itemText(outstr1_format) + '\n'
            dat = dat + 'outstr2-format  = ' + self.combo24.itemText(outstr2_format) + '\n'
            dat = dat + 'pos1-posmode    = ' + self.combo10.itemText(pos1_posmode) + '\n'
            dat = dat + 'pos1-frequency  = ' + self.combo11.itemText(pos1_frequency) + '\n'
            dat = dat + 'pos1-elmask     = ' + pos1_elmask + '\n'
            dat = dat + 'pos1-snrmask_r  = ' + self.combo_Rover.itemText(rover) + '\n'
            dat = dat + 'pos1-snrmask_b  = ' + self.combo_Base.itemText(base) + '\n'
            dat = dat + 'pos1-snrmask_L1 = ' + pos1_snrmask_L1 + '\n'
            dat = dat + 'pos1-snrmask_L2 = ' + pos1_snrmask_L2 + '\n'
            dat = dat + 'pos1-snrmask_L5 = ' + pos1_snrmask_L5 + '\n'
            dat = dat + 'pos1-exclsats   = ' + pos1_exclsats + '\n'
            dat = dat + 'pos1-navsys     = ' + pos1_navsys + '\n'
            dat = dat + 'pos2-armode     = ' + self.combo16.itemText(pos2_armode) + '\n'
            dat = dat + 'ant2-postype    = ' + self.combo17.itemText(ant2_postype) + '\n'
            dat = dat + 'ant2-pos1       = ' + ant2_pos1 + '\n'
            dat = dat + 'ant2-pos2       = ' + ant2_pos2 + '\n'
            dat = dat + 'ant2-pos3       = ' + ant2_pos3 + '\n'
            dat = dat + 'out-degform     = deg\n'
            dat = dat + 'out-height      = ellipsoidal\n'
            dat = dat + 'file-cmdfile1   = ' + self.combo8.itemText(file_cmdfile1) + '\n'
            dat = dat + 'file-cmdfile2   = ' + self.combo9.itemText(file_cmdfile2) + '\n'
            if self.combo21.itemText(outstr1_type) == 'file':
                r1 = self.lineEdit_out1path.text()[-1:]
                if r1 == '/':
                    dat = dat + 'outstr1-path    = ' + self.lineEdit_out1path.text() + d2[0] + '_out1.log\n'
                else:
                    dat = dat + 'outstr1-path    = ' + self.lineEdit_out1path.text() + '/' + d2[0] + '_out1.log\n'
            else:
               dat = dat + 'outstr1-path    = ' + self.lineEdit_out1path.text() + '\n'
            if self.combo22.itemText(outstr2_type) == 'file':
                return
                r1 = self.lineEdit_out2path.text()[-1:]
                if r1 == '/':
                    dat = dat + 'outstr2-path    = ' + self.lineEdit_out2path.text() + d2[0] + '_out2.log\n'
                else:
                    dat = dat + 'outstr2-path    = ' + self.lineEdit_out2path.text() + '/' + d2[0] + '_out2.log\n'
            else:
                dat = dat + 'outstr2-path    = ' + self.lineEdit_out2path.text() + '\n'
        else:
            cmdfile1 = 0
            cmdfile2 = 0
            for line in open(conf_name, 'r'):
                d = line.split('=')
                if 'inpstr1-type' in line:
                    line = d[0] + '=' + self.combo1.itemText(inpstr1_type) + '\n'
                if 'inpstr2-type' in line:
                    line = d[0] + '=' + self.combo2.itemText(inpstr2_type) + '\n'
                if 'inpstr1-path' in line:
                    line = d[0] + '=' + inpstr1_path + '\n'
                if 'inpstr2-path' in line:
                    line = d[0] + '=' + inpstr2_path + '\n'
                if 'inpstr1-format' in line:
                    line = d[0] + '=' + self.combo5.itemText(inpstr1_format) + '\n'
                if 'inpstr2-format' in line:
                    line = d[0] + '=' + self.combo6.itemText(inpstr2_format) + '\n'
                if 'misc-navmsgsel' in line:
                    line = d[0] + '=' + self.combo7.itemText(misc_navmsgsel) + '\n'
                if 'outstr1-type' in line:
                    line = d[0] + '=' + self.combo21.itemText(outstr1_type) + '\n'
                if 'outstr2-type' in line:
                    line = d[0] + '=' + self.combo22.itemText(outstr2_type) + '\n'
                if 'outstr1-format' in line:
                    line = d[0] + '=' + self.combo23.itemText(outstr1_format) + '\n'
                if 'outstr2-format' in line:
                    line = d[0] + '=' + self.combo24.itemText(outstr2_format) + '\n'
                if 'pos1-posmode' in line:
                    line = d[0] + '=' + self.combo10.itemText(pos1_posmode) + '\n'
                if 'pos1-frequency' in line:
                    line = d[0] + '=' + self.combo11.itemText(pos1_frequency) + '\n'
                if 'pos1-elmask' in line:
                    line = d[0] + '=' + pos1_elmask + '\n'
                if 'pos1-snrmask_r' in line:
                    line = d[0] + '=' + self.combo_Rover.itemText(rover) + '\n'
                if 'pos1-snrmask_b' in line:
                    line = d[0] + '=' + self.combo_Base.itemText(base) + '\n'
                if 'pos1-snrmask_L1' in line:
                    line = d[0] + '=' + pos1_snrmask_L1 + '\n'
                if 'pos1-snrmask_L2' in line:
                    line = d[0] + '=' + pos1_snrmask_L2 + '\n'
                if 'pos1-snrmask_L5' in line:
                    line = d[0] + '=' + pos1_snrmask_L5 + '\n'
                if  'pos1-exclsats' in line:
                    line = d[0] + '=' + pos1_exclsats + '\n'
                if 'pos1-navsys' in line:
                    line = d[0] + '=' + pos1_navsys + '\n'
                if 'pos2-armode' in line:
                    line = d[0] + '=' + self.combo16.itemText(pos2_armode) + '\n'
                if  'ant2-postype' in line:
                    line = d[0] + '=' + self.combo17.itemText(ant2_postype) + '\n'
                if 'ant2-pos1' in line:
                    line = d[0] + '=' + ant2_pos1 + '\n'
                if 'ant2-pos2' in line:
                    line = d[0] + '=' + ant2_pos2 + '\n'
                if 'ant2-pos3' in line:
                    line = d[0] + '=' + ant2_pos3 + '\n'
                if 'out-degform' in line:
                    line = 'out-degform        =deg        # (0:deg,1:dms)\n'
                if 'out-height' in line:
                    line = 'out-height         =ellipsoidal # (0:ellipsoidal,1:geodetic)\n'
                if 'outstr1-path' in line:
                    if outstr1_type == 2:
                            r1 = self.lineEdit_out1path.text()[-1:]
                            if r1 == '/':
                                line = 'outstr1-path       =' + self.lineEdit_out1path.text() + d2[0] + '_out1.log\n'
                            else:
                                line = 'outstr1-path       =' + self.lineEdit_out1path.text() + '/' + d2[0] + '_out1.log\n'
                    else:
                        if 'outstr1-path' in line:
                            line = 'outstr1-path       =' + self.lineEdit_out1path.text() + '\n'
                if 'outstr2-path' in line:
                    if outstr2_type == 2:
                            r1 = self.lineEdit_out2path.text()[-1:]
                            if r1 == '/':
                                line = 'outstr2-path       =' + self.lineEdit_out2path.text() + d2[0] + '_out2.log\n'
                            else:
                                line = 'outstr2-path       =' + self.lineEdit_out2path.text() + '/' + d2[0] + '_out2.log\n'
                    else:
                        if 'outstr2-path' in line:
                            line = 'outstr2-path       =' + self.lineEdit_out2path.text() + '\n'
                if 'file-cmdfile1' in line:
                    if self.combo8.currentIndex() == 0:
                        line = d[0] + '=\n'
                    else:
                        line = d[0] + '=../../../data/' + self.combo8.itemText(file_cmdfile1) + '\n'
                    cmdfile1 = 1
                if 'file-cmdfile2' in line:
                    if self.combo9.currentIndex() == 0:
                        line = d[0] + '=\n'
                    else:
                        line = d[0] + '=../../../data/' + self.combo9.itemText(file_cmdfile2) + '\n'
                    cmdfile2 = 1
                dat = dat + line
            if cmdfile1 == 0:
                if self.combo8.currentIndex() == 0:
                    line = 'file-cmdfile1      =\n'
                else:
                    line = 'file-cmdfile1      =../../../data/' + self.combo8.itemText(file_cmdfile1) + '\n'
                dat = dat + line
            if cmdfile2 == 0:
                if self.combo9.currentIndex() == 0:
                    line = 'file-cmdfile2      =\n'
                else:
                    line = 'file-cmdfile2      =../../../data/' + self.combo9.itemText(file_cmdfile2) + '\n'
                dat = dat + line

        fname = open(conf_name, 'w')
        fname.write(dat)
        fname.close()
        if sys.platform == "win32":
            QMessageBox.information(self, u'OS未対応', u'Windowsでは接続できません。')
            return
        sh_text = 'cd ' + self.lineEdit_rtkrcv_path.text() + '\n'
        if self.checkBox_mOption.isChecked():
            sh_text = sh_text + './rtkrcv -o ' + conf_name + ' -m 52001\n'
        else:
            sh_text = sh_text + './rtkrcv -o ' + conf_name + '\n'
        fname = open(self.lineEdit_rtkrcv_path.text() + 'rtkrcv_run.sh', 'w')
        fname.write(sh_text)
        fname.close()
        cmd = 'chmod 755 ' + self.lineEdit_rtkrcv_path.text() + 'rtkrcv_run.sh'
        subprocess.check_output(cmd,shell=True)
        cmd = 'lxterminal -e ' + self.lineEdit_rtkrcv_path.text() + 'rtkrcv_run.sh'
        subprocess.call(cmd,shell=True)

    # リスト選択
    def SetList2(self):
        try:
            datname = os.path.dirname(__file__) + u'/RTK_CONF/' + self.combo_path.currentText() + '.dat'
            for line in open(datname,'r'):
                dat = line.split(('$'))
            self.combo1.setCurrentIndex(int(dat[0]))
            self.combo2.setCurrentIndex(int(dat[1]))
            self.lineEdit3.setText(dat[2])
            self.lineEdit4.setText(dat[3])
            self.combo5.setCurrentIndex(int(dat[4]))
            self.combo6.setCurrentIndex(int(dat[5]))
            self.combo7.setCurrentIndex(int(dat[6]))
            self.combo8.setCurrentIndex(int(dat[7]))
            self.combo9.setCurrentIndex(int(dat[8]))
            self.combo10.setCurrentIndex(int(dat[9]))
            self.combo11.setCurrentIndex(int(dat[10]))
            self.lineEdit12.setText(dat[11])
            self.combo_Rover.setCurrentIndex(int(dat[12]))
            self.combo_Base.setCurrentIndex(int(dat[13]))
            self.lineEditL1.setText(dat[14])
            self.lineEditL2.setText(dat[15])
            self.lineEditL5.setText(dat[16])
            self.lineEdit14.setText(dat[17])
            self.lineEdit15.setText(dat[18])
            self.combo16.setCurrentIndex(int(dat[19]))
            self.combo17.setCurrentIndex(int(dat[20]))
            self.lineEdit18.setText(dat[21])
            self.lineEdit19.setText(dat[22])
            self.lineEdit20.setText(dat[23])
            self.combo21.setCurrentIndex(int(dat[24]))
            self.combo22.setCurrentIndex(int(dat[25]))
            self.combo23.setCurrentIndex(int(dat[26]))
            self.combo24.setCurrentIndex(int(dat[27]))
            self.combo8.setCurrentIndex(int(dat[28]))
            self.combo9.setCurrentIndex(int(dat[30]))
        except:
            pass

    # outstr1-path
    def SetPath1(self):
        osp = os.path.dirname(__file__).split('/')
        if self.combo21.currentIndex() == 1:
            self.lineEdit_out1path.setText('ttyACM1:230400:8:n:1:off')
        elif self.combo21.currentIndex() == 2:
            self.lineEdit_out1path.setText('/home/' + osp[2] + '/RTK_TOOL3/log/')
        elif self.combo21.currentIndex() == 4:
            self.lineEdit_out1path.setText(':@localhost:52001/:')
            self.checkBox_mOption.setChecked(True)

    # outstr2-path
    def SetPath2(self):
        osp = os.path.dirname(__file__).split('/')
        if self.combo22.currentIndex() == 1:
            self.lineEdit_out2path.setText('ttyACM1:230400:8:n:1:off')
        elif self.combo22.currentIndex() == 2:
            self.lineEdit_out2path.setText('/home/' + osp[2] + '/RTK_TOOL3/log/')
        elif self.combo22.currentIndex() == 4:
            self.lineEdit_out2path.setText(':@localhost:52001/:')
            self.checkBox_mOption.setChecked(True)

    # STR2STRよりパスを取得
    def getPath(self):
        self.lineEdit3.setText(self.combo_port.currentText() + ':' + self.combo_baudrate.currentText() + ':8:n:1:off')
        self.lineEdit4.setText(self.lineEdit_ID.text() + ':' + self.lineEdit_Pass.text() + '@' + self.lineEdit_Host.text() + ':' + self.lineEdit_Port.text() + '/' + self.lineEdit_Mountpoint.text())


# 平均計算--------------------------------------------------------------------------------------------------------------------------------------------------------------------

    # ログファイル読込
    def read_log(self):
        log_name = tkFileDialog.askopenfilename(filetypes = [(u'ログファイル','*.*')], initialdir = os.path.dirname(__file__) + u'/log/') 
        if not log_name:
            return
        self.lineEdit_log.setText(log_name)
        self.textEdit_log.clear()
        self.lineEdit_lat.clear()
        self.lineEdit_lng.clear()
        self.lineEdit_h1.clear()
        self.lineEdit_g.clear()
        self.lineEdit_x.clear()
        self.lineEdit_y.clear()
        self.lineEdit_h2.clear()
        self.lineEdit_m.clear()
        self.lineEdit_s.clear()
        self.lineEdit_n.clear()
        if self.lineEdit_ratio.text() == '':
            self.lineEdit_ratio.setText('0')
        n = 0
        Lat = 0
        Lon = 0
        Height = 0
        with open(log_name, "r") as f:
            line = f.readline()
            for line in f:
                if line[0:1] != '%':
                    dat = re.sub(r" +", ",", line.replace(u'\n', ''))
                    d = dat.split(',')
                    ratio = float(d[14])
                    Lat0 = float(d[2])
                    Lon0 = float(d[3])
                    Height0 = float(d[4])
                    fix = d[5]
                    if self.radioButton_fix.isChecked() and fix == '1':
                        if Lat0 != 0 and Lon0 != 0:
                            self.textEdit_log.append(dat)
                            Lat = Lat + Lat0
                            Lon = Lon + Lon0
                            Height = Height + Height0
                            n = n + 1
                    elif self.radioButton_all.isChecked():
                        if Lat0 != 0 and Lon0 != 0:
                            self.textEdit_log.append(dat)
                            Lat = Lat + Lat0
                            Lon = Lon + Lon0
                            Height = Height + Height0
                            n = n + 1
                    elif self.radioButton_ratio.isChecked() and ratio >= float(self.lineEdit_ratio.text()):
                        if Lat0 != 0 and Lon0 != 0:
                            self.textEdit_log.append(dat)
                            Lat = Lat + Lat0
                            Lon = Lon + Lon0
                            Height = Height + Height0
                            n = n + 1
        if n == 0:
            QMessageBox.information(self, u'エラー', u'該当するデータがありません。')
            return
        Lat = round(Lat / n, 9)
        Lon = round(Lon / n, 9)
        Height = round(Height / n, 4)
        self.lineEdit_lat.setText(str(Lat))
        self.lineEdit_lng.setText(str(Lon))
        self.lineEdit_h1.setText(str(Height))
        self.lineEdit_n.setText(str(n))
        zone = str(self.comboBox_kei.currentIndex() + 1)
        URL = "https://vldb.gsi.go.jp/sokuchi/surveycalc/surveycalc/bl2xy.pl?outputType=json&refFrame=2&zone=" + zone  + u"&latitude=" + str(Lat) + u"&longitude=" + str(Lon)
        req = urllib.request.Request(URL)
        with urllib.request.urlopen(req) as res:
            data = json.load(res)
            try:
                OutputData  = str(data['OutputData'])
                OutputData = OutputData.replace('{', '')
                OutputData = OutputData.replace('}', '')
                OutputData = OutputData.replace("'", '')
                OutputData = OutputData.replace(' ', '')
                OutputData = OutputData.replace('publicX:', '')
                OutputData = OutputData.replace('publicY:', '')
                OutputData = OutputData.replace('latitude:', '')
                OutputData = OutputData.replace('longitude:', '')
                OutputData = OutputData.replace('gridConv:', '')
                OutputData = OutputData.replace('scaleFactor:', '')
                OutputData = OutputData.replace('zone:', '')
                OutputData = OutputData.replace('ellipsoid:', '')
                OutputData = OutputData.replace('refFrame:', '')
                OutputData = OutputData.replace(u'uu', '')
                dat = OutputData.split(u',')
                self.lineEdit_x.setText(dat[0])
                self.lineEdit_y.setText(dat[1])
                self.lineEdit_m.setText(dat[2])
                self.lineEdit_s.setText(dat[3])
            except:
                QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')
        URL = "http://vldb.gsi.go.jp/sokuchi/surveycalc/geoid/calcgh/cgi/geoidcalc.pl?outputType=json&" + u"&latitude=" + str(Lat) + u"&longitude=" + str(Lon)
        req = urllib.request.Request(URL)
        with urllib.request.urlopen(req) as res:
            data = json.load(res)
            try:
                OutputData  = str(data['OutputData'])
                OutputData = OutputData.replace('{', '')
                OutputData = OutputData.replace('}', '')
                OutputData = OutputData.replace("'", '')
                OutputData = OutputData.replace(' ', '')
                OutputData = OutputData.replace('latitude:', '')
                OutputData = OutputData.replace('longitude:', '')
                OutputData = OutputData.replace('geoidHeight:', '')
                OutputData = OutputData.replace(u'uu', '')
                dat = OutputData.split(u',')
                self.lineEdit_g.setText(dat[2])
                self.lineEdit_h2.setText(str(round(float(Height) - float(dat[2]), 3)))
            except:
                QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')

    # 再計算 & 平面直角座標→緯度・経度変換
    def saikeisan(self):
        log_name = self.lineEdit_log.text()
        self.textEdit_log.clear()
        self.lineEdit_g.clear()
        self.lineEdit_x.clear()
        self.lineEdit_y.clear()
        self.lineEdit_h2.clear()
        self.lineEdit_m.clear()
        self.lineEdit_s.clear()
        self.lineEdit_n.clear()
        if self.check_trans.isChecked():
            if self.lineEdit_lat.text() == '' or self.lineEdit_lng.text() == '' or self.lineEdit_h1.text() == '':
                return
            if self.lineEdit_ih.text() == '':
                self.lineEdit_ih.setText('0.000')
            x = str(round(float(self.lineEdit_lat.text()), 3))
            y = str(round(float(self.lineEdit_lng.text()), 3))
            h = str(round(float(self.lineEdit_h1.text()) + float(self.lineEdit_ih.text()), 3))
            zone = str(self.comboBox_kei.currentIndex() + 1)
            URL = "http://vldb.gsi.go.jp/sokuchi/surveycalc/surveycalc/xy2bl.pl?outputType=json&refFrame=2&zone=" + zone  + u"&publicX=" + x + u"&publicY=" + y
            req = urllib.request.Request(URL)
            with urllib.request.urlopen(req) as res:
                data = json.load(res)
                try:
                    OutputData  = str(data['OutputData'])
                    OutputData = OutputData.replace('{', '')
                    OutputData = OutputData.replace('}', '')
                    OutputData = OutputData.replace("'", '')
                    OutputData = OutputData.replace(' ', '')
                    OutputData = OutputData.replace('latitude:', '')
                    OutputData = OutputData.replace('longitude:', '')
                    OutputData = OutputData.replace('gridConv:', '')
                    OutputData = OutputData.replace('scaleFactor:', '')
                    OutputData = OutputData.replace(u'uu', '')
                    dat = OutputData.split(u',')
                    self.lineEdit_x.setText(dat[0])
                    self.lineEdit_y.setText(dat[1])
                    self.lineEdit_m.setText(dat[2])
                    self.lineEdit_s.setText(dat[3])
                except:
                    QtGui.QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')
            URL = "http://vldb.gsi.go.jp/sokuchi/surveycalc/geoid/calcgh/cgi/geoidcalc.pl?outputType=json&latitude=" + str(dat[0]) + u"&longitude=" + str(dat[1])
            req = urllib.request.Request(URL)
            with urllib.request.urlopen(req) as res:
                data = json.load(res)
                try:
                    OutputData  = str(data['OutputData'])
                    OutputData = OutputData.replace('{', '')
                    OutputData = OutputData.replace('}', '')
                    OutputData = OutputData.replace("'", '')
                    OutputData = OutputData.replace(' ', '')
                    OutputData = OutputData.replace('latitude:', '')
                    OutputData = OutputData.replace('longitude:', '')
                    OutputData = OutputData.replace('geoidHeight:', '')
                    OutputData = OutputData.replace(u'uu', '')
                    dat = OutputData.split(u',')
                    self.lineEdit_g.setText(dat[2])
                    self.lineEdit_h2.setText(str(round(float(h) + float(dat[2]), 3)))
                except:
                    QtGui.QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')
            if self.check_tenki.isChecked():
                self.base_lat.setText(self.lineEdit_x.text())
                self.base_lon.setText(self.lineEdit_y.text())
                self.base_alt.setText(self.lineEdit_h2.text())
        elif self.check_trans2.isChecked():
            if self.lineEdit_lat.text() == '' or self.lineEdit_lng.text() == '' or self.lineEdit_h1.text() == '':
                return
            if self.lineEdit_ih.text() == '':
                self.lineEdit_ih.setText('0.000')
            Height = str(round(float(self.lineEdit_h1.text()), 3))
            Lat = str(round(float(self.lineEdit_lat.text()), 9))
            Lon = str(round(float(self.lineEdit_lng.text()), 9))
            h = str(round(float(self.lineEdit_h1.text()) + float(self.lineEdit_ih.text()), 3))
            zone = str(self.comboBox_kei.currentIndex() + 1)
            URL = "https://vldb.gsi.go.jp/sokuchi/surveycalc/surveycalc/bl2xy.pl?outputType=json&refFrame=2&zone=" + zone  + u"&latitude=" + Lat + u"&longitude=" + Lon
            req = urllib.request.Request(URL)
            with urllib.request.urlopen(req) as res:
                data = json.load(res)
                try:
                    OutputData  = str(data['OutputData'])
                    OutputData = OutputData.replace('{', '')
                    OutputData = OutputData.replace('}', '')
                    OutputData = OutputData.replace("'", '')
                    OutputData = OutputData.replace(' ', '')
                    OutputData = OutputData.replace('publicX:', '')
                    OutputData = OutputData.replace('publicY:', '')
                    OutputData = OutputData.replace('latitude:', '')
                    OutputData = OutputData.replace('longitude:', '')
                    OutputData = OutputData.replace('gridConv:', '')
                    OutputData = OutputData.replace('scaleFactor:', '')
                    OutputData = OutputData.replace('zone:', '')
                    OutputData = OutputData.replace('ellipsoid:', '')
                    OutputData = OutputData.replace('refFrame:', '')
                    OutputData = OutputData.replace(u'uu', '')
                    dat = OutputData.split(u',')
                    self.lineEdit_x.setText(dat[0])
                    self.lineEdit_y.setText(dat[1])
                    self.lineEdit_m.setText(dat[2])
                    self.lineEdit_s.setText(dat[3])
                except:
                    QtGui.QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')
            URL = "http://vldb.gsi.go.jp/sokuchi/surveycalc/geoid/calcgh/cgi/geoidcalc.pl?outputType=json&latitude=" + Lat + u"&longitude=" + Lon
            req = urllib.request.Request(URL)
            with urllib.request.urlopen(req) as res:
                data = json.load(res)
                try:
                    OutputData = str(data['OutputData'])
                    OutputData = OutputData.replace('{', '')
                    OutputData = OutputData.replace('}', '')
                    OutputData = OutputData.replace("'", '')
                    OutputData = OutputData.replace(' ', '')
                    OutputData = OutputData.replace('latitude:', '')
                    OutputData = OutputData.replace('longitude:', '')
                    OutputData = OutputData.replace('geoidHeight:', '')
                    OutputData = OutputData.replace(u'uu', '')
                    dat = OutputData.split(u',')
                    self.lineEdit_g.setText(dat[2])
                    self.lineEdit_h2.setText(str(round(float(Height) - float(dat[2]), 3)))
                except:
                    QtGui.QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')
        else:
            if self.lineEdit_ratio.text() == '':
                self.lineEdit_ratio.setText('0')
            if log_name == '':
                if self.lineEdit_lat.text() == '' or self.lineEdit_lng.text() == '':
                    return
                Lat = str(round(float(self.lineEdit_lat.text()), 9))
                Lon = str(round(float(self.lineEdit_lng.text()), 9))
                if self.lineEdit_h1.text() == '':
                    Height = -9999
                else:
                    Height = str(round(float(self.lineEdit_h1.text()), 3))
            else:
                n = 0
                Lat = 0
                Lon = 0
                Height = 0
                with open(log_name, "r") as f:
                    line = f.readline()
                    for line in f:
                        if line[0:1] != '%':
                            dat = re.sub(r" +", ",", line.replace(u'\n', ''))
                            d = dat.split(',')
                            ratio = float(d[14])
                            Lat0 = float(d[2])
                            Lon0 = float(d[3])
                            Height0 = float(d[4])
                            fix = d[5]
                            if self.radioButton_fix.isChecked() and fix == '1':
                                if Lat0 != 0 and Lon0 != 0:
                                    self.textEdit_log.append(dat)
                                    Lat = Lat + Lat0
                                    Lon = Lon + Lon0
                                    Height = Height + Height0
                                    n = n + 1
                            elif self.radioButton_all.isChecked():
                                if Lat0 != 0 and Lon0 != 0:
                                    self.textEdit_log.append(dat)
                                    Lat = Lat + Lat0
                                    Lon = Lon + Lon0
                                    Height = Height + Height0
                                    n = n + 1
                            elif self.radioButton_ratio.isChecked() and ratio >= float(self.lineEdit_ratio.text()):
                                if Lat0 != 0 and Lon0 != 0:
                                    self.textEdit_log.append(dat)
                                    Lat = Lat + Lat0
                                    Lon = Lon + Lon0
                                    Height = Height + Height0
                                    n = n + 1
                if n == 0:
                    QMessageBox.information(self, u'エラー', u'該当するデータがありません。')
                    return
                Lat = round(Lat / n, 9)
                Lon = round(Lon / n, 9)
                Height = round(Height / n, 4)
                self.lineEdit_lat.setText(str(Lat))
                self.lineEdit_lng.setText(str(Lon))
                self.lineEdit_h1.setText(str(Height))
                self.lineEdit_n.setText(str(n))
            zone = str(self.comboBox_kei.currentIndex() + 1)
            URL = "https://vldb.gsi.go.jp/sokuchi/surveycalc/surveycalc/bl2xy.pl?outputType=json&refFrame=2&zone=" + zone  + u"&latitude=" + str(Lat) + u"&longitude=" + str(Lon)
            req = urllib.request.Request(URL)
            with urllib.request.urlopen(req) as res:
                data = json.load(res)
                try:
                    OutputData = str(data['OutputData'])
                    OutputData = OutputData.replace('{', '')
                    OutputData = OutputData.replace('}', '')
                    OutputData = OutputData.replace("'", '')
                    OutputData = OutputData.replace(' ', '')
                    OutputData = OutputData.replace('publicX:', '')
                    OutputData = OutputData.replace('publicY:', '')
                    OutputData = OutputData.replace('latitude:', '')
                    OutputData = OutputData.replace('longitude:', '')
                    OutputData = OutputData.replace('gridConv:', '')
                    OutputData = OutputData.replace('scaleFactor:', '')
                    OutputData = OutputData.replace('zone:', '')
                    OutputData = OutputData.replace('ellipsoid:', '')
                    OutputData = OutputData.replace('refFrame:', '')
                    OutputData = OutputData.replace(u'uu', '')
                    dat = OutputData.split(u',')
                    self.lineEdit_x.setText(dat[0])
                    self.lineEdit_y.setText(dat[1])
                    self.lineEdit_m.setText(dat[2])
                    self.lineEdit_s.setText(dat[3])
                except:
                    QtGui.QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')
            URL = "http://vldb.gsi.go.jp/sokuchi/surveycalc/geoid/calcgh/cgi/geoidcalc.pl?outputType=json&latitude=" + str(Lat) + u"&longitude=" + str(Lon)
            req = urllib.request.Request(URL)
            with urllib.request.urlopen(req) as res:
                data = json.load(res)
                try:
                    OutputData  = str(data['OutputData'])
                    OutputData = OutputData.replace('{', '')
                    OutputData = OutputData.replace('}', '')
                    OutputData = OutputData.replace("'", '')
                    OutputData = OutputData.replace(' ', '')
                    OutputData = OutputData.replace('latitude:', '')
                    OutputData = OutputData.replace('longitude:', '')
                    OutputData = OutputData.replace('geoidHeight:', '')
                    OutputData = OutputData.replace(u'uu', '')
                    dat = OutputData.split(u',')
                    self.lineEdit_g.setText(dat[2])
                    self.lineEdit_h2.setText(str(round(float(Height) - float(dat[2]), 3)))
                except:
                    QtGui.QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')

    # 結果をテキストで保存する
    def save_result(self):
        savename = tkFileDialog.asksaveasfilename(filetypes = [(u'TEXTファイル','*.txt')], initialdir = os.path.dirname(__file__) + u'/data/') 
        if not savename:
            return
        if self.radioButton_fix.isChecked():
           dat = 'Fix'
        elif self.radioButton_all.isChecked():
           dat = 'All'
        elif self.radioButton_ratio.isChecked():
           dat = 'Ratio:' + self.lineEdit_ratio.text() + u'以上'
        savetext = dat + u'（' + self.lineEdit_n.text() + u'点）\n'
        savetext = savetext + u'-----------------------------------\n'
        savetext = savetext + u'緯度           =  ' + self.lineEdit_lat.text() + '\n'
        savetext = savetext + u'経度           = ' + self.lineEdit_lng.text() + '\n'
        savetext = savetext + u'楕円体高       = ' + self.lineEdit_h1.text() + '\n'
        if self.lineEdit_ih.text() != '':
            savetext = savetext + u'器械高         = ' + self.lineEdit_ih.text() + '\n'
        savetext = savetext + u'-----------------------------------\n'
        savetext = savetext + u'平面直角座標系 = ' + self.comboBox_kei.currentText() + '\n'
        savetext = savetext + u'-----------------------------------\n'
        savetext = savetext + u'Ｘ座標         = ' + self.lineEdit_x.text() + '\n'
        savetext = savetext + u'Ｙ座標         = ' + self.lineEdit_y.text() + '\n'
        savetext = savetext + u'真北方向角     = ' + self.lineEdit_m.text() + '\n'
        savetext = savetext + u'縮尺係数       = ' + self.lineEdit_s.text() + '\n'
        savetext = savetext + u'ジオイド高     = ' + self.lineEdit_g.text() + '\n'
        savetext = savetext + u'-----------------------------------\n'
        savetext = savetext + u'標高           = ' + self.lineEdit_h2.text() + '\n'
        savetext = savetext + u'-----------------------------------\n'
        if sys.platform == "win32":
            savename = savename + u'.txt'
        with open(savename, "w") as f:
            f.write(savetext)
        filename = os.path.basename(str(savename))
        fn, ext = os.path.splitext(filename)
        d = datetime.datetime.today()
        daystr = d.strftime("%Y%m%d")
        savename2 = os.path.dirname(__file__) + u'/data/' + daystr + u'.csv'
        savetext2 = fn + ',' + self.lineEdit_lat.text() + ',' + self.lineEdit_lng.text() + ',' + self.lineEdit_h1.text() + ',' + self.lineEdit_ih.text() + ',' + self.lineEdit_x.text() + ',' + self.lineEdit_y.text() + ',' + self.lineEdit_m.text() + ',' + self.lineEdit_s.text() + ',' + self.lineEdit_g.text() + ',' + self.lineEdit_h2.text() + ',\n'
        with open(savename2, "a") as f:
            f.write(savetext2)
        QMessageBox.information(self, u'平均結果保存', savename + u'を作成しました。')

    # SIMA変換
    def sima(self):
        csv_name = tkFileDialog.askopenfilename(filetypes = [(u'CSVファイル','*.csv')], initialdir = os.path.dirname(__file__) + u'/data/') 
        if not csv_name:
            return
        sima = 'G00,01,RTK_TOOL,,\n'
        sima = sima + 'Z00,,\n'
        sima = sima + 'A00,\n'
        n = 1
        with open(csv_name, "r") as f:
            line = f.readline()
            for line in f:
                dat = line.split(',')
                sima = sima + 'A01,' + str(n) + ',' + str(dat[0]) + ',' + str(dat[5]) + ',' + str(dat[6]) + ',' + str(dat[10]) + ',\n'
                n = n + 1
        sima = sima + 'A99,\n'
        try:
            filename = os.path.basename(str(csv_name))
            fn, ext = os.path.splitext(filename)
            savename = os.path.dirname(__file__) + u'/data/' + fn + u'.sim'
            with open(savename, "w") as f:
                f.write(sima)
            QMessageBox.information(self, u'SIMA変換', savename + u'を作成しました。')
        except:
            QMessageBox.information(self, u'エラー', savename + u'を作成できませんでした。')

    # KMLを作成する
    def kml(self):
        if self.textEdit_log.toPlainText() == '':
            return
        log_name = os.path.dirname(__file__) + u'/data/kml.txt'
        with open(log_name, "w") as f:
            f.write(self.textEdit_log.toPlainText())   
        kmlname = tkFileDialog.asksaveasfilename(filetypes = [(u'KMLファイル','*.kml')], initialdir = os.path.dirname(__file__) + u'/data/') 
        if not kmlname:
            return
        point_text = ''
        rosen_text = ''
        kml_text = '<?xml version=' + '"' + '1.0' + '"' + ' encoding=' + '"' + 'UTF-8' + '"' + '?>\n'
        kml_text = kml_text + '<kml xmlns=' + '"' + 'http://www.opengis.net/kml/2.2' + '"' + ' xmlns:gx=' + '"' + 'http://www.google.com/kml/ext/2.2' + '"' +' xmlns:kml=' + '"' + 'http://www.opengis.net/kml/2.2' + '"' + ' xmlns:atom=' + '"' + 'http://www.w3.org/2005/Atom' + '"' + '>\n'
        kml_text = kml_text + '    <Document>\n'
        kml_text = kml_text + '        <name></name>\n'
        kml_text = kml_text + '        <StyleMap id=' + '"' + 'my_line' + '"' + '>\n'
        kml_text = kml_text + '            <Pair>\n'
        kml_text = kml_text + '                <key>normal</key>\n'
        kml_text = kml_text + '                <styleUrl>#s_my_line</styleUrl>\n'
        kml_text = kml_text + '            </Pair>\n'
        kml_text = kml_text + '        </StyleMap>\n'
        kml_text = kml_text + '        <Style id=' + '"' + 's_my_line' + '"' + '>\n'
        kml_text = kml_text + '            <LineStyle>\n'
        kml_text = kml_text + '                <color>880000ff</color>\n'
        kml_text = kml_text + '                <width>2</width>\n'
        kml_text = kml_text + '            </LineStyle>\n'
        kml_text = kml_text + '            <PolyStyle>\n'
        kml_text = kml_text + '                <fill>0</fill>\n'
        kml_text = kml_text + '            </PolyStyle>\n'
        kml_text = kml_text + '        </Style>\n'
        k = 0
        with open(log_name, "r") as f:
            line = f.readline()
            for line in f:
                dat = line.replace((u'\n'), '').replace((u'\r'), '').split(',')
                name = str(dat[0]).replace('/','') + str(dat[1]).replace(':','').replace('.000','')
                bb = str(dat[2])
                ll = str(dat[3])
                hh = str(dat[4])
                ratio = str(dat[14])
                point_text = point_text + '        <Placemark>\n'
                point_text = point_text + '          <name>' + name + '</name>\n'
                point_text = point_text + '          <description><![CDATA[<div>Latitude= ' + bb + '</div><div>Longitude= ' + ll + '</div><div>Altitude= ' + hh + '</div><div>Ratio= ' + ratio + '</div>]]></description>\n'
                point_text = point_text + '          <Point>\n'
                point_text = point_text + '              <coordinates>' + ll + ',' + bb + ',' + hh + '</coordinates>\n'
                point_text = point_text + '          </Point>\n'
                point_text = point_text + '        </Placemark>\n'
                point = ll + ',' + bb + ',' + hh + ' '
                if k == 0:
                    rosen_text = rosen_text + '        <Placemark>\n'
                    rosen_text = rosen_text + '            <name>track</name>\n'
                    rosen_text = rosen_text + '            <description>track</description>\n'
                    rosen_text = rosen_text + '            <styleUrl>#my_line</styleUrl>\n'
                    rosen_text = rosen_text + '            <LineString>\n'
                    rosen_text = rosen_text + '                <tessellate>1</tessellate>\n'
                    rosen_text = rosen_text + '                <altitudeMode>relativeToGround</altitudeMode>\n'
                    rosen_text = rosen_text + '                    <coordinates>\n'
                    coordinates = '                            ' + point
                    k = 1
                else:
                    coordinates = coordinates + point
        rosen_text = rosen_text + coordinates +'\n'
        rosen_text = rosen_text + '                    </coordinates>\n'
        rosen_text = rosen_text + '            </LineString>\n'
        rosen_text = rosen_text + '        </Placemark>\n'
        kml_text = kml_text + rosen_text + point_text
        kml_text = kml_text + '    </Document>\n'
        kml_text = kml_text + '</kml>\n'
        if sys.platform == "win32":
            kmlname = kmlname + u'.kml'
        with open(kmlname, "w") as f:
            f.write(kml_text)
        QMessageBox.information(self, u'KML変換', kmlname + u'を作成しました。')
        try:
            os.remove(log_name)
        except:
            pass

    # 抽出したログを保存する
    def logsave(self):
        if self.textEdit_log.toPlainText() == '':
            return
        savename = tkFileDialog.asksaveasfilename(filetypes = [(u'ログファイル','*.pos')], initialdir = os.path.dirname(__file__) + u'/data/')
        if not savename:
            return
        if sys.platform == "win32":
            savename = savename + u'.pos'
        with open(savename, "w") as f:
            f.write(self.textEdit_log.toPlainText())
        QMessageBox.information(self, u'抽出ログ保存', savename + u'を作成しました。')

    # 結果をSemiDynaEXEタブに送る
    def tenki(self):
        self.le_b1.setText(self.lineEdit_lat.text())
        self.le_l1.setText(self.lineEdit_lng.text())
        self.comboBox_kei2.setCurrentIndex(self.comboBox_kei.currentIndex())
        self.le_x1.setText(self.lineEdit_x.text())
        self.le_y1.setText(self.lineEdit_y.text())
        self.le_h1.setText(self.lineEdit_h2.text())
        self.konki_genki.setChecked(True)
        self.opt_xy.setChecked(True)
        self.tabWidget.setCurrentIndex(3)
        self.SemiDynaEXE()

    def ChangeTitle(self):
        if self.check_trans.isChecked():
            self.label_38.setText('Ｘ座標')
            self.label_39.setText('Ｙ座標')
            self.label_40.setText('標高')
            self.label_85.setText('緯度')
            self.label_87.setText('経度')
            self.label_86.setText('楕円体高')
            self.check_tenki.setEnabled(True)
            self.lineEdit_ih.setFocus()
        elif self.check_trans2.isChecked():
            self.label_38.setText('緯度')
            self.label_39.setText('経度')
            self.label_40.setText('楕円体高')
            self.label_85.setText('Ｘ座標')
            self.label_87.setText('Ｙ座標')
            self.label_86.setText('標高')
            self.check_tenki.setChecked(False)
            self.check_tenki.setEnabled(False)
            self.lineEdit_ih.setFocus()
        elif self.check_file.isChecked():
            self.label_38.setText('緯度')
            self.label_39.setText('経度')
            self.label_40.setText('楕円体高')
            self.label_85.setText('Ｘ座標')
            self.label_87.setText('Ｙ座標')
            self.label_86.setText('標高')
            self.check_tenki.setChecked(False)
            self.check_tenki.setEnabled(False)
            self.pushButton_read.setFocus()

# SemiDynaEXE-----------------------------------------------------------------------------------------------------------------------------------------------------------------

    # SemiDynaEXE実行
    def SemiDynaEXE(self):
        self.le_b2.setText('')
        self.le_l2.setText('')
        self.le_x2.setText('')
        self.le_y2.setText('')
        self.le_h2.setText('')
        self.le_geoid.setText('')
        self.le_h3.setText('')
        chiiki = self.par.text()
        if self.genki_konki.isChecked():
            sokuchi = 0
        else:
            sokuchi = 1
        Lat  = self.le_b1.text()
        Lon = self.le_l1.text()
        if self.le_h1.text() == '':
            flag = 0
            Height ='0'
        else:
            flag = 1
            Height = self.le_h1.text()
        zon = self.comboBox_kei2.currentIndex() + 1
        pubX = self.le_x1.text()
        pubY = self.le_y1.text()
        if self.opt_bl.isChecked():
            URL = "http://vldb.gsi.go.jp/sokuchi/surveycalc/semidyna/web/semidyna_r.php?outputType=json&chiiki=" + str(chiiki) + u"&sokuchi=" + str(sokuchi) + u"&Place=0&Hosei_J=3&latitude=" + str(Lat) + u"&longitude=" + str(Lon) + u"&altitude1=" + str(Height)
        else:
            URL = "http://vldb.gsi.go.jp/sokuchi/surveycalc/semidyna/web/semidyna_r.php?outputType=json&chiiki=" + str(chiiki) + u"&sokuchi=" + str(sokuchi) + u"&Place=1&Hosei_J=3&zone=" + str(zon) + u"&publicX=" + str(pubX) + u"&publicY=" + str(pubY) + u"&altitude2=" + str(Height)
        req = urllib.request.Request(URL)
        with urllib.request.urlopen(req) as res:
            data = json.load(res)
            try:
                OutputData = str(data['OutputData'])
                OutputData = OutputData.replace('{', '')
                OutputData = OutputData.replace('}', '')
                OutputData = OutputData.replace("'", '')
                OutputData = OutputData.replace(' ', '')
                OutputData = OutputData.replace('latitude:', '')
                OutputData = OutputData.replace('longitude:', '')
                OutputData = OutputData.replace('zone:', '')
                OutputData = OutputData.replace('publicX:', '')
                OutputData = OutputData.replace('publicY:', '')
                OutputData = OutputData.replace('altitude:', '')
                OutputData = OutputData.replace(u'uu', '')
                dat = OutputData.split(u',')
                self.le_b2.setText(OutputData)
                if self.opt_bl.isChecked():
                    self.le_b2.setText(dat[0])
                    self.le_l2.setText(dat[1])
                    self.le_x2.setText('')
                    self.le_y2.setText('')
                    if flag == 1:
                        self.le_h2.setText(dat[2])
                else:
                    self.le_b2.setText(dat[0])
                    self.le_l2.setText(dat[1])
                    self.le_x2.setText(dat[3])
                    self.le_y2.setText(dat[4])
                    if flag == 1:
                        self.le_h2.setText(dat[5])
            except:
                QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')
        if flag == 1:
            URL = "http://vldb.gsi.go.jp/sokuchi/surveycalc/geoid/calcgh/cgi/geoidcalc.pl?outputType=json&" + u"&latitude=" + str(dat[0]) + u"&longitude=" + str(dat[1])
            req = urllib.request.Request(URL)
            with urllib.request.urlopen(req) as res:
                data = json.load(res)
                try:
                    OutputData  = str(data['OutputData'])
                    OutputData = OutputData.replace('{', '')
                    OutputData = OutputData.replace('}', '')
                    OutputData = OutputData.replace("'", '')
                    OutputData = OutputData.replace(' ', '')
                    OutputData = OutputData.replace('latitude:', '')
                    OutputData = OutputData.replace('longitude:', '')
                    OutputData = OutputData.replace('geoidHeight:', '')
                    OutputData = OutputData.replace(u'uu', '')
                    dat2 = OutputData.split(u',')
                    self.le_geoid.setText(dat2[2])
                    self.le_h3.setText(str(float(self.le_h2.text()) + float(dat2[2])))
                except:
                    QMessageBox.information(self, u'通信エラー', u'取得に失敗しました。\n再度、実行してください。')

    # 結果をテキストで保存する
    def hozon(self):
        if self.le_b2.text() == '' or self.le_l2.text() == '':
            return
        if self.opt_xy.isChecked() and (self.le_x2.text() == '' or self.le_y2.text() == ''):
            return
        savename = tkFileDialog.asksaveasfilename(filetypes = [(u'TEXTファイル','*.txt')], initialdir = os.path.dirname(__file__) + u'/data/') 
        if not savename:
            return
        if self.genki_konki.isChecked():
            houkou = u'変換方向：元期→今期'
        else:
            houkou = u'変換方向：今期→元期'
        savetext = u'セミダイナミック補正（国土地理院 測量計算API）\n'
        savetext = savetext + u'----------------------------------------------\n'
        savetext = savetext + houkou + '\n'
        savetext = savetext + u'補正パラメータ：' + self.par.text() + '\n'
        savetext = savetext + u'----------------------------------------------\n'
        if self.opt_bl.isChecked():
            savetext = savetext + u'入力値\n'
            savetext = savetext + u'緯度           = ' + self.le_b1.text() + '\n'
            savetext = savetext + u'経度           = ' + self.le_l1.text() + '\n'
            savetext = savetext + u'標高           = ' + self.le_h1.text() + '\n'
            savetext = savetext + u'----------------------------------------------\n'
            savetext = savetext + u'出力値\n'
            savetext = savetext + u'緯度           = ' + self.le_b2.text() + '\n'
            savetext = savetext + u'経度           = ' + self.le_l2.text() + '\n'
            savetext = savetext + u'標高           = ' + self.le_h2.text() + '\n'
            savetext = savetext + u'ジオイド高     = ' + self.le_geoid.text() + '\n'
            savetext = savetext + u'楕円体高       = ' + self.le_h3.text() + '\n'
            savetext = savetext + u'----------------------------------------------\n'
        else:
            savetext = savetext + u'入力値\n'
            savetext = savetext + u'平面直角座標系 = ' + self.comboBox_kei.currentText() + '\n'
            savetext = savetext + u'Ｘ座標         = ' + self.le_x1.text() + '\n'
            savetext = savetext + u'Ｙ座標         = ' + self.le_y1.text() + '\n'
            savetext = savetext + u'標高           = ' + self.le_h1.text() + '\n'
            savetext = savetext + u'----------------------------------------------\n'
            savetext = savetext + u'出力値\n'
            savetext = savetext + u'緯度           = ' + self.le_b2.text() + '\n'
            savetext = savetext + u'経度           = ' + self.le_l2.text() + '\n'
            savetext = savetext + u'Ｘ座標         = ' + self.le_x2.text() + '\n'
            savetext = savetext + u'Ｙ座標         = ' + self.le_y2.text() + '\n'
            savetext = savetext + u'標高           = ' + self.le_h2.text() + '\n'
            savetext = savetext + u'ジオイド高     = ' + self.le_geoid.text() + '\n'
            savetext = savetext + u'楕円体高       = ' + self.le_h3.text() + '\n'
            savetext = savetext + u'----------------------------------------------\n'
        if sys.platform == "win32":
            savename = savename + u'.txt'
        with open(savename, "w") as f:
            f.write(savetext)
        QMessageBox.information(self, u'補正結果保存', savename + u'を作成しました。')



# Logger----------------------------------------------------------------------------------------------------------------------------------------------------------------------
    # ボタン名変更
    def changeText(self):
        self.label_x2.setText('')
        self.label_y2.setText('')
        self.label_h2.setText('')
        if self.epoch.isChecked():
            self.epoch.setText(u'取得中')
        else:
            self.epoch.setText(u'開始')

    # 測点探索
    def SetEnable(self):
        if self.check2.isChecked():
            self.x1.setEnabled(True)
            self.y1.setEnabled(True)
            self.a.setEnabled(True)
            self.d.setEnabled(True)
            self.label_1.setEnabled(True)
            self.label_2.setEnabled(True)
            self.label_3.setEnabled(True)
            self.label_4.setEnabled(True)
            self.x1.setFocus()
        else:
            self.x1.clear()
            self.y1.clear()
            self.a.clear()
            self.d.clear()
            self.x1.setEnabled(False)
            self.y1.setEnabled(False)
            self.a.setEnabled(False)
            self.d.setEnabled(False)
            self.label_1.setEnabled(False)
            self.label_2.setEnabled(False)
            self.label_3.setEnabled(False)
            self.label_4.setEnabled(False)

    # Sentence選択
    def SetEnable2(self):
        self.lineEdit_Ratio.setEnabled(False)
        self.lineEdit_epoch.setEnabled(False)
        self.epoch.setEnabled(False)
        if self.comboBox_sentence.currentText() == 'RTKNAVI_RATIO' or self.comboBox_sentence.currentText() == 'TCP_RATIO':
            self.lineEdit_Ratio.setEnabled(True)
            self.lineEdit_Ratio.setFocus()
        if self.comboBox_sentence.currentText() == 'RTKNAVI_FIX' or self.comboBox_sentence.currentText() == 'RTKNAVI_ALL' or self.comboBox_sentence.currentText() == 'RTKNAVI_RATIO' or self.comboBox_sentence.currentText() == 'TCP_FIX' or self.comboBox_sentence.currentText() == 'TCP_ALL' or self.comboBox_sentence.currentText() == 'TCP_RATIO':
            self.epoch.setEnabled(True)
            self.lineEdit_epoch.setEnabled(True)

    # GPX保存
    def gpx_save(self):
        log_name = tkFileDialog.askopenfilename(filetypes = [(u'log or csvファイル','*.log *.csv')], initialdir = os.path.dirname(__file__) + u'/log/') 
        if not log_name:
            return
        filename = os.path.basename(str(log_name))
        fn, ext = os.path.splitext(filename)
        with open(log_name, "r") as f:
            line = f.readline()
            if ext == 'log':
                if str(line)[0:1] == '$':
                    QMessageBox.information(self, u'エラー', '「GNRMC/G`RMC」「GNGGA/GPGGA」「GNGLL/GPGLL」の何れかのログを選択してください。')
                    return
        os.chdir((os.path.dirname(__file__) + u'/log/').replace('/', '//'))
        gpxname = tkFileDialog.asksaveasfilename(filetypes = [(u'GPXファイル','*.gpx')], initialdir = os.path.dirname(__file__) + u'/log/') 
        if not gpxname:
            return
        gpx_text = '<?xml version=' + '"' + '1.0' + '"' + ' encoding=' + '"' + 'UTF-8' + '"' + '?>\n'
        gpx_text = gpx_text + '<gpx xmlns:xsi=' + '"' + 'http://www.w3.org/2001/XMLSchema-instance' + '"' + ' xmlns=' + '"' + 'http://www.topografix.com/GPX/1/0' + '"' +' xsi:schemaLocation=' + '"' + 'http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd' + '"' + '>\n'
        gpx_text = gpx_text + '    <trk>\n'
        gpx_text = gpx_text + '        <name>GNSS_Logger_Plugin</name>\n'
        gpx_text = gpx_text + '        <number>1</number>\n'
        gpx_text = gpx_text + '        <trkseg>\n'
        for line in open(log_name, 'r'):
            dat = line.replace((u'\n'), '').replace((u'\r'), '').split(',')
            name = str(dat[0])
            if len(name) == 14:
                day_time = name[0:4] + '-' + name[4:6] + '-' + name[6:8] + 'T' + name[8:10] + ':' + name[10:12] + ':' + name[12:14] + 'Z'
            elif len(name) == 15:
                day_time = '20' + name[4:6] + '-' + name[2:4] + '-' + name[0:2] + 'T' + name[6:8] + ':' + name[8:10] + ':' + name[10:15] + 'Z'
            elif len(name) == 9:
                day_time = 'T' + name[0:2] + ':' + name[2:4] + ':' + name[4:9] + 'Z'
            elif len(name) == 10:
                day_time = 'T' + name[0:2] + ':' + name[2:4] + ':' + name[4:10] + 'Z'
            bb = str(dat[1])
            ll = str(dat[2])
            hh = str(dat[3])
            gpx_text = gpx_text + '            <trkpt lat=' + '"' + bb + '"' + ' lon=' + '"' + ll + '"' + '><ele>' + hh + '</ele><time>' + day_time + '</time></trkpt>\n'
        gpx_text = gpx_text + '        </trkseg>\n'
        gpx_text = gpx_text + '    </trk>\n'
        gpx_text = gpx_text + '</gpx>\n'
        if sys.platform == "win32":
            gpxname = gpxname + u'.gpx'
        with open(gpxname, "w") as f:
            f.write(gpx_text)
        QMessageBox.information(self, u'GPX保存', gpxname + u'を作成しました。')

    # SIMA保存
    def sima_save(self):
        log_name = tkFileDialog.askopenfilename(filetypes = [(u'log or csvファイル','*.log *.csv')], initialdir = os.path.dirname(__file__) + u'/log/') 
        if not log_name:
            return
        filename = os.path.basename(str(log_name))
        fn, ext = os.path.splitext(filename)
        with open(log_name, "r") as f:
            line = f.readline()
            if ext == 'log':
                if str(line)[0:1] == '$':
                    QMessageBox.information(self, u'エラー', '「GNRMC/G`RMC」「GNGGA/GPGGA」「GNGLL/GPGLL」の何れかのログを選択してください。')
                    return
        os.chdir((os.path.dirname(__file__) + u'/log/').replace('/', '//'))
        simaname = tkFileDialog.asksaveasfilename(filetypes = [(u'SIMAファイル','*.sim')], initialdir = os.path.dirname(__file__) + u'/log/')
        if not simaname :
            return
        sima_text = 'G00,01,GNSS_Loggerﾃﾞｰﾀ,,\n'
        sima_text = sima_text + 'Z00,座標ﾃﾞｰﾀ,\n'
        sima_text = sima_text + 'A00,\n'
        k = 1
        for line in open(log_name, 'r'):
            dat = line.replace((u'\n'), '').replace((u'\r'), '').split(',')
            if dat[11] != '':
                name = str(dat[11])
            else:
                name = str(dat[0])
            hh = str(dat[3])
            xx = str(dat[6])
            yy = str(dat[7])
            sima_text = sima_text + 'A01,' + str(k) + ',' + name + ',' + xx + ',' + yy + ',' + hh + ',\n'
            k = k + 1
        sima_text = sima_text + 'A99,\n'
        if sys.platform == "win32":
            simaname = simaname + u'.sim'
        with open(simaname, "w") as f:
            f.write(sima_text)
        QMessageBox.information(self, u'SIMA保存', simaname + u'を作成しました。')

    # KML保存
    def kml_save(self):
        log_name = tkFileDialog.askopenfilename(filetypes = [(u'log or csvファイル','*.log *.csv')], initialdir = os.path.dirname(__file__) + u'/log/') 
        if not log_name:
            return
        filename = os.path.basename(str(log_name))
        fn, ext = os.path.splitext(filename)
        with open(log_name, "r") as f:
            line = f.readline()
            if ext == 'log':
                if str(line)[0:1] == '$':
                    QMessageBox.information(self, u'エラー', '「GNRMC/G`RMC」「GNGGA/GPGGA」「GNGLL/GPGLL」の何れかのログを選択してください。')
                    return
        os.chdir((os.path.dirname(__file__) + u'/log/').replace('/', '//'))
        kmlname = tkFileDialog.asksaveasfilename(filetypes = [(u'KMLファイル','*.kml')], initialdir = os.path.dirname(__file__) + u'/log/') 
        if not kmlname:
            return
        point_text = ''
        rosen_text = ''
        kml_text = '<?xml version=' + '"' + '1.0' + '"' + ' encoding=' + '"' + 'UTF-8' + '"' + '?>\n'
        kml_text = kml_text + '<kml xmlns=' + '"' + 'http://www.opengis.net/kml/2.2' + '"' + ' xmlns:gx=' + '"' + 'http://www.google.com/kml/ext/2.2' + '"' +' xmlns:kml=' + '"' + 'http://www.opengis.net/kml/2.2' + '"' + ' xmlns:atom=' + '"' + 'http://www.w3.org/2005/Atom' + '"' + '>\n'
        kml_text = kml_text + '    <Document>\n'
        kml_text = kml_text + '        <name></name>\n'
        kml_text = kml_text + '        <StyleMap id=' + '"' + 'my_line' + '"' + '>\n'
        kml_text = kml_text + '            <Pair>\n'
        kml_text = kml_text + '                <key>normal</key>\n'
        kml_text = kml_text + '                <styleUrl>#s_my_line</styleUrl>\n'
        kml_text = kml_text + '            </Pair>\n'
        kml_text = kml_text + '        </StyleMap>\n'
        kml_text = kml_text + '        <Style id=' + '"' + 's_my_line' + '"' + '>\n'
        kml_text = kml_text + '            <LineStyle>\n'
        kml_text = kml_text + '                <color>880000ff</color>\n'
        kml_text = kml_text + '                <width>2</width>\n'
        kml_text = kml_text + '            </LineStyle>\n'
        kml_text = kml_text + '            <PolyStyle>\n'
        kml_text = kml_text + '                <fill>0</fill>\n'
        kml_text = kml_text + '            </PolyStyle>\n'
        kml_text = kml_text + '        </Style>\n'
        k = 0
        for line in open(log_name, 'r'):
            dat = line.replace((u'\n'), '').replace((u'\r'), '').split(',')
            if dat[11] != '':
                name = str(dat[11])
            else:
                name = str(dat[0])
            bb = str(dat[1])
            ll = str(dat[2])
            hh = str(dat[3])
            epsg = str(dat[5])
            xx = str(dat[6])
            yy = str(dat[7])
            point_text = point_text + '        <Placemark>\n'
            point_text = point_text + '          <name>' + name + '</name>\n'
            point_text = point_text + '          <description><![CDATA[<div>' + epsg + '</div><div>X= ' + xx + '</div><div>Y= ' + yy + '</div><div>H= ' + hh + '</div>]]></description>\n'
            point_text = point_text + '          <Point>\n'
            point_text = point_text + '              <coordinates>' + ll + ',' + bb + ',' + hh + '</coordinates>\n'
            point_text = point_text + '          </Point>\n'
            point_text = point_text + '        </Placemark>\n'
            point = ll + ',' + bb + ',' + hh + ' '
            if k == 0:
                rosen_text = rosen_text + '        <Placemark>\n'
                rosen_text = rosen_text + '            <name>track</name>\n'
                rosen_text = rosen_text + '            <description>track</description>\n'
                rosen_text = rosen_text + '            <styleUrl>#my_line</styleUrl>\n'
                rosen_text = rosen_text + '            <LineString>\n'
                rosen_text = rosen_text + '                <tessellate>1</tessellate>\n'
                rosen_text = rosen_text + '                <altitudeMode>relativeToGround</altitudeMode>\n'
                rosen_text = rosen_text + '                    <coordinates>\n'
                coordinates = '                            ' + point
                k = 1
            else:
                coordinates = coordinates + point
        rosen_text = rosen_text + coordinates +'\n'
        rosen_text = rosen_text + '                    </coordinates>\n'
        rosen_text = rosen_text + '            </LineString>\n'
        rosen_text = rosen_text + '        </Placemark>\n'
        kml_text = kml_text + rosen_text + point_text
        kml_text = kml_text + '    </Document>\n'
        kml_text = kml_text + '</kml>\n'
        if sys.platform == "win32":
            kmlname = kmlname + u'.kml'
        with open(kmlname, "w") as f:
            f.write(kml_text)
        QMessageBox.information(self, u'KML保存', kmlname + u'を作成しました。')

    # 消去
    def clearlog(self):
        kakunin = QMessageBox.question(self,u'消去', u'ログが消去されます。\n実行してもよろしいですか？',QMessageBox.Yes | QMessageBox.No,QMessageBox.No)
        if kakunin == QMessageBox.Yes:
            self.textLog.clear()
            self.x1.clear()
            self.y1.clear()
            self.a.clear()
            self.d.clear()
            self.label_x.clear()
            self.label_y.clear()
            self.label_h.clear()
            self.label_ratio.clear()
            self.label_x2.setText('')
            self.label_y2.setText('')
            self.label_h2.setText('')
            self.check2.setChecked(False)

    # 接続・切断
    def on_off3(self, checked):
        self.stop_event = threading.Event()
        self.inc_event = threading.Event()
        if self.comboBox_sentence.currentText() != 'TCP_FIX' and self.comboBox_sentence.currentText() != 'TCP_ALL' and self.comboBox_sentence.currentText() != 'TCP_RATIO':
            self.thread = threading.Thread(target = self.get_log)
        else:
            self.thread = threading.Thread(target = self.get_log2)
        if checked:
            if self.check2.isChecked():
                if self.x1.text() == '':
                    QMessageBox.information(self, u'エラー', u'探索する測点のX座標を設定してください。')
                    self.switch_on2.setChecked(False)
                    return
                if self.y1.text() == '':
                    QMessageBox.information(self, u'エラー', u'探索する測点のY座標を設定してください。')
                    self.switch_on2.setChecked(False)
                    return
            if self.textLog.toPlainText() != '':
                kakunin = QMessageBox.question(self,u'受信', u'取得済みのログは消去されます。\n実行してもよろしいですか？',QMessageBox.Yes | QMessageBox.No,QMessageBox.No)
                if kakunin == QMessageBox.No:
                    self.switch_on2.setChecked(False)
                    return
            self.switch_on2.setText(u'切断')
            self.kei.setEnabled(False)
            self.comboBox_port.setEnabled(False)
            self.comboBox_baudrate.setEnabled(False)
            self.comboBox_sentence.setEnabled(False)
            self.SIMA.setEnabled(False)
            self.KML.setEnabled(False)
            self.GPX.setEnabled(False)
            self.clear_log.setEnabled(False)
            self.kei.setEnabled(False)
            self.groupBox_time.setEnabled(False)
            self.textLog.clear()
            self.label_x.clear()
            self.label_y.clear()
            self.label_h.clear()
            self.label_ratio.clear()
            if self.comboBox_sentence.currentText() == 'NMEA':
                self.textLog.append(u'NMEA記録中')
            self.thread.start()
            return
        else:
            self.switch_on2.setText(u'受信開始')
            self.kei.setEnabled(True)
            self.comboBox_port.setEnabled(True)
            self.comboBox_baudrate.setEnabled(True)
            self.comboBox_sentence.setEnabled(True)
            self.SIMA.setEnabled(True)
            self.KML.setEnabled(True)
            self.GPX.setEnabled(True)
            self.clear_log.setEnabled(True)
            self.kei.setEnabled(True)
            self.groupBox_time.setEnabled(True)
            self.epoch.setChecked(False)
            self.epoch.setText(u'開始')
            if self.comboBox_sentence.currentText() == 'NMEA':
                self.textLog.clear()
            self.stop_event.set()

    def stop(self):
        self.stop_event.set()
        self.thread.join()

    # 受信
    def get_log(self):
        epsg2 = self.kei.currentText().split(u':')
        EPSG1 = 'EPSG:4326'
        EPSG2 = 'EPSG:' + str(epsg2[1])

        if sys.platform == "win32":
            ser = serial.Serial(
                port=str(self.comboBox_port.currentText()),
                baudrate=int(self.comboBox_baudrate.currentText()),
                bytesize=8,
                parity='N',
                stopbits=1,
                timeout=1)#,
                #xonxoff=0,
                #rtscts=0,
                #writeTimeout=None,
                #dsrdtr=None)
        else:
            ser = serial.Serial(
                port='/dev/' + str(self.comboBox_port.currentText()),\
                baudrate=int(self.comboBox_baudrate.currentText()),\
                parity=serial.PARITY_NONE,\
                stopbits=serial.STOPBITS_ONE,\
                bytesize=serial.EIGHTBITS,\
                timeout=1)

        def degrees_to_decimal(data, hemisphere):
            try:
                decimalPointPosition = data.index('.')
                degrees = float(data[:decimalPointPosition-2])
                minutes = float(data[decimalPointPosition-2:])/60
                output = degrees + minutes
                if hemisphere == 'N' or hemisphere == 'E':
                    return output
                if hemisphere == 'S' or hemisphere == 'W':
                    return -output
            except:
                return ""

        def parse_GNRMC(data):
            data = data.split(',')
            dict = {
                    'fix_time': data[1],
                    'Status': data[2],
                    'latitude': data[3],
                    'NothingIndicator': data[4],
                    'longitude': data[5],
                    'EastingIndicator': data[6],
                    'speed': data[7],
                    'true_course': data[8],
                    'fix_date': data[9],
                    'variation': data[10],
                    'variation_e_w': data[11],
                    'checksum': data[12]
            }
            dict['decimal_latitude'] = degrees_to_decimal(dict['latitude'], dict['NothingIndicator'])
            dict['decimal_longitude'] = degrees_to_decimal(dict['longitude'], dict['EastingIndicator'])
            return dict

        def parse_GNGGA(data):
            data = data.split(',')
            dict = {
                    'fix_time': data[1],
                    'latitude': data[2],
                    'NothingIndicator': data[3],
                    'longitude': data[4],
                    'EastingIndicator': data[5],
                    'Status': data[6],
                    'SVsUsed': data[7],
                    'HDOP': data[8],
                    'altitude': data[9],
                    'unit1': data[10],
                    'geoid': data[11],
                    'unit2': data[12],
                    'dgps': data[13],
                    'checksum': data[14]
            }
            dict['decimal_latitude'] = degrees_to_decimal(dict['latitude'], dict['NothingIndicator'])
            dict['decimal_longitude'] = degrees_to_decimal(dict['longitude'], dict['EastingIndicator'])
            return dict

        def parse_GNGLL(data):
            data = data.split(',')
            dict = {
                    'latitude': data[1],
                    'NothingIndicator': data[2],
                    'longitude': data[3],
                    'EastingIndicator': data[4],
                    'fix_time': data[5],
                    'Status': data[6],
                    'ModeIndicator': data[7]
            }
            dict['decimal_latitude'] = degrees_to_decimal(dict['latitude'], dict['NothingIndicator'])
            dict['decimal_longitude'] = degrees_to_decimal(dict['longitude'], dict['EastingIndicator'])
            return dict

        firstFixFlag = False

        global daytime
        global b
        global l
        global x1
        global y1
        global x2
        global y2
        x0 = 999999
        y0 = 999999

        startTime = str(datetime.datetime.today())[0:10].replace('-', '') + str(datetime.datetime.today())[11:19].replace(':' or '-', '')
        if self.comboBox_sentence.currentText() == 'GNRMC/GPRMC':
            while not self.stop_event.is_set():
                line = ser.readline().decode('utf-8', 'ignore')
                if '$GNRMC' in line or '$GPRMC' in line:
                    if '$GNRMC' in line:
                        gn = line.split('$GNRMC')
                        line = '$GNRMC' + gn[1]
                        log_name = 'GNRMC'
                    else:
                        gn = line.split('$GPRMC')
                        line = '$GPRMC' + gn[1]
                        log_name = 'GPRMC'
                    gpsData = parse_GNRMC(line)
                    if gpsData['Status'] == 'A':
                        if firstFixFlag is False:
                            firstFixFlag = True
                        else:
                            day_time = datetime.datetime.today()
                            if self.radioButton_time1.isChecked():
                                daytime = str(datetime.datetime.today())[0:19].replace('-', '').replace(':', '').replace(' ', '')
                            else:
                                daytime = str(gpsData['fix_date']) + str(gpsData['fix_time'])
                            b = '{:.9f}'.format(round(float(gpsData['decimal_latitude']), 9))
                            l = '{:.9f}'.format(round(float(gpsData['decimal_longitude']), 9))
                            h = ''
                            g = ''
                            transformer = pyproj.Transformer.from_crs(EPSG1, EPSG2, always_xy=True)
                            y1, x1 = transformer.transform(float(l), float(b))
                            x01 = '{:.7f}'.format(round(x1, 7))
                            y01 = '{:.7f}'.format(round(y1, 7))

                            log_line = daytime + ',' + b + ',' + l + ',' + h + ',' + g + u",EPSG:" + str(epsg2[1]) + ',' + x01 + ',' + y01 + u',,,,,'
                            self.textLog.append(log_line)
                            try:
                                self.label_time.setText(daytime)
                                self.label_x.setText(str(round(x1,3)))
                                self.label_y.setText(str(round(y1,3)))
                            except:
                                pass
                            if self.check2.isChecked():
                                self.tansaku()
                            with open(os.path.dirname(__file__) + '/log/' + startTime + u'_' + log_name + u".log", "a") as myfile:
                                myfile.write(log_line + '\n')
            ser.close()

        elif self.comboBox_sentence.currentText() == 'GNGGA/GPGGA':

            while not self.stop_event.is_set():
                line = ser.readline().decode('utf-8', 'ignore')
                if '$GNGGA' in line or '$GPGGA' in line:
                    if '$GNGGA' in line:
                        gn = line.split('$GNGGA')
                        line = '$GNGGA' + gn[1]
                        log_name = 'GNGGA'
                    else:
                        gn = line.split('$GPGGA')
                        line = '$GPGGA' + gn[1]
                        log_name = 'GPGGA'
                    gpsData = parse_GNGGA(line)
                    if gpsData['Status'] == '1' or gpsData['Status'] == '2' or gpsData['Status'] == '4' or gpsData['Status'] == '5':
                        if firstFixFlag is False:
                            firstFixFlag = True
                        else:
                            day_time = datetime.datetime.today()
                            if self.radioButton_time1.isChecked():
                                daytime = str(datetime.datetime.today())[0:19].replace('-', '').replace(':', '').replace(' ', '')
                            else:
                                daytime = str(gpsData['fix_time'])
                            b = '{:.9f}'.format(round(float(gpsData['decimal_latitude']), 9))
                            l = '{:.9f}'.format(round(float(gpsData['decimal_longitude']), 9))
                            h = str(gpsData['altitude'])
                            g = str(gpsData['geoid'])
                            transformer = pyproj.Transformer.from_crs(EPSG1, EPSG2, always_xy=True)
                            y1, x1 = transformer.transform(float(l), float(b))
                            x01 = '{:.7f}'.format(round(x1, 7))
                            y01 = '{:.7f}'.format(round(y1, 7))

                            log_line = daytime + ',' + b + ',' + l + ',' + h + ',' + g + u",EPSG:" + str(epsg2[1]) + ',' + x01 + ',' + y01 + u',,,,,'
                            self.textLog.append(log_line)
                            try:
                                self.label_time.setText(daytime)
                                self.label_x.setText('{:.3f}'.format(round(x1, 3)))
                                self.label_y.setText('{:.3f}'.format(round(y1, 3)))
                                self.label_h.setText(h)
                            except:
                                pass
                            if self.check2.isChecked():
                                self.tansaku()
                            with open(os.path.dirname(__file__) + '/log/' + startTime + u'_' + log_name + u".log", "a") as myfile:
                                myfile.write(log_line + '\n')
            ser.close()

        elif self.comboBox_sentence.currentText() == 'GNGLL/GPGLL':

            while not self.stop_event.is_set():
                line = ser.readline().decode('utf-8', 'ignore')
                if '$GNGLL' in line or '$GPGLL' in line:
                    if '$GNGLL' in line:
                        gn = line.split('$GNGLL')
                        line = '$GNGLL' + gn[1]
                        log_name = 'GNGLL'
                    else:
                        gn = line.split('$GPGLL')
                        line = '$GPGLL' + gn[1]
                        log_name = 'GPGLL'
                    gpsData = parse_GNGLL(line)
                    if gpsData['Status'] == 'A':
                        if firstFixFlag is False:
                            firstFixFlag = True
                        else:
                            day_time = datetime.datetime.today()
                            if self.radioButton_time1.isChecked():
                                daytime = str(datetime.datetime.today())[0:19].replace('-', '').replace(':', '').replace(' ', '')
                            else:
                                daytime = str(gpsData['fix_time'])
                            b = '{:.9f}'.format(round(float(gpsData['decimal_latitude']), 9))
                            l = '{:.9f}'.format(round(float(gpsData['decimal_longitude']), 9))
                            h = ''
                            g = ''
                            transformer = pyproj.Transformer.from_crs(EPSG1, EPSG2, always_xy=True)
                            y1, x1 = transformer.transform(float(l), float(b))
                            x01 = '{:.7f}'.format(round(x1, 7))
                            y01 = '{:.7f}'.format(round(y1, 7))

                            log_line = daytime + ',' + b + ',' + l + ',' + h + ',' + g + u",EPSG:" + str(epsg2[1]) + ',' + x01 + ',' + y01 + u',,,,,'
                            self.textLog.append(log_line)
                            try:
                                self.label_time.setText(daytime)
                                self.label_x.setText('{:.3f}'.format(round(x1, 3)))
                                self.label_y.setText('{:.3f}'.format(round(y1, 3)))
                            except:
                                pass
                            if self.check2.isChecked():
                                self.tansaku()
                            with open(os.path.dirname(__file__) + '/log/' + startTime + u'_' + log_name + u".log", "a") as myfile:
                                myfile.write(log_line + '\n')
            ser.close()

        elif self.comboBox_sentence.currentText() == 'NMEA':
            while not self.stop_event.is_set():
                line = ser.readline().decode('utf-8', 'ignore')
                if line[0:1] == '$' or line[0:1] == 'µ':
                    if '$GNRMC' in line:
                        gn = line.split('$GNRMC')
                        line = '$GNRMC' + gn[1]
                    if '$GNGGA' in line:
                        gn = line.split('$GNGGA')
                        line = '$GNGGA' + gn[1]
                    if '$GNGLL' in line:
                        gn = line.split('$GNGLL')
                        line = '$GNGLL' + gn[1]
                    if '$GPRMC' in line:
                        gn = line.split('$GPRMC')
                        line = '$GPRMC' + gn[1]
                    if '$GPGGA' in line:
                        gn = line.split('$GPGGA')
                        line = '$GPGGA' + gn[1]
                    if '$GPGLL' in line:
                        gn = line.split('$GPGLL')
                        line = '$GPGLL' + gn[1]
                if line[0:1] == '$':
                    line = str(line).replace('\r\n', '')
                    #self.textLog.append(line)
                    with open(os.path.dirname(__file__) + '/log/' + startTime + u"_NMEA.log", "a") as myfile:
                        myfile.write(line + '\n')
            ser.close()
        else:
            log_name = self.comboBox_sentence.currentText()
            n = 0
            x001 = 0
            y001 = 0
            h001 = 0

            while not self.stop_event.is_set():
                try:
                    line = ser.readline().decode('utf-8', 'ignore')
                    line = re.sub(r"\s+", ",", line).replace('\r\n', '')
                    if line != '':
                        dat = line.split(',')
                        if (self.comboBox_sentence.currentText() == 'RTKNAVI_FIX' and dat[5] == '1') or (self.comboBox_sentence.currentText() == 'RTKNAVI_ALL' and (dat[5] == '1' or dat[5] == '2')) or (self.comboBox_sentence.currentText() == 'RTKNAVI_RATIO' and float(dat[14]) >= float(self.lineEdit_Ratio.text())):
                            day_time = datetime.datetime.today()
                            if self.radioButton_time1.isChecked():
                                daytime = str(datetime.datetime.today())[0:19].replace('-', '').replace(':', '').replace(' ', '')
                            else:
                                daytime = dat[1].replace(':', '')
                            b = '{:.9f}'.format(round(float(dat[2]), 9))
                            l = '{:.9f}'.format(round(float(dat[3]), 9))
                            h = '{:.3f}'.format(round(float(dat[4]), 3))
                            g = ''
                            if float(b) != 0 and float(l) != 0:
                                # 世界測地系(JGD2011）に変換
                                transformer = pyproj.Transformer.from_crs(EPSG1, EPSG2, always_xy=True)
                                y1, x1 = transformer.transform(float(l), float(b))
                                x01 = '{:.7f}'.format(round(x1, 7))
                                y01 = '{:.7f}'.format(round(y1, 7))

                                log_line = daytime + ',' + b + ',' + l + ',' + h + ',' + g + u",EPSG:" + str(epsg2[1]) + ',' + x01 + ',' + y01 + u',,,,,'
                                if not self.epoch.isChecked():
                                    n = 0
                                    x001 = 0
                                    y001 = 0
                                    h001 = 0
                                ep = int(self.lineEdit_epoch.text())
                                if self.epoch.isChecked() and n != ep:
                                    x001 = x001 + x1
                                    y001 = y001 + y1
                                    h001 = h001 + float(h)
                                    n = n + 1
                                    self.epoch.setText(str(n))
                                elif n == ep:
                                    x001 = x001 / ep
                                    y001 = y001 / ep
                                    h001 = h001 / ep
                                    transformer = pyproj.Transformer.from_crs(EPSG2, EPSG1, always_xy=True)
                                    y3, x3 = transformer.transform(y001, x001)
                                    self.epoch.setChecked(False)
                                    self.label_x2.setText(str('{:.3f}'.format(round(x001, 3))))
                                    self.label_y2.setText(str('{:.3f}'.format(round(y001, 3))))
                                    self.label_h2.setText(str('{:.3f}'.format(round(h001, 3))))
                                    self.epoch.setText(u'開始')
                                    n = 0
                                    x001 = 0
                                    y001 = 0
                                    h001 = 0
                                    d = datetime.datetime.today()
                                    daystr = d.strftime("%Y%m%d")
                                    csvname = os.path.dirname(__file__) + '/log/' + daystr + '.csv'
                                    pn = self.lineEdit_pn.text()
                                    csvtext = daytime + ',' + str(x3) + ',' + str(y3) + ',' + self.label_h2.text() + ',,' + str(epsg2[1]) + ',' + self.label_x2.text() + ',' + self.label_y2.text() + ',,,,' + pn + ',\n'
                                    fname = codecs.open(csvname, 'a', 'shift-jis')
                                    fname.write(csvtext)
                                    fname.close()
                                    #self.lineEdit_pn.setFocus()
                                if self.check2.isChecked():
                                    self.tansaku()
                                try:
                                    self.label_time.setText(daytime)
                                    self.label_x.setText(str('{:.3f}'.format(round(x1, 3))))
                                    self.label_y.setText(str('{:.3f}'.format(round(y1, 3))))
                                    self.label_h.setText(h)
                                    self.label_ratio.setText(dat[14])
                                except:
                                    pass
                                self.textLog.append(log_line)
                                with open(os.path.dirname(__file__) + "/log/" + startTime + u"_" + log_name + u".log", "a") as myfile:
                                    myfile.write(log_line + '\n')
                                with open(os.path.dirname(__file__) + "/log/" + startTime + u"_" + log_name + u".pos", "a") as myfile:
                                    myfile.write(line + '\n')
                except:
                    pass
            ser.close()

    def get_log2(self):
        epsg2 = self.kei.currentText().split(u':')
        EPSG1 = 'epsg:4326'
        EPSG2 = 'epsg:' + str(epsg2[1])
        global daytime
        global b
        global l
        global x1
        global y1
        global x2
        global y2
        global x3
        global y3
        x0 = 999999
        y0 = 999999
        log_name = self.comboBox_sentence.currentText()
        n = 0
        x001 = 0
        y001 = 0
        h001 = 0
        startTime = str(datetime.datetime.today())[0:10].replace('-', '') + str(datetime.datetime.today())[11:19].replace(':' or '-', '')
        host = 'localhost'
        port = 52001
        bufsize = 4096
        sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        with closing(sock):
            sock.connect((host, port))
            while not self.stop_event.is_set():
                try:
                    line = sock.recv(bufsize).decode('utf-8', 'ignore')
                    line = re.sub(r"\s+", ",", line).replace('\r\n', '')
                    if line != ',':
                        dat = line.split(',')
                        if (self.comboBox_sentence.currentText() == 'TCP_FIX' and dat[5] == '1') or (self.comboBox_sentence.currentText() == 'TCP_ALL' and (dat[5] == '1' or dat[5] == '2')) or (self.comboBox_sentence.currentText() == 'TCP_RATIO' and float(dat[14]) >= float(self.lineEdit_Ratio.text())):
                            day_time = datetime.datetime.today()
                            if self.radioButton_time1.isChecked():
                                daytime = str(datetime.datetime.today())[0:19].replace('-', '').replace(':', '').replace(' ', '')
                            else:
                                daytime = dat[1].replace(':', '')
                            b = '{:.9f}'.format(round(float(dat[2]), 9))
                            l = '{:.9f}'.format(round(float(dat[3]), 9))
                            h = '{:.3f}'.format(round(float(dat[4]), 3))
                            g = ''
                            if float(b) != 0 and float(l) != 0:
                                # 世界測地系(JGD2011）に変換
                                transformer = pyproj.Transformer.from_crs(EPSG1, EPSG2, always_xy=True)
                                y1, x1 = transformer.transform(float(l), float(b))
                                x01 = '{:.7f}'.format(round(x1, 7))
                                y01 = '{:.7f}'.format(round(y1, 7))
                                log_line = daytime + ',' + b + ',' + l + ',' + h + ',' + g + u",EPSG:" + str(epsg2[1]) + ',' + x01 + ',' + y01 + u',,,,,'
                                if not self.epoch.isChecked():
                                    n = 0
                                    x001 = 0
                                    y001 = 0
                                    h001 = 0
                                ep = int(self.lineEdit_epoch.text())
                                if self.epoch.isChecked() and n != ep:
                                    x001 = x001 + x1
                                    y001 = y001 + y1
                                    h001 = h001 + float(h)
                                    n = n + 1
                                    self.epoch.setText(str(n))
                                elif n == ep:
                                    x001 = x001 / ep
                                    y001 = y001 / ep
                                    h001 = h001 / ep
                                    transformer = pyproj.Transformer.from_crs(EPSG2, EPSG1, always_xy=True)
                                    y3, x3 = transformer.transform(y001, x001)
                                    self.epoch.setChecked(False)
                                    self.label_x2.setText(str('{:.3f}'.format(round(x001, 3))))
                                    self.label_y2.setText(str('{:.3f}'.format(round(y001, 3))))
                                    self.label_h2.setText(str('{:.3f}'.format(round(h001, 3))))
                                    self.epoch.setText(u'開始')
                                    n = 0
                                    x001 = 0
                                    y001 = 0
                                    h001 = 0
                                    d = datetime.datetime.today()
                                    daystr = d.strftime("%Y%m%d")
                                    csvname = os.path.dirname(__file__) + '/log/' + daystr + '.csv'
                                    pn = self.lineEdit_pn.text()
                                    csvtext = daytime + ',' + str(x3) + ',' + str(y3) + ',' + self.label_h2.text() + ',,' + str(epsg2[1]) + ',' + self.label_x2.text() + ',' + self.label_y2.text() + ',,,,' + pn + ',\n'
                                    fname = codecs.open(csvname, 'a', 'shift-jis')
                                    fname.write(csvtext)
                                    fname.close()

                                    # leaflet出力
                                    if self.check_leaflet.isChecked():
                                        self.leaflet()

                                if self.check2.isChecked():
                                    self.tansaku()
                                try:
                                    self.label_time.setText(daytime)
                                    self.label_x.setText(str('{:.3f}'.format(round(x1, 3))))
                                    self.label_y.setText(str('{:.3f}'.format(round(y1, 3))))
                                    self.label_h.setText(h)
                                    self.label_ratio.setText(dat[14])
                                except:
                                    pass
                                self.textLog.append(log_line)
                                with open(os.path.dirname(__file__) + "/log/" + startTime + u"_" + log_name + u".log", "a") as myfile:
                                    myfile.write(log_line + '\n')
                                with open(os.path.dirname(__file__) + "/log/" + startTime + u"_" + log_name + u".pos", "a") as myfile:
                                    myfile.write(line + '\n')
                except:
                    pass
        sock.close()

    # leaflet
    def leaflet(self):
        htmltext = ''
        htmlname = os.path.dirname(__file__) + '/leaflet.html'
        for line in codecs.open(htmlname, 'r', 'utf-8'):
            if '    B1 =' in line:
                line = '    B1 = ' + str(x3) + ';\n'
            elif '    L1 =' in line:
                line = '    L1 = ' + str(y3) + ';\n'
            elif '    X1 =' in line:
                line = '    X1 = ' + '"' + self.label_x2.text() + '"' + ';\n'
            elif '    Y1 =' in line:
                line = '    Y1 = ' + '"' + self.label_y2.text() + '"' + ';\n'
            elif '    H1 =' in line:
                line = '    H1 = ' + '"' + self.label_h2.text() + '"' + ';\n'
            htmltext = htmltext + line
        #htmlname.close()
        fname = codecs.open(htmlname, 'w', 'utf-8')
        fname.write(htmltext)
        fname.close()
        uri = 'file:///' + htmlname
        webbrowser.open_new_tab(uri)

    # 測点探索
    def tansaku(self):
        if self.check2.isChecked():
            x2 = round(float(self.x1.text()), 3)
            y2 = round(float(self.y1.text()), 3)
            dx = x2 - x1
            dy = y2 - y1
            #点間距離
            s = math.sqrt(dx ** 2 + dy ** 2)
            self.d.setText('{:.3f}'.format(round(s, 3)))
            #方向角
            RAD = 3.14159265358979 / 180
            pi = math.atan2(1, 1) * 4;
            if dx == 0:
                if dy == 0:
                    a = 0
                elif dy > 0:
                    a = pi / 2
                elif dy < 0:
                    a = pi * 3 / 2
            elif dx != 0:
                ha = math.atan2(math.fabs(dy), math.fabs(dx))
                if dx > 0:
                    if dy >= 0:
                        a = ha
                    if dy <  0:
                        a = 2 * pi - ha
                if dx < 0:
                    if dy >= 0:
                        a = pi - ha
                    if dy <  0:
                        a = pi + ha
            if a >= 2 * pi:
                a = a - 2 * pi
            dd = a / RAD;
            self.a.setText('{:.9f}'.format(round(dd, 9)))
            return

    # SIMAファイル読込
    def open_sima(self):
        sima_name = tkFileDialog.askopenfilename(filetypes = [(u'SIMAファイル','*.sim')], initialdir = "") 
        if not sima_name:
            return
        self.listWidget.clear()
        for line in codecs.open(sima_name, 'r', 'shift-jis'):
            dat = re.sub(r" +", "", line.replace(u'\n', ''))
            if dat[0:4] == 'A01,':
                d = dat.split(',')
                pn = d[2]
                x = str('{:.3f}'.format(round(float(d[3]), 3)))
                y = str('{:.3f}'.format(round(float(d[4]), 3)))
                self.listWidget.addItem(pn + ',' + x + ',' + y)
        self.check2.setChecked(True)
        self.x1.setEnabled(True)
        self.y1.setEnabled(True)
        self.a.setEnabled(True)
        self.d.setEnabled(True)
        self.label_1.setEnabled(True)
        self.label_2.setEnabled(True)
        self.label_3.setEnabled(True)
        self.label_4.setEnabled(True)

    # リストクリック
    def itemClick(self,item):
        self.check2.setChecked(True)
        self.x1.setEnabled(True)
        self.y1.setEnabled(True)
        self.a.setEnabled(True)
        self.d.setEnabled(True)
        self.lineEdit_pn2.clear()
        self.x1.clear()
        self.y1.clear()
        self.a.clear()
        self.d.clear()
        self.label_1.setEnabled(True)
        self.label_2.setEnabled(True)
        self.label_3.setEnabled(True)
        self.label_4.setEnabled(True)
        dat = item.text().split(',')
        self.lineEdit_pn2.setText(dat[0])
        self.x1.setText(dat[1])
        self.y1.setText(dat[2])

    # 検索
    def knsk(self):
        if self.listWidget.count() == 0:
            return
        if self.lineEdit_pn2.text() == '':
            return
        self.x1.clear()
        self.y1.clear()
        self.a.clear()
        self.d.clear()
        for i in range(self.listWidget.count()):
            dat = self.listWidget.item(i).text().split(',')
            if dat[0] == self.lineEdit_pn2.text():
                self.check2.setChecked(True)
                self.x1.setEnabled(True)
                self.y1.setEnabled(True)
                self.a.setEnabled(True)
                self.d.setEnabled(True)
                self.label_1.setEnabled(True)
                self.label_2.setEnabled(True)
                self.label_3.setEnabled(True)
                self.label_4.setEnabled(True)
                self.x1.setText(dat[1])
                self.y1.setText(dat[2])


# Setting---------------------------------------------------------------------------------------------------------------------------------------------------------------------
    # RTKLIB のインストール
    def rtklib_install(self):
        data_dir_path = "../RTKLIB"
        if os.path.exists(data_dir_path):
            shutil.rmtree(data_dir_path)
        file_url = self.lineEdit_URL.text()
        save_path = "../RTKLIB.zip"
        zippath = file_url.split('/')
        oldpath = zippath[8].replace('.zip','')
        try:
            with urllib.request.urlopen(file_url) as download_file:
                data = download_file.read()
                with open(save_path, mode='wb') as save_file:
                    save_file.write(data)
        except urllib.error.URLError as e:
            print(e)
        with zipfile.ZipFile("../RTKLIB.zip") as obj_zip:
            obj_zip.extractall("../")
        newpath = '../RTKLIB'
        os.rename('../' + oldpath, newpath)
        if os.path.exists(save_path):
            os.remove(save_path)

        shname = os.path.dirname(__file__) + '/rtklib_install.sh'
        if os.path.exists(shname):
            os.remove(shname)

        osp = os.path.dirname(__file__).split('/')
        if os.path.isdir('/home/' + osp[2] + '/RTKLIB/app/consapp/'):
            makefile_path = '/home/' + osp[2] + '/RTKLIB/app/consapp/'
        else:
            makefile_path = '/home/' + osp[2] + '/RTKLIB/app/'
        self.lineEdit_makefile_path.setText(makefile_path)
        
        str2str_path = makefile_path + 'str2str/gcc/'
        self.lineEdit_str2str_path.setText(str2str_path)
        rtkstart_path = makefile_path + 'rtkrcv/gcc/rtkstart.sh'
        self.lineEdit_rtkstart_path.setText(rtkstart_path)
        rtkshut_path = makefile_path + 'rtkrcv/gcc/rtkshut.sh'
        self.lineEdit_rtkshut_path.setText(rtkshut_path)
        rtkrcv_path = makefile_path + 'rtkrcv/gcc/'
        self.lineEdit_rtkrcv_path.setText(rtkrcv_path)
        conf_path = makefile_path + 'rtkrcv/conf/'
        self.lineEdit_conf_path.setText(conf_path) + 'rtk.conf'

        sh_text = 'cd ' + self.lineEdit_makefile_path.text() + '\n'
        sh_text = sh_text + 'make\n'
        sh_text = sh_text + 'chmod 755 ' + self.lineEdit_rtkstart_path.text() + '\n'
        sh_text = sh_text + 'chmod 755 ' + self.lineEdit_rtkshut_path.text() + '\n'

        fname = open(shname, 'w')
        fname.write(sh_text)
        fname.close()
        cmd = 'chmod 755 ' + os.path.dirname(__file__) + u'/rtklib_install.sh'
        subprocess.check_output(cmd,shell=True)
        cmd = 'lxterminal -e ' + os.path.dirname(__file__) + u'/rtklib_install.sh'
        subprocess.call(cmd,shell=True)

    # 起動用ファイルの作成
    def make_sh(self):
        osp = os.path.dirname(__file__).split('/')
        sh_text = '#!/bin/bash\n'
        sh_text = sh_text + 'python3 /home/' + osp[2] + '/RTK_TOOL3/RTK_TOOL3.py\n'
        try:
            shfile = u'/home/' + osp[2] + '/デスクトップ/RTK_TOOL3.sh'
            if os.path.exists(shfile):
                result = QMessageBox.question(self,u'上書き確認', shfile + u' は、既に存在します。\n上書きしてもよろしいですか？',QMessageBox.Yes | QMessageBox.No,QMessageBox.No)
                if result == QMessageBox.Yes:
                    with open(shfile, "w") as f:
                        f.write(sh_text)
                else:
                    return
            else:
                with open(shfile, "w") as f:
                    f.write(sh_text)
        except:
            shfile = u'/home/' + osp[2] + '/Desktop/RTK_TOOL3.sh'
            if os.path.exists(shfile):
                result = QMessageBox.question(self,u'上書き確認', shfile + u' は、既に存在します。\n上書きしてもよろしいですか？',QMessageBox.Yes | QMessageBox.No,QMessageBox.No)
                if result == QMessageBox.Yes:
                    with open(shfile, "w") as f:
                        f.write(sh_text)
                else:
                    return
            else:
                with open(shfile, "w") as f:
                    f.write(sh_text)
        cmd = 'chmod 755 ' + shfile
        subprocess.check_output(cmd,shell=True)
        QMessageBox.information(self, u'起動用ファイル', shfile + u'を作成しました。')

    # 起動用バッチファイル＆vbs作成
    def make_vbs(self):
        python_path = tkFileDialog.askopenfilename(filetypes = [(u'python.exe選択','python.exe')], initialdir = '')
        if not python_path:
            return
        batname = os.path.dirname(__file__) + '/run.bat'
        bat_text = '"' + python_path.replace('/', '\\') + '" "' + os.path.dirname(__file__) + u'\\RTK_TOOL3.py"'
        fname = open(batname, 'w')
        fname.write(bat_text)
        fname.close()
        vbsname = os.path.dirname(__file__) + '/RTK_TOOL3.vbs'
        vbs_text = 'Dim oShell\n'
        vbs_text = vbs_text + 'Set oShell = WScript.CreateObject (' + '"' + 'WSCript.shell' + '"' + ')\n'
        vbs_text = vbs_text + 'oShell.run ' +  '"' + batname.replace('/', '\\') + '"' + ',0\n'
        vbs_text = vbs_text + 'Set oShell = Nothing'
        fname = open(vbsname, 'w')
        fname.write(vbs_text)
        fname.close()

    # COMポート確認
    def check_com(self):
        #QMessageBox.information(self, u'COMポート確認', u'GNSSモジュールを接続して実行してください。\nターミナルウィンドウのタイトルバーにポート番号が表示されます。')
        QMessageBox.information(self, u'COMポート確認', u'COMポート番号を確認する場合は、\n1.デスクトップの「RTK_TOOL3.sh」を実行して\n「端末で実行する」をクリックしてください。\n（ターミナルウィンドウも同時に起動します。）\n2.GNSSモジュールを接続してください。\n3.ターミナルウィンドウに接続されているポートの\n最終番号が表示されます。')
        #cmd = 'lxterminal -e -c ls /dev/ttyA*;exec bash'
        cmd = 'ls -l /dev/serial/by-id/'
        subprocess.call(cmd,shell=True)


#------------------------------------------------------------------------------------------------------------------

if __name__ == '__main__':
    app = QApplication(sys.argv)
    win = Dialog()
    sys.exit(app.exec_())
